# import of libraries
import numpy as np
import time
import matplotlib.pyplot as plt

import Dynamics
import Matrices
import Output_Files
import Ansys_Scrape
import Forcing
import Added
import Animation





def Core_function (Total_time, time_step, segments, Length_segment, free_space_between_segments,
                   characteristics_small_floater, characteristics_large_floater, M_segment, J_segment,
                   z_location_bottom_floater, z_location_deck, width_deck, z_location_Super_Structure, z_location_turbines, Turbine_char,
                   Length_Pendulum, Angle_Pendulum, Angle_Pendulum_Mid_Tide, Pendulum_hinge_top_location, Diameter_pendulum,
                   Stiffness_Pendulum, Stiffness_Spudpole, Stiffness_connection_segment, Damping_Pendulum,
                   Damping_Spudpole, Damping_connection_segment, Wind_Distributed_Load_Deck,
                   Wind_Distributed_Load_Super_Structure, Traffic_load, Max_Turbine, C_drag_pointed_rectangle, C_drag_bottom_floater,
                   C_Added_Mass_Pointed_Tip_Reduction, C_Added_Mass_Not_Infinite_Factor, C_Marine_Growth_Extra, C_Damping_Pointed_Tip_Reduction, Tidal_level, flow_velocity,
                   Wave_hlp, depth, rho, g, gridsize, smooth_time, Three_Dimensional_Calculation, Wind_Deck_Force, Wind_Super_Structure_Force,
                   Wave_Force, Pendulum_Drag_Force, Current_Force, Turbine_Force, Traffic_Force, Constant_force, Smooth_Start, Approaching_Wave_Field, Show_plot,
                   Show_Tidal_Displacement_In_Plot, Make_Animation, Alternative_prints, HeatMapTestNumber, HeatMapRound, Integration_Of_Ansys_Aqwa_mass, Integration_Of_Ansys_Aqwa_damp,
                   Ansys_Aqwa_file_name, Ansys_char, ExperimentalAddition,Stiffness_lean_factor,showplotoverride, M_added_tur_hori, M_added_tur_vert,M_added_tur_rot,Turbine_dimensions_HWL, draught,
                   C_radiation_turbine_sway_reduction,C_inertia, Sway_Plate_Force, COG_to_surface, Sway_plate_char, Heave_Plate_Force, Heave_plate_char, 
                   Slosh_char, Slosh_Force, Slosh_Force_test, loopname, Sway_Plate_Force_Design3, M_added_sway_plateD3):

    """"
    # Function:
    # This function mis the core of everything that this model does. From all the settings,
    # it computes the dynamic behaviour of a tidal bridge.
    
    # Input:
    # Total_Time								= Total time that is simulated by the model					(1)
    # Smallest_Period_Devider					= Ratio between smallest eigen period and timestep			(1)
    # segments                          		= Number of segments in the bridge                      	(1)
    # Length_segment							= Length of a single segment								(1)
    # free_space_between_segments				= Free space between the small floaters between segments	(1)
    # characteristics_small_floater     		= Number of, width and length of small floaters         	(3)
    # characteristics_large_floater     		= Number of, width and length of large floaters         	(3)
    # M_segment                         		= Mass of a single segment                              	(1)
    # J_segment									= Rotational moment of inertia about x y and z-coordinate   (3)
    # z_location_bottom_floater         		= Z-coordinate of the bottom side of the floaters       	(1)
    # z_location_deck							= Z-coordinate of the middle deck							(1)
    # z_location_Super_Structure				= Z-coordinate of the middle of the super structure			(1)
    # z_location_turbines						= Z-coordinate of the middle of the turbines				(1)
    # Length_Pendulum							= List of lengths of pendulums								(2*segments-2)
    # Angle_Pendulum							= List of the angles of all pendulums						(2*segments-2)
    # Angle_Pendulum_Mid_Tide					= Angle of pendulums at mid tide							(1)
    # Pendulum_hinge_top_location				= Y- and z-coordinate of the top hing of pendulum       	(2)
    # Stiffness_Pendulum						= List of stiffnesses of pendulums							(2*segments-2)
    # Stiffness_Spudpole						= List of stiffnesses of the two spudpoles					(2)
    # Stiffness_connection_segment				= Stiffness of connecting elements							(1)
    # Damping_Pendulum							= List of dampers of pendulums								(2*segments-2)
    # Damping_Spudpole							= List of dampers of the two spudpoles						(2)
    # Damping_connection_segment				= Dampers of connecting elements							(1)
    # Wind_Distributed_Load_Deck				= Distributed load by the wind on the deck					(1)
    # Wind_Distributed_Load_Super_Structure		= Distributed load by the wind on the super structure		(1)
    # Max_Turbine								= Max turbine force and corrosponding flow velocity			(2)
    # C_drag_pointed_rectangle          		= Drag coefficient of a pointed rectangle               	(1)
    # C_drag_bottom_floater                     = Drag coefficient of vertical flow against floaters        (1)
    # C_Added_Mass_Pointed_Tip_Reduction		= Factor to add added mass reduction due to pointed tips	(1)
    # C_Added_Mass_Not_Infinite_Factor          = Factor to add fact that floaters have not infinite width  (1)
    # C_Marine_Growth_Extra						= Added mass coefficient to include marine growth			(1)
    # C_Damping_Pointed_Tip_Reduction			= Radiation damping reductino due to pointed tips
    # Tidal_level								= Tidal level to be evaluated								(1)
    # flow_velocity                     		= Flow velocity of the fluid                            	(1)
    # Wave_hlp									= Regular wave height, length and period					(3)
    # depth										= Local water depth											(1)
    # rho                               		= Density of the fluid                                  	(1)
    # g											= Gravetational acceleration								(1)
    # gridsize									= Gridsize for numerical computation of wave force			(1)
    # smooth_time								= Initial sinewave smoothing time							(1)
    # Three_Dimensional_Calculation				= Option to implement three dimensional calculation			(T/F)
    # Wind_Deck_Force							= Option to implement force by wind on deck					(T/F)
    # Wind_Super_Structure_Force				= Option to implement force by wind on super structure		(T/F)
    # Wave_Force								= Option to implement force by waves on floaters			(T/F)
    # Current_Force								= Option to implement force by current on floaters			(T/F)
    # Turbine_Force								= Option to implement force by current on turbines			(T/F)
    # Constant_force							= Option to implement horizontal test force					(T/F)
    # Smooth_Start								= Option to implement smoothing of forces first 10 seconds	(T/F)
    # Show_plot									= Option to enable plot popups								(T/F)
    # Show_Tidal_Displacement_In_Plot			= Option to implement tidal displacement in plot			(T/F)
    # Make_Animation							= Option to make animation of the 2D displacement 			(T/F)
    # Integration_Of_Ansys_Aqwa_mass			= Option to implement integration with Aqwa for added Mass	(T/F)
    # Integration_Of_Ansys_Aqwa_damp			= Option to implement integration with Aqwa for added Damp	(T/F)
    # Ansys_Aqwa_file_name						= File name which is used to scrape results from Aqwa		(str)
    # Ansys_char								= Charactreristics of flaoters, M and J in Aqwa model		(3x3)
    """

    # Recalculating position and angle of pendulum taking into account tidal level
    Angle_Pendulum_Initial_Tidal, Pendulum_hinge_bottom_location = Dynamics.Angle_At_Tide_Calculator(segments,
                                                            Length_Pendulum, Angle_Pendulum, Angle_Pendulum_Mid_Tide,
                                                            Pendulum_hinge_top_location, Tidal_level)

    ######################################################## MATRIX FORMATIONS #######################################################
    N_matrix = 3
    
    if Alternative_prints == False:
        print(">> Process started")
        print()
        print("> Basic matrix computation started")
        Test_Number = Output_Files.fcount()
    else:
        Test_Number = HeatMapTestNumber

    # Matrices without added mass or radiation damping, so frequency indepenedent.
    #Mass matrix
    M_matrix_basic = Matrices.Tidal_Bridge_M(segments, M_segment, J_segment, Three_Dimensional_Calculation)
    M_added_turbine = Added.Added_turbine(characteristics_large_floater, characteristics_small_floater, M_added_tur_hori, M_added_tur_vert, M_added_tur_rot,z_location_turbines)
    M_added_SwayPlate = Added.Added_SwayPlate(Sway_plate_char,Sway_Plate_Force, Sway_Plate_Force_Design3, M_added_sway_plateD3, draught)
    M_added_HeavePlate = Added.Added_HeavePlate(Heave_plate_char, Heave_Plate_Force)
    
    #Hydraulic stiffness for heave and roll for one single element
    K_matrix_water = Matrices.TB_Force_Water(segments, Length_segment, free_space_between_segments, characteristics_small_floater,characteristics_large_floater, rho, g, Three_Dimensional_Calculation)
    #Stiffness for heave due to the hydraulic stiffness of the adjacent element
    K_matrix_adjacent = Matrices.TB_Hydro_Force_Adjacent (Length_segment, free_space_between_segments, characteristics_small_floater, characteristics_large_floater, rho, g,Stiffness_lean_factor)
    #Stiffness due to the pendulum following Gerjan with some simplifications to calculate the natural frequencies
    K_matrix_pendulum_Gerjan = Matrices.TB_Spring_Matrix_variable(segments, Length_segment, free_space_between_segments,characteristics_small_floater,Angle_Pendulum, Pendulum_hinge_top_location, Stiffness_Pendulum,Three_Dimensional_Calculation) 
    #Results of the pendulum stiffness calculation with higher order 
    # K_matrix_pendulum_Wessel = [[1.17364818e+08, 9.84807753e+07, 1.48316189e+09],[9.84807753e+07, 8.26351822e+07, 1.24452059e+09],[1.48515173e+09, 1.24619027e+09, 1.87098890e+10]]
    # Combined K_matrix for natural frequency calculations
    K_matrix_natural = K_matrix_water + K_matrix_adjacent + K_matrix_pendulum_Gerjan

    # Added mass and radiation damping dicts from Ansys Aqwa
    if Integration_Of_Ansys_Aqwa_damp == True:
        Frequency_damping_dict = Ansys_Scrape.Damping_Ansys_Aqwa(Three_Dimensional_Calculation, Ansys_Aqwa_file_name)[0]
        Frequencies_list = Ansys_Scrape.Damping_Ansys_Aqwa(Three_Dimensional_Calculation, Ansys_Aqwa_file_name)[1]
    if Integration_Of_Ansys_Aqwa_mass == True:
        Frequency_Mass_dict = Ansys_Scrape.Mass_Ansys_Aqwa(Three_Dimensional_Calculation, Ansys_Aqwa_file_name)
        Frequencies_list = Ansys_Scrape.Damping_Ansys_Aqwa(Three_Dimensional_Calculation, Ansys_Aqwa_file_name)[1]


    # Natural frequency calculator, iterative method
    Frequency = 0.14  # just a guess
    for i in range(14):
        # Get added mass, from Ansys or fysica hand calcualtions
        if Integration_Of_Ansys_Aqwa_mass == True:
            M_added_floater = Added.Aqwa_Mass(segments, characteristics_small_floater, characteristics_large_floater, M_segment, C_Marine_Growth_Extra, rho, Frequency , Frequency_Mass_dict , Frequencies_list,  Three_Dimensional_Calculation, Ansys_char, Ansys_Aqwa_file_name)
        else:
            M_added_floater = Added.Fysica_Floater_Added_Mass(segments, Length_segment, free_space_between_segments, characteristics_small_floater,
                                                              characteristics_large_floater, M_segment, z_location_bottom_floater, C_Added_Mass_Pointed_Tip_Reduction,
                                                              C_Added_Mass_Not_Infinite_Factor, C_Marine_Growth_Extra, rho, Three_Dimensional_Calculation, Turbine_Force, ExperimentalAddition, draught)
        if Integration_Of_Ansys_Aqwa_damp == True:
            C__added_floater = Added.Aqwa_Damping(segments, Frequency, Frequency_damping_dict, Frequencies_list,Three_Dimensional_Calculation)
        else:
            C__added_floater = Added.Fysica_Damping(segments, M_segment, Length_segment, free_space_between_segments, characteristics_small_floater,
                                                  characteristics_large_floater, z_location_bottom_floater, C_Damping_Pointed_Tip_Reduction, Wave_hlp[2],
                                                  rho, g, Three_Dimensional_Calculation, ExperimentalAddition, draught)
            C__added_turbine = Added.Fysica_Turbine_Damping(Wave_hlp, rho, g, Turbine_dimensions_HWL, Turbine_char,C_radiation_turbine_sway_reduction)


        # Fix divide by zero
        for j in range (N_matrix):
            if K_matrix_natural[j, j] == 0:
                K_matrix_natural[j, j] = 0.00001
                print("Devide by zero")

        # Natural frequencies and periods
        Natural_Frequencies, Natural_Period = Dynamics.Natural(M_matrix_basic + M_added_floater + M_added_turbine + M_added_SwayPlate + M_added_HeavePlate, K_matrix_natural)
        Natural_Period_sort = np.sort(Natural_Period)

        # Most important frequency, being the largest period
        for j in range(len(Natural_Period_sort)):
            if Natural_Period_sort[-j-1] < 100:   #to forget about spring forces which are zero
                Frequency = 1 / Natural_Period_sort[-j-1]
                break


    # set added mass and damping for forcing frequency of waves
    if Wave_Force == True:
        if Integration_Of_Ansys_Aqwa_mass == True:
            M_added_floater = Added.Aqwa_Mass(segments, characteristics_small_floater, characteristics_large_floater, M_segment, C_Marine_Growth_Extra, rho, 1 / Wave_hlp[2] , Frequency_Mass_dict , Frequencies_list,  Three_Dimensional_Calculation, Ansys_char, Ansys_Aqwa_file_name)
        else:
            M_added_floater = Added.Fysica_Floater_Added_Mass(segments, Length_segment, free_space_between_segments, characteristics_small_floater,
                characteristics_large_floater, M_segment, z_location_bottom_floater, C_Added_Mass_Pointed_Tip_Reduction,
                C_Added_Mass_Not_Infinite_Factor, C_Marine_Growth_Extra, rho, Three_Dimensional_Calculation, Turbine_Force, ExperimentalAddition, draught)

        if Integration_Of_Ansys_Aqwa_damp == True:
            C__added_floater = Added.Aqwa_Damping(segments, 1 / Wave_hlp[2], Frequency_damping_dict, Frequencies_list,
                                                Three_Dimensional_Calculation)
        else:
            C__added_floater = Added.Fysica_Damping(segments, M_segment, Length_segment, free_space_between_segments, characteristics_small_floater, characteristics_large_floater,
                                                  z_location_bottom_floater, C_Damping_Pointed_Tip_Reduction, Wave_hlp[2], 
                                                  rho, g, Three_Dimensional_Calculation, ExperimentalAddition, draught)
            C__added_turbine = Added.Fysica_Turbine_Damping(Wave_hlp, rho, g, Turbine_dimensions_HWL, Turbine_char,C_radiation_turbine_sway_reduction)

    # damp_cof = [0, 0, 0.02]
    # C_matrix_rayleigh = np.zeros((3,3))    
    # for i in range(len(C_matrix_rayleigh)):
    #     C_matrix_rayleigh[i,i] = damp_cof[i]*(M_matrix_basic[i,i] + M_added_floater[i,i])+ damp_cof[i]*K_matrix_natural[i,i]

    # Determine damping ratio
    # C_critical = 2*(M_matrix_basic + M_matrix_added)*Natural_Frequencies
    # Damping_ratio = np.zeros((3,3))
    # for i in range(len(C_critical)):
    #     Damping_ratio[i,i]=C_matrix_added[i,i]/C_critical[i,i]
    # print(Damping_ratio)


    M_matrix = M_matrix_basic + M_added_floater + M_added_turbine + M_added_SwayPlate + M_added_HeavePlate
    C_matrix = C__added_floater + C__added_turbine # + C_matrix_rayleigh
    K_matrix_txt = K_matrix_natural
    K_matrix = K_matrix_water + K_matrix_adjacent
    
    # devide by zero errors fix
    for j in range (N_matrix):
        if K_matrix[j, j] == 0:
            K_matrix[j, j] = 0.00001

######################################################## END M-, C-, and K-MATRIX FORMATIONS #######################################################




    # Simulation steps and time, devided lowest period by >>1 to 'guarantee' stability
    steps = int(Total_time / time_step)
    Time = np.linspace(0, Total_time, steps + 1)

    # Make empty matrices for storages
    x_list = np.zeros((steps + 1, N_matrix))
    slosh_kin_list = np.zeros((steps + 1,6))
    xdot_list = np.zeros((steps + 1, N_matrix))
    xddot_list = np.zeros((steps, N_matrix))
    xddot_list_tot = np.zeros(steps)
    F_axial = np.zeros((steps+1,2*segments-2))
    F_save = np.zeros((steps, N_matrix))    
    F_save_p = np.zeros((steps, N_matrix))


    # Forcing, create list for every step and fill it with the different forces (Constant)
    F_constant = np.zeros((steps, N_matrix))
    if Constant_force == True:
        F_constant += Forcing.Constant(segments, steps, Three_Dimensional_Calculation)
    if Wind_Deck_Force == True:
        F_constant += Forcing.Wind_Deck (segments, steps, Length_segment, z_location_deck, Wind_Distributed_Load_Deck,
                                     Three_Dimensional_Calculation)
    if Wind_Super_Structure_Force == True:
        F_constant += Forcing.Wind_Super_Structure (segments, steps, Length_segment, z_location_Super_Structure,
                           Wind_Distributed_Load_Super_Structure, Three_Dimensional_Calculation)

    if Alternative_prints == False:
        print("> Basic matrix computation finished")
        print()
        print("> Dynamic calculation started")

    # Equation to make first ten second smooth, which removes jumpy behaviour at start and removing initial jump
    smooth_function_value = np.zeros(int(steps / Total_time * smooth_time))
    for i in range(int(steps / Total_time * smooth_time)):
        smooth_function_value[i] = 0.5 - 0.5 * np.cos(np.pi / len(smooth_function_value) * i)

    # Dynamic computation
    Start_Time = time.time()
    Acceleration_Override = False   
    

    def Updater (i, x_list, xdot_list, xddot_list, F_constant, segments, steps, Total_time, Length_segment, free_space_between_segments,characteristics_small_floater, Length_Pendulum, Pendulum_hinge_top_location,
                 Diameter_pendulum, Pendulum_hinge_bottom_location, Damping_Pendulum, Three_Dimensional_Calculation,characteristics_large_floater,M_segment, C_drag_pointed_rectangle, C_drag_bottom_floater,
                 Stiffness_Pendulum, z_location_bottom_floater, Tidal_level, flow_velocity, Wave_hlp, rho, depth, Current_Force, Wave_Force,
                 Approaching_Wave_Field,z_location_turbines, Max_Turbine, g, M_added_floater,Acceleration_Override, gridsize, Smooth_Start,smooth_function_value, N_matrix,COG_to_surface,
                 Sway_plate_char, Heave_plate_char, C_inertia, Slosh_char, Slosh_Force, slosh_kin_list,Slosh_Force_test, M_added_sway_plateD3):
        

  
        # Update angle of pendulum
        Angle_Pendulum = Dynamics.Angle(i, x_list, segments, Length_segment, free_space_between_segments,
                                        characteristics_small_floater, Pendulum_hinge_top_location,
                                        Pendulum_hinge_bottom_location, Three_Dimensional_Calculation)

        Pendulum_Force,F_axial = Forcing.Pendulum_Force(i,x_list,Angle_Pendulum,Pendulum_hinge_top_location,Stiffness_Pendulum)
        
        if Current_Force == True or Wave_Force == True:
             FloaterDrag_addition = Forcing.FloaterDrag(i, Total_time, x_list, xdot_list,segments, steps,characteristics_small_floater, characteristics_large_floater,
                                                        M_segment, C_drag_pointed_rectangle, C_drag_bottom_floater, z_location_bottom_floater, Tidal_level, flow_velocity,
                                                        Wave_hlp, rho, depth, Current_Force, Wave_Force, Three_Dimensional_Calculation, Approaching_Wave_Field)

        if Turbine_Force == True and Current_Force == True or Wave_Force == True:
            TurbineDrag_addition = Forcing.TurbineDrag(i, Total_time, x_list, xdot_list, steps, flow_velocity, Wave_hlp, rho, depth, Current_Force,
                                                       Wave_Force, Turbine_dimensions_HWL ,Turbine_char, draught,Tidal_level, z_location_bottom_floater, z_location_turbines)

        if Wave_Force == True:
            FloaterInertia_addition = Forcing.FloaterInertia(i, Total_time, x_list, steps, Length_segment, free_space_between_segments,
                                                              characteristics_small_floater, characteristics_large_floater, M_segment,
                                                              z_location_bottom_floater, Tidal_level, flow_velocity, Wave_hlp, depth, rho, g, M_added_floater,
                                                              gridsize, Current_Force, Approaching_Wave_Field, draught, C_inertia)
            
            TurbineInertia_addition = Forcing.TurbineInertia(i, x_list, Wave_hlp, Current_Force, depth, Tidal_level, draught, flow_velocity, M_added_tur_hori,
                                                             M_added_tur_vert, z_location_bottom_floater, rho, Total_time, steps,Turbine_dimensions_HWL, C_inertia)

         
        if Pendulum_Drag_Force == True:
            Pendulum_addition = Forcing.PendulumDrag(i, segments, steps, Length_segment, free_space_between_segments,
                                                     characteristics_small_floater, Length_Pendulum, Angle_Pendulum, Pendulum_hinge_top_location,
                                                     Diameter_pendulum, flow_velocity, rho, Three_Dimensional_Calculation)


        if Sway_Plate_Force == True:
            if Sway_Plate_Force_Design3 == True:
                SwayPlate_addition = Forcing.SwayPlateForcesD3(i, x_list, xdot_list, Wave_hlp, Current_Force, depth, Tidal_level, flow_velocity, rho, Total_time, 
                                                               steps, Turbine_dimensions_HWL, Wave_Force, COG_to_surface, Sway_plate_char, C_inertia, draught,
                                                               characteristics_large_floater, M_added_sway_plateD3)
            else:
                SwayPlate_addition = Forcing.SwayDoublePlateForces(i, x_list, xdot_list, Wave_hlp, Current_Force, depth, Tidal_level, flow_velocity, rho, Total_time, 
                                                                   steps, Turbine_dimensions_HWL, Wave_Force, COG_to_surface, Sway_plate_char, C_inertia, draught, characteristics_large_floater)
        else:
            SwayPlate_addition = np.zeros(N_matrix)
        
        if Heave_Plate_Force == True:
            HeavePlate_addition = Forcing.HeavePlateForces(i, x_list, xdot_list, Wave_hlp, Current_Force, depth, Tidal_level, flow_velocity, rho, Total_time, 
                                                           steps, Turbine_dimensions_HWL, Wave_Force, COG_to_surface, Heave_plate_char, C_inertia, characteristics_large_floater)
        else:
            HeavePlate_addition = np.zeros(N_matrix)
        
        if Slosh_Force == True:
            SloshDamper_addition, slosh_kin_list, E_matrix = Forcing.SloshDamper(i, x_list, xddot_list, rho, Total_time, steps, slosh_kin_list, Slosh_char, g, z_location_bottom_floater,Slosh_Force_test)
        else:
            SloshDamper_addition = np.zeros(N_matrix)
            E_matrix = np.zeros((N_matrix,N_matrix))
   
        if Slosh_Force_test == True:
            F_moment = np.zeros(3)
            F_moment[2]= 1*10**8
            
            Total_Force = (F_constant[i]
                           + FloaterDrag_addition[i]  
                           + TurbineDrag_addition[i]
                           + FloaterInertia_addition
                           + TurbineInertia_addition
                           + Pendulum_addition[i]
                           + SwayPlate_addition
                           + HeavePlate_addition
                           + SloshDamper_addition)
        else:
            Total_Force = (F_constant[i]
                           + FloaterDrag_addition[i]  
                           + TurbineDrag_addition[i]
                           + FloaterInertia_addition
                           + TurbineInertia_addition
                           + Pendulum_addition[i]
                           + SwayPlate_addition
                           + HeavePlate_addition
                           + SloshDamper_addition)

        
        # Smoothening
        if Smooth_Start == True:
            if i < int(steps / Total_time * smooth_time):
                Total_Force = Total_Force * smooth_function_value[i]
         
        Total_Force += Pendulum_Force

        return (Total_Force, Angle_Pendulum, F_axial, slosh_kin_list, E_matrix)
    
    for i in range(steps):
        
        if i==0:
            F_save[i,:], Angle_Pendulum, F_axial[i], slosh_kin_list, E_matrix = Updater(i, x_list, xdot_list, xddot_list, F_constant, segments, steps, Total_time, Length_segment, free_space_between_segments,characteristics_small_floater, Length_Pendulum, Pendulum_hinge_top_location,
                                                                        Diameter_pendulum, Pendulum_hinge_bottom_location, Damping_Pendulum, Three_Dimensional_Calculation,characteristics_large_floater,M_segment, C_drag_pointed_rectangle, C_drag_bottom_floater,
                                                                        Stiffness_Pendulum, z_location_bottom_floater, Tidal_level, flow_velocity, Wave_hlp, rho, depth, Current_Force, Wave_Force,
                                                                        Approaching_Wave_Field,z_location_turbines, Max_Turbine, g, M_added_floater ,Acceleration_Override, gridsize, Smooth_Start,smooth_function_value, N_matrix, COG_to_surface,
                                                                        Sway_plate_char, Heave_plate_char, C_inertia, Slosh_char, Slosh_Force, slosh_kin_list, Slosh_Force_test, M_added_sway_plateD3)
        
        #This step is valid for all i's: Loading the relevant numbers
        x_time_0 = np.array( x_list[i] )
        xdot_time_0 = np.array( xdot_list[i] )
        F_time_0 = np.array( F_save[i] )

        if i==0:
            xddot_time_0 = Dynamics.xddot_calculator (x_time_0, xdot_time_0, F_time_0, M_matrix - E_matrix, K_matrix, C_matrix)
        else:
            xddot_time_0 = np.array( xddot_list[i] )

        #PREDICTOR
        x_time_1_p = x_time_0 + time_step * xdot_time_0
        xdot_time_1_p = xdot_time_0 + time_step * xddot_time_0
        x_list[i+1] = x_time_1_p
        xdot_list[i+1] = xdot_time_1_p     
        
        if i==steps-1:
            break
            
        #Update forcing, etc.with the predictor values
        F_save_p[i+1], Angle_Pendulum ,F_axial[i], slosh_kin_list, E_matrix = Updater(i+1, x_list, xdot_list, xddot_list, F_constant, segments, steps, Total_time, Length_segment, free_space_between_segments,characteristics_small_floater, Length_Pendulum, Pendulum_hinge_top_location,
                                                                                                 Diameter_pendulum, Pendulum_hinge_bottom_location, Damping_Pendulum, Three_Dimensional_Calculation,characteristics_large_floater,M_segment, C_drag_pointed_rectangle, C_drag_bottom_floater,
                                                                                                 Stiffness_Pendulum, z_location_bottom_floater, Tidal_level, flow_velocity, Wave_hlp, rho, depth, Current_Force, Wave_Force,
                                                                                                 Approaching_Wave_Field,z_location_turbines, Max_Turbine, g, M_added_floater,Acceleration_Override, gridsize, Smooth_Start,smooth_function_value, N_matrix, COG_to_surface, 
                                                                                                 Sway_plate_char, Heave_plate_char, C_inertia, Slosh_char, Slosh_Force, slosh_kin_list, Slosh_Force_test, M_added_sway_plateD3)
        
        
        
        F_time_p = np.array(F_save_p[i+1])

        # print(M_matrix-E_matrix)
        xddot_time_1_p = Dynamics.xddot_calculator (x_time_1_p, xdot_time_1_p, F_time_p, M_matrix - E_matrix, K_matrix, C_matrix)
        
        #CORRECTOR
        # Integration with timesteps for velocity and location
        x_time_1 = x_time_0 + time_step * 0.5*(xdot_time_0 + xdot_time_1_p) #Wellicht xdot_time_1 van de volgende regel hierin invullen ipv xdot_time_p.....
        xdot_time_1 = xdot_time_0 + time_step * 0.5*(xddot_time_0 + xddot_time_1_p)
        x_list[ i + 1 ] = x_time_1
        xdot_list[i + 1] = xdot_time_1
        
        
        F_save[i+1], Angle_Pendulum, F_axial[i], slosh_kin_list, E_matrix = Updater(i+1, x_list, xdot_list, xddot_list, F_constant, segments, steps, Total_time, Length_segment, free_space_between_segments,characteristics_small_floater, Length_Pendulum, Pendulum_hinge_top_location,
                                                                                                 Diameter_pendulum, Pendulum_hinge_bottom_location, Damping_Pendulum, Three_Dimensional_Calculation,characteristics_large_floater,M_segment, C_drag_pointed_rectangle, C_drag_bottom_floater,
                                                                                                 Stiffness_Pendulum, z_location_bottom_floater, Tidal_level, flow_velocity, Wave_hlp, rho, depth, Current_Force, Wave_Force,
                                                                                                 Approaching_Wave_Field,z_location_turbines, Max_Turbine, g, M_added_floater,Acceleration_Override, gridsize, Smooth_Start,smooth_function_value, N_matrix, COG_to_surface, 
                                                                                                 Sway_plate_char, Heave_plate_char, C_inertia, Slosh_char, Slosh_Force, slosh_kin_list, Slosh_Force_test, M_added_sway_plateD3)
        
        
        
        F_time_1 = np.array( F_save[i+1] )
        xddot_time_1 = Dynamics.xddot_calculator (x_time_1, xdot_time_1, F_time_1, M_matrix - E_matrix, K_matrix, C_matrix)
        xddot_list[i + 1] = xddot_time_1
        xddot_list_tot[i+1] = max( np.sqrt(   (xddot_list[i+1,0] - xddot_list[i+1,2]*z_location_deck)**2 + (xddot_list[i+1,1] - xddot_list[i+1,2] * width_deck/2)**2),
                                   np.sqrt(    (xddot_list[i + 1, 0] - xddot_list[i + 1, 2] * z_location_deck) ** 2 + (xddot_list[i + 1, 1] + xddot_list[i + 1, 2] * width_deck / 2) ** 2)  )


        # Progress information and estimated time left
        if Alternative_prints == False:
            if i == 10:
                Estimated_Time_Left = (time.time() - Start_Time) / 11 * steps
                print("Dynamic calculation: 0.0 %,",
                      round(Estimated_Time_Left),
                      "sec left")

            if (i + 1) % int(steps / 10) == 0 and i != 0:
                Estimated_Time_Left = (time.time() - Start_Time) / ((i + 1) / int(steps / 10)) * 10 - (
                            time.time() - Start_Time)
                print("Dynamic calculation:", np.ceil(round(100 * i / steps) / 10) * 10, "%,", round(Estimated_Time_Left),
                      "sec left,", round(time.time() - Start_Time),'sec passed,', round(Estimated_Time_Left) + round(time.time() - Start_Time),'sec in total')

        else:
            if i == 10:
                Estimated_Time_Left = (time.time() - Start_Time) / 11 * steps
                print("Dynamic calculation", HeatMapRound, ": 0.0 %,",
                      round(Estimated_Time_Left),
                      "sec left")

            if (i + 1) % int(steps / 10) == 0 and i != 0:
                Estimated_Time_Left = (time.time() - Start_Time) / ((i + 1) / int(steps / 10)) * 10 - (
                        time.time() - Start_Time)
                print("Dynamic calculation", HeatMapRound, ":", np.ceil(round(100 * i / steps) / 10) * 10, "%,",
                      round(Estimated_Time_Left),
                      "sec left")



    F_axial = F_axial[:-1]

    # find maximum values for location and acceleration (ignore first 14 seconds)
    Max_location, Max_acceleration, Max_F_Pendulum, Min_F_Pendulum,start_search = Dynamics.Maximum(x_list, xddot_list, xddot_list_tot, Total_time, segments, F_axial, Three_Dimensional_Calculation , Wave_hlp , flow_velocity)

    if Alternative_prints == False:
        print("> Dynamic calculation finished")
        print()
        print("> Generating data file, figures and animation started")

    # Generate plots, save plots to folder and include txt file specifying data.
    Output_Files.DataFile(Test_Number, M_matrix, C_matrix, K_matrix_txt, Total_time,
                          time_step, Length_segment, free_space_between_segments,
                          characteristics_small_floater, characteristics_large_floater, M_segment, J_segment,
                          z_location_bottom_floater, z_location_deck, z_location_Super_Structure, z_location_turbines, width_deck, Turbine_char,
                          Length_Pendulum, Angle_Pendulum_Mid_Tide, Angle_Pendulum_Initial_Tidal,
                          Pendulum_hinge_top_location, Diameter_pendulum, Stiffness_Pendulum, Stiffness_Spudpole,
                          Stiffness_connection_segment, Damping_Pendulum, Damping_Spudpole, Damping_connection_segment,
                          Wind_Distributed_Load_Deck, Wind_Distributed_Load_Super_Structure, Traffic_load, Max_Turbine, C_drag_pointed_rectangle, C_drag_bottom_floater,
                          C_Added_Mass_Pointed_Tip_Reduction, C_Added_Mass_Not_Infinite_Factor, C_Marine_Growth_Extra, C_Damping_Pointed_Tip_Reduction,
                          Tidal_level, flow_velocity, Wave_hlp, depth, rho, g, Natural_Period, gridsize, smooth_time, Max_location,
                          Max_acceleration, Max_F_Pendulum, Min_F_Pendulum, Wave_Force, Pendulum_Drag_Force, Current_Force, Turbine_Force, Traffic_Force, Constant_force,
                          Three_Dimensional_Calculation, Wind_Deck_Force, Wind_Super_Structure_Force, Smooth_Start, Approaching_Wave_Field,
                          Integration_Of_Ansys_Aqwa_mass, Integration_Of_Ansys_Aqwa_damp, Ansys_Aqwa_file_name, Ansys_char, Acceleration_Override, ExperimentalAddition,
                          start_search,Stiffness_lean_factor,Turbine_dimensions_HWL, M_added_tur_hori, M_added_tur_vert,C_radiation_turbine_sway_reduction,x_list,
                          Sway_Plate_Force, Slosh_Force_test,draught, loopname, Heave_Plate_Force, Heave_plate_char, Sway_plate_char, Slosh_char, Slosh_Force)

    Output_Files.Graphs(Test_Number, segments, steps, Total_time, Time, x_list, xdot_list, xddot_list,xddot_list_tot,F_save,
                        Show_Tidal_Displacement_In_Plot, Tidal_level, Length_segment, Angle_Pendulum_Initial_Tidal, F_axial,
                        Three_Dimensional_Calculation, Wave_Force,showplotoverride, slosh_kin_list,Slosh_Force, Slosh_Force_test)

    if Three_Dimensional_Calculation == False:
        if Make_Animation == True:
            Animation.Animation(Total_time,x_list,steps,characteristics_small_floater,characteristics_large_floater,M_segment,
               z_location_bottom_floater,z_location_deck,Angle_Pendulum_Initial_Tidal,Pendulum_hinge_top_location,Pendulum_hinge_bottom_location,
               Wind_Distributed_Load_Deck,Tidal_level,flow_velocity,Wave_hlp,depth,rho,smooth_time,Wind_Deck_Force,Wave_Force,Current_Force,Smooth_Start, 
               slosh_kin_list, Approaching_Wave_Field, Slosh_char,Slosh_Force, draught)

    if Alternative_prints == False:
        print("> Generating data file, figures and animation finished")
        print()
        if Acceleration_Override == True:
            print(">> Process finished   - - -   Warning, numerical instabilities in accelerations were manually corrected")
        else:
            print(">> Process finished")

    if Show_plot == True:
        plt.show()


    return (Test_Number, Max_location, Max_acceleration, Max_F_Pendulum, Min_F_Pendulum)