import math
import Heatmap_Enhancer
import numpy as np
#import matplotlib.pyplot as plt

loopname = "WaveHeight_Length"
First_Test_Number = 4900
flow_velocity = 0
Wave_Height_Direction = 1 #Make negative if this is not in the wave data anymore....
len_l = 8
len_h = 6
depth = 23.3

Last_Test_Number = int(First_Test_Number + len_h * len_l - 1)
Plot_enhancer = int(14 * 36 / len_l)

#%%
map_roll_loc = np.loadtxt("Figures/Test_{} - finish/Map_Roll_Loc_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),delimiter=',')
map_tot_acc = np.loadtxt("Figures/Test_{} - finish/Map_Tot_Acc_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),delimiter=',')    
Wave_height = np.loadtxt("Figures/Test_{} - finish/Map_Wave_Height_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),delimiter=',')
Wave_length = np.loadtxt("Figures/Test_{} - finish/Map_Wave_Length_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),delimiter=',')
Angle_Pendulum_Mid_Tide = np.loadtxt("Figures/Test_{} - finish/Map_Angle_Pendulum_Mid_Tide_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),delimiter=',')

g = 9.8
print('Load data succeeded')

#%%    
#This part is to determin the wave frequency axis.
Axis_Wave_L_pre_enhanced = np.zeros((len_l,len_h))
for i in range(len_l):
    for j in range(len_h):
        Axis_Wave_L_pre_enhanced[i,j] = Wave_length[j+i*len_h]#Wave_length[(j+1)+len_h*i]
Axis_Wave_L_enhanced = np.array(Heatmap_Enhancer.Enhance(Axis_Wave_L_pre_enhanced, Plot_enhancer))
Wave_L_enhanced = np.zeros(len(Axis_Wave_L_enhanced))
for i in range(len(Axis_Wave_L_enhanced)):
    Wave_L_enhanced[i] = Axis_Wave_L_enhanced[i,0]
Wave_speed_enhanced = np.sqrt(g * Wave_L_enhanced / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_L_enhanced)) + flow_velocity * Wave_Height_Direction
Wave_period_enhanced = Wave_L_enhanced / Wave_speed_enhanced
np.savetxt("Figures_combined_graph/Wave_period_enhanced_{}-{}.csv".format(f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),Wave_period_enhanced, delimiter=',')

#%%
map_tot_acc_trans = np.zeros((len_h,len_l))
for i in range (len_l):
    for j in range (len_h):
        map_roll_loc[i][j] = map_roll_loc[i][j] * (1. / Angle_Pendulum_Mid_Tide[i])
        map_tot_acc_trans[j][i] = map_tot_acc[i][len_h-1-j] * (1. / g)

map_roll_loc_enhanced = np.array(Heatmap_Enhancer.Enhance(map_roll_loc, Plot_enhancer))
print('map_roll_loc_enhanced')
map_tot_acc_trans_enhanced = np.array(Heatmap_Enhancer.Enhance(map_tot_acc_trans, Plot_enhancer))
print('map_tot_acc_trans_enhanced')

#%%
limit_loc_roll = np.zeros((len(map_roll_loc_enhanced), len(map_roll_loc_enhanced[0])))
limit_acc_tot_trans = np.zeros((len(map_tot_acc_trans_enhanced),len(map_tot_acc_trans_enhanced[0])))

roll_loc_value = 0.06
tot_value = 0.7
#roll_loc_value = 0.06
#tot_value = 0.5

difference = 0.0007
for i in range(len(limit_loc_roll)):
    for j in range(len(limit_loc_roll[0])):
        if abs(map_roll_loc_enhanced[i,j] - roll_loc_value * (1. / Angle_Pendulum_Mid_Tide[0])) < difference:
            limit_loc_roll[i,j]=1
for i in range(len(map_tot_acc_trans_enhanced)): #y-values         map_tot_acc_trans_enhanced[y,x]
    for j in range(len(map_tot_acc_trans_enhanced[0])): #x-values
        if abs(map_tot_acc_trans_enhanced[i,j] - tot_value * (1. / g)) < difference:
            limit_acc_tot_trans[i,j]=1

#limit_loc_roll = np.zeros(len(limit_loc_roll[0]))
#for i in range(len(limit_loc_roll)):
#    temp_roll = np.zeros(len(limit_loc_roll))
#    count_roll = 0
#    for j in range(len(limit_loc_roll)):
#        if limit_loc_roll[j,i]>0:
#            temp_roll[j]= j
#            count_roll += 1
#    limit_loc_roll[i] = np.sum(temp_roll)/count_roll
#    if math.isnan(limit_loc_roll[i])== True:
#        limit_loc_roll[i] = 0

limit_acc_tot = np.zeros(len(limit_acc_tot_trans[0]))
for i in range(len(limit_acc_tot)):
    temp_tot = np.zeros(len(limit_acc_tot_trans))
    count_tot = 0
    for j in range(len(limit_acc_tot_trans)):
        if limit_acc_tot_trans[j,i]>0:
            temp_tot[j]= j
            count_tot += 1
    limit_acc_tot[i] = np.sum(temp_tot)/count_tot
    if math.isnan(limit_acc_tot[i])== True:
        limit_acc_tot[i] = 0

#limit_loc_roll[0]=0
#limit_loc_roll[-1]=0
limit_acc_tot[0]=0
limit_acc_tot[-1]=0

for i in range(len(limit_acc_tot)):
#    if limit_loc_roll[i]==0:
#        limit_loc_roll[i]=limit_loc_roll[i-1]
    if limit_acc_tot[i]==0:
        limit_acc_tot[i]=limit_acc_tot[i-1]

#limit_loc_roll = max(Wave_height)-(max(Wave_height)-min(Wave_height))/len(map_roll_loc_enhanced) * limit_loc_roll
limit_acc_tot = max(Wave_height)-(max(Wave_height)-min(Wave_height))/len(map_tot_acc_trans_enhanced) * limit_acc_tot
np.savetxt("Figures_combined_graph/limit_acc_tot_{}-{}.csv".format(f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),limit_acc_tot, delimiter=',')
print('max', max(limit_acc_tot))
print('min', min(limit_acc_tot))

#%%
