
# import of libraries
import Main
import Output_Files
import Heatmap_Enhancer

import numpy as np
import matplotlib.pyplot as plt
import seaborn as sb
import multiprocessing as mp
from joblib import Parallel, delayed
from datetime import datetime
import os

def Product(NEEM, FirstNumber,Rangetickstuff, GenerateData = True ,MakePlot = False,LoadData = False):



    plt.rcParams.update({'figure.max_open_warning': 0})

    ################################# COMPUTATION SETTINGS ##################################

    # loopnames implemented:
        # "Angle_Lratio"                        Angle of pendulum on x_axis and Length wave / length floater on y axis
        # "Angle_ypendulum"                     Angle of pendulum on x axis and the y coordinate of the upper pendulum hinge over z-coordinate on the y axis
        # "WaveHeight_Length"                   Wave height / draught on x axis sand wave length / length floater on y axis = Waves in positive direction
        # "WaveHeightmin_Length"                Wave height / draught on x axis sand wave length / length floater on y axis - Waves in negative direction
        # "FlowVelocity_WaveLength_scalar"      Flow velocity / Wave speed on x axis and wave length / length_floater on y axis - WAve height is scalar
        # "FlowVelocity_WaveLength_A3" Flow velocity / Wave speed on x axis and wave length / length_floater on y axis - WAve height is linear function of wave length according to negative waves acc heave
        # "WindForce_WaveLength_Plus"           Wind distributed load / Max wind load on x axis and wave length / length_floater on y axis PLUS flow curve
        # "ypendulum_WaveLength"                y location of pendulum / z location on xaxis and wave length / floater length on y axis
        # "TidalLevel_WaveLength"               Tidal level / PendulumLength on xaxis and wave length / floater length on y axis
        # "TurbineForce_WaveLength"             Turbine force at 1 m/s / grafitational force segment on xaxis and wave length / length floater on y axis
        # "TurbineForce_TurbineLoc"             Turbine force at 1 m/s / grafitational force segment on xaxis and - depth turbine / draught on y axis

    loopname = NEEM

    x_axis_range = np.linspace(Rangetickstuff[0], Rangetickstuff[1], 6)  # 4 or larger
    # y_axis_range_start = 3.5 #seconds (wave lengths of about 20 meters)
    # y_axis_range_stop = 11 #seconds (wave lengths of about 150 meters
    # steppers = 8 #4 or larger #for wave length
    # temp = np.linspace(0, 1, steppers)  # for wave length
    # y_axis_range = y_axis_range_start + (y_axis_range_stop-y_axis_range_start)*temp**1.8#for wave length

    y_axis_range_start = 0.33 #for wave length
    y_axis_range_stop = 4.5 #for wave length
    steppers = 8 #4 or larger #for wave length
    temp = np.linspace(0,1,steppers)#for wave length
    y_axis_range = y_axis_range_start + (y_axis_range_stop-y_axis_range_start)*temp**2#for wave length


    x_axis_ticks_spacing = Rangetickstuff[2]
    y_axis_ticks_spacing = 0.5

    First_Test_Number = FirstNumber


    ################################# MAGIC STARTS HERE ##################################

    computation_list = np.zeros((len(x_axis_range) * len((y_axis_range)), 2))
    values = np.linspace(0, len(computation_list) - 1, len(computation_list))

    num_cores = mp.cpu_count()
    if num_cores < 9:
        num_cores = num_cores - 1
    Last_Test_Number = int(First_Test_Number + len(computation_list) - 1)

    for i in range(len(computation_list)):
        computation_list[i, 0] = x_axis_range[i % len(x_axis_range)]
        computation_list[i, 1] = y_axis_range[int(np.floor(i / len(x_axis_range)))]


    def HeatMapProcessor(i):
        print(" - - - - - - - Heatmap process", int(i + 1), "out of", len(computation_list), "started - - - - - - -")
        Max_location, Max_acceleration, Max_F_Pendulum, Min_F_pendulum, Wave_height, g, M_segment, Angle_Pendulum_Mid_Tide,Wave_period, Wave_length = Main.Main(
            loopname, computation_list[int(i)],3, int(First_Test_Number + i), int(i + 1))
        plt.close('all')

        #Main(loopname, loopvalue, showplotoverride, HeatMapTestNumber, HeatMapRound)

        return (
        Max_location, Max_acceleration, Max_F_Pendulum, Min_F_pendulum, First_Test_Number + i, Wave_height, g, M_segment,
        Angle_Pendulum_Mid_Tide,Wave_period, Wave_length)

    if GenerateData == True:
        Computation_data = Parallel(n_jobs=num_cores)(delayed(HeatMapProcessor)(i) for i in values)

        x_list = np.zeros((len(computation_list), 3))
        xddot_list = np.zeros((len(computation_list), 4))
        F_list = np.zeros((len(computation_list), 4))
        F_list_min = np.zeros((len(computation_list), 4))

        Wave_height = np.zeros(len(computation_list))
        Angle_Pendulum_Mid_Tide = np.zeros(len(computation_list))
        Wave_period = np.zeros(len(computation_list))
        Wave_length = np.zeros(len(computation_list))


    #    for i in range (len(values)):
    #       x_list[i], xddot_list[i],F_list[i], F_list_min[i], First_Test_Number,Wave_height[i], g, M_segment, Angle_Pendulum_Mid_Tide[i] = HeatMapProcessor(i)

        for i in range(len(Computation_data)):
            x_list[i, :] = Computation_data[i][0]
            xddot_list[i, :] = Computation_data[i][1]
            F_list[i, :] = Computation_data[i][2]
            F_list_min[i, :] = Computation_data[i][3]

            if i == 0:
                g = Computation_data[i][6]
                M_segment = Computation_data[i][7]

            Wave_height[i] = abs(Computation_data[i][5])
            Angle_Pendulum_Mid_Tide[i] = Computation_data[i][8]
            Wave_period[i] = Computation_data[i][9]
            Wave_length[i] = Computation_data[i][10]

        map_sway_loc = np.reshape(x_list[:, 0], (len(y_axis_range), len(x_axis_range)))
        map_heave_loc = np.reshape(x_list[:, 1], (len(y_axis_range), len(x_axis_range)))
        map_roll_loc = np.reshape(x_list[:, 2], (len(y_axis_range), len(x_axis_range)))
        map_sway_acc = np.reshape(xddot_list[:, 0], (len(y_axis_range), len(x_axis_range)))
        map_heave_acc = np.reshape(xddot_list[:, 1], (len(y_axis_range), len(x_axis_range)))
        map_roll_acc = np.reshape(xddot_list[:, 2], (len(y_axis_range), len(x_axis_range)))
        map_tot_acc = np.reshape(xddot_list[:, 3], (len(y_axis_range), len(x_axis_range)))
        map_force = np.reshape(F_list[:, 1], (len(y_axis_range), len(x_axis_range)))
        map_force_min = np.reshape(F_list_min[:, 1], (len(y_axis_range), len(x_axis_range)))

        np.savetxt("Figures/Test_{}/Map_Sway_Loc_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),
                   map_sway_loc, delimiter=',')
        np.savetxt("Figures/Test_{}/Map_Heave_Loc_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),
                   map_heave_loc, delimiter=',')
        np.savetxt("Figures/Test_{}/Map_Roll_Loc_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),
                   map_roll_loc, delimiter=',')
        np.savetxt("Figures/Test_{}/Map_Sway_Acc_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),
                   map_sway_acc, delimiter=',')
        np.savetxt("Figures/Test_{}/Map_Heave_Acc_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),
                   map_heave_acc, delimiter=',')
        np.savetxt("Figures/Test_{}/Map_Roll_Acc_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),
                   map_roll_acc, delimiter=',')
        np.savetxt("Figures/Test_{}/Map_Tot_Acc_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),
                   map_tot_acc, delimiter=',')
        np.savetxt("Figures/Test_{}/Map_Wave_Height_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),
                   Wave_height, delimiter=',')
        np.savetxt("Figures/Test_{}/Map_Wave_Period_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),
                   Wave_period, delimiter=',')
        np.savetxt("Figures/Test_{}/Map_Wave_Length_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),
                   Wave_length, delimiter=',')
        np.savetxt("Figures/Test_{}/Map_Angle_Pendulum_Mid_Tide_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),
                   Angle_Pendulum_Mid_Tide, delimiter=',')
        
        
        
    if LoadData == True:
        map_sway_loc = np.loadtxt(
            "Figures/Test_{}/Map_Sway_Loc_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",
                                                                          f"{First_Test_Number:05d}",
                                                                          f"{Last_Test_Number:05d}", loopname),
            delimiter=',')
        map_heave_loc = np.loadtxt(
            "Figures/Test_{}/Map_Heave_Loc_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",
                                                                           f"{First_Test_Number:05d}",
                                                                           f"{Last_Test_Number:05d}", loopname),
            delimiter=',')
        map_roll_loc = np.loadtxt(
            "Figures/Test_{}/Map_Roll_Loc_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",
                                                                          f"{First_Test_Number:05d}",
                                                                          f"{Last_Test_Number:05d}", loopname),
            delimiter=',')
        map_sway_acc = np.loadtxt(
            "Figures/Test_{}/Map_Sway_Acc_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",
                                                                          f"{First_Test_Number:05d}",
                                                                          f"{Last_Test_Number:05d}", loopname),
            delimiter=',')
        map_heave_acc = np.loadtxt(
            "Figures/Test_{}/Map_Heave_Acc_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",
                                                                           f"{First_Test_Number:05d}",
                                                                           f"{Last_Test_Number:05d}", loopname),
            delimiter=',')
        map_roll_acc = np.loadtxt(
            "Figures/Test_{}/Map_Roll_Acc_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",
                                                                          f"{First_Test_Number:05d}",
                                                                          f"{Last_Test_Number:05d}", loopname),
            delimiter=',')
        map_tot_acc = np.loadtxt(
            "Figures/Test_{}/Map_Tot_Acc_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",
                                                                          f"{First_Test_Number:05d}",
                                                                          f"{Last_Test_Number:05d}", loopname),
            delimiter=',')    
        Wave_height = np.loadtxt(
            "Figures/Test_{}/Map_Wave_Height_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",
                                                                             f"{First_Test_Number:05d}",
                                                                             f"{Last_Test_Number:05d}", loopname),
            delimiter=',')
        Wave_period = np.loadtxt(
            "Figures/Test_{}/Map_Wave_Period_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",
                                                                             f"{First_Test_Number:05d}",
                                                                             f"{Last_Test_Number:05d}", loopname),
            delimiter=',')
        Wave_length = np.loadtxt("Figures/Test_{}/Map_Wave_Length_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),delimiter=',')
        Angle_Pendulum_Mid_Tide = np.loadtxt("Figures/Test_{}/Map_Angle_Pendulum_Mid_Tide_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),delimiter=',')
        g = 9.8
        M_segment = 3000000


    # This has mistakes below here
    # for i in range (len(map_sway_acc)):
    # # for i in range (len(map_sway_acc[0])):
    # # for i in range(len(Computation_data))
    #     map_sway_loc[i] = map_sway_loc[i] * (1. / abs(Wave_height[i]))
    #     map_heave_loc[i] = map_heave_loc[i] * (1. / abs(Wave_height[i]))
    #     map_roll_loc[i] = map_roll_loc[i] * (1. / Angle_Pendulum_Mid_Tide[i])
    #     map_sway_acc[i] = map_sway_acc[i] * (1. / g)
    #     map_heave_acc[i] = map_heave_acc[i] * (1. / g)
    #     map_roll_acc[i] = map_roll_acc[i] * (1. / (Angle_Pendulum_Mid_Tide[i] * g / abs(Wave_height[i])))
    #     map_force[i] = map_force[i] * (1. / (M_segment * g))
    #     map_force_min[i] = map_force_min[i] * (1. / (M_segment * g))

    map_roll_acc2 = np.zeros((len(map_sway_loc),len(map_sway_loc[0])))

    for i in range (len(y_axis_range)):
        for j in range (len(x_axis_range)):
            map_sway_loc[i][j] = map_sway_loc[i][j] * (1. / abs(Wave_height[j]))
            map_heave_loc[i][j] = map_heave_loc[i][j] * (1. / abs(Wave_height[j]))
            map_roll_loc[i][j] = map_roll_loc[i][j] * (1. / Angle_Pendulum_Mid_Tide[i])
            map_sway_acc[i][j] = map_sway_acc[i][j] * (1. / g)
            map_heave_acc[i][j] = map_heave_acc[i][j] * (1. / g)
            map_roll_acc[i][j] = map_roll_acc[i][j] * (1. / (Angle_Pendulum_Mid_Tide[i] * g / abs(Wave_height[j])))
            map_roll_acc2[i][j] = map_roll_acc[i][j]
            map_tot_acc[i][j] = map_tot_acc[i][j] * (1. / g)
    if LoadData == True:
        pass
    else:
        for i in range (len(y_axis_range)):
            for j in range (len(x_axis_range)):         
                map_force[i][j] = map_force[i][j] * (1. / (M_segment * g))
                map_force_min[i][j] = map_force_min[i][j] * (1. / (M_segment * g))


    # Enhance figures
    Plot_enhancer = int(14 * 36 / len(y_axis_range))

    map_sway_loc_enhanced = np.array(Heatmap_Enhancer.Enhance(map_sway_loc, Plot_enhancer))
    map_heave_loc_enhanced = np.array(Heatmap_Enhancer.Enhance(map_heave_loc, Plot_enhancer))
    map_roll_loc_enhanced = np.array(Heatmap_Enhancer.Enhance(map_roll_loc, Plot_enhancer))
    map_sway_acc_enhanced = np.array(Heatmap_Enhancer.Enhance(map_sway_acc, Plot_enhancer))
    map_heave_acc_enhanced = np.array(Heatmap_Enhancer.Enhance(map_heave_acc, Plot_enhancer))
    map_roll_acc_enhanced = np.array(Heatmap_Enhancer.Enhance(map_roll_acc, Plot_enhancer))
    map_roll_acc_enhanced2 = np.array(Heatmap_Enhancer.Enhance(map_roll_acc2, Plot_enhancer))
    map_tot_acc_enhanced = np.array(Heatmap_Enhancer.Enhance(map_tot_acc, Plot_enhancer))
    if LoadData == True:
        pass
    else:
        map_force_enhanced = np.array(Heatmap_Enhancer.Enhance(map_force, Plot_enhancer))
        map_force_min_enhanced = np.array(Heatmap_Enhancer.Enhance(map_force_min, Plot_enhancer))

    limit_loc_roll = np.zeros((len(map_sway_acc_enhanced), len(map_sway_acc_enhanced[0])))
    limit_acc_sway = np.zeros((len(map_sway_acc_enhanced),len(map_sway_acc_enhanced[0])))
    limit_acc_heave = np.zeros((len(map_sway_acc_enhanced),len(map_sway_acc_enhanced[0])))
    limit_acc_roll = np.zeros((len(map_sway_acc_enhanced),len(map_sway_acc_enhanced[0])))
    limit_acc_tot = np.zeros((len(map_sway_acc_enhanced),len(map_sway_acc_enhanced[0])))

    roll_loc_value = 0.06
    sway_value = 0.5
    heave_value = 0.5
    roll_value = 0.05
    tot_value = 0.7

    difference = 0.0007
    for i in range(len(map_sway_acc_enhanced)):
        for j in range(len(map_sway_acc_enhanced[0])):
            if abs(map_roll_loc_enhanced[i,j] - roll_loc_value * (1. / Angle_Pendulum_Mid_Tide[0])) < difference:
                limit_loc_roll[i,j]=1
            if abs(map_sway_acc_enhanced[i,j] - sway_value * (1. / g)) <difference:
                limit_acc_sway[i,j]=1
            if abs(map_heave_acc_enhanced[i,j] - heave_value * (1. / g)) < difference:
                limit_acc_heave[i,j]=1
            if abs(map_roll_acc_enhanced2[i,j] - roll_value) < difference:
                limit_acc_roll[i,j]=1
            if abs(map_tot_acc_enhanced[i,j] - tot_value * (1. / g)) < difference:
                limit_acc_tot[i,j]=1


    #Xlabel and Xtics for single sensitivity analysis
    if loopname == "Angle_Lratio":
        xaxis = r'$\phi$ [degrees]'
        yaxis = r'$L_{wave} / L_{fl}$ [-]'
    if loopname == "Angle_ypendulum":
        xaxis = r'$\phi$ [degrees]'
        yaxis = r'$y_{p,top} / z_{p,top}$ [-]'
    if loopname == "WaveHeight_Length" or "WaveHeight_Length0" or "WaveHeight_Length4" or "WaveHeight_Length3" or "WaveHeightm_Length3" or "WaveHeight_Lengthm3":
        xaxis = r'$H_{wave} / d$ [-]'
        yaxis = r'$L_{wave} / L_{fl}$ [-]'
    if loopname == "WaveHeightmin_Length":
        xaxis = r'$H_{wave} / d$ [-]'
        yaxis = r'$L_{wave} / L_{fl}$ [-]'
    if "FlowVelocity_WaveLength" in loopname:
        xaxis = r'$u / c_{wave}$ [-]'
        yaxis = r'$L_{wave} / L_{fl}$ [-]'
    if "WindRatio_WaveLength" in loopname:
        xaxis = r'$F_{wind} / F_{wind,max}}$ [-]'
        yaxis = r'$L_{wave} / L_{fl}$ [-]'
    if "PendAngle_MaxForce" in loopname:
        xaxis = r'$\phi$ [degrees]'
        yaxis = r'$L_{wave} / L_{fl}$ [-]'
    if "Depth_MaxForce" in loopname:
        xaxis = r'$h / d$ [-]'
        yaxis = r'$L_{wave} / L_{fl}$ [-]'
    if "Hinge_MaxForce" in loopname:
        xaxis = r'$y_{p,top} / z_{p,top}$ [-]'
        yaxis = r'$L_{wave} / L_{fl}$ [-]'
    if loopname == "ypendulum_WaveLength":
        xaxis = r'$y_{p,top} / z_{p,top}$ [-]'
        yaxis = r'$L_{wave} / L_{fl}$ [-]'
    if loopname == "TidalLevel_WaveLength":
        xaxis = r'$ \Delta d / L_{p}$ [-]'
        yaxis = r'$L_{wave} / L_{fl}$ [-]'
    if loopname == "TurbineForce_WaveLength":
        xaxis = r'$F_{ T,1} / F_{g}$ [-]'
        yaxis = r'$L_{wave} / L_{fl}$ [-]'
    if loopname == "TurbineForce_TurbineLoc":
        xaxis = r'$F_{ T,1} / F_{g}$ [-]'
        yaxis = r'$- F_{z} / d$ [-]'
    if loopname == "WaveHeightp_Length_Currentp4" or "WaveHeightn_Length_Currentp4" or "WaveHeightp_Length_Currentn4" or "WaveHeightn_Length_Currentn4":
        xaxis = r'$H_{wave,original} / d$ [-]'
        yaxis = r'$L_{wave,original} / L_{fl}$ [-]'
    if loopname == "WaveHeightp_Length_Currentp4" or "WaveHeightn_Length_Currentn4" or "WaveHeightp_Length_Currentp1" or "WaveHeightn_Length_Currentn1" or "WaveHeightn_Length_Currentp1" or "WaveHeightp_Length_Currentn1":
        xaxis = r'$H_{wave,original} / d$ [-]'
        yaxis = r'$L_{wave,original} / L_{fl}$ [-]'
    
    x_axis_ticks = np.linspace(x_axis_range[0], x_axis_range[-1],
                               int((x_axis_range[-1] - x_axis_range[0]) / x_axis_ticks_spacing + 1))
    y_axis_ticks = np.linspace(y_axis_range[0], y_axis_range[-1],
                               int((y_axis_range[-1] - y_axis_range[0]) / y_axis_ticks_spacing + 1))

    for i in range(14):
        if x_axis_ticks_spacing == round(x_axis_ticks_spacing, i):
            x_decimals = i
            break

    for i in range(14):
        if y_axis_ticks_spacing == round(y_axis_ticks_spacing, i):
            y_decimals = i
            break

    xaxis_plot_range = np.linspace(0, len(map_sway_loc_enhanced[0]), (len(map_sway_loc[0]) - 1) * 10)

    if not os.path.exists("Figures/Test_{}/Heatmaps".format(f"{Last_Test_Number:05d}")):
        os.mkdir("Figures/Test_{}/Heatmaps".format(f"{Last_Test_Number:05d}")) #If the error hits this line. Just create this folder.

#    os.mkdir("Figures/Test_{}/Heatmaps".format(f"{Last_Test_Number:05d}")) #If the error hits this line. Just create this folder.
    plt.rcParams.update({'font.size': 14})

    if MakePlot == True:
        # DATA SWAY LOC PLOT
        plt.figure(figsize=(9.5, 5.3))
        sb.heatmap(map_sway_loc, cmap="jet", cbar_kws={'label': r'$ y / |H_{wave}| $'})
        plt.yticks(np.arange(len(y_axis_range)) + 0.5, y_axis_range)
        plt.xticks(np.arange(len(x_axis_range)) + 0.5, x_axis_range)
        plt.xlim(0, len(x_axis_range))
        plt.ylim(0, len(y_axis_range))
        plt.title("Maximum steady state sway displacement")
        plt.xlabel(xaxis)
        plt.ylabel(yaxis)
        plt.savefig("Figures/Test_{}/Heatmaps/Data_0_Loc_Sway_Heatmap_{}-{}".format(f"{Last_Test_Number:05d}",
                                                                                    f"{First_Test_Number:05d}",
                                                                                    f"{Last_Test_Number:05d}", loopname))
    
    
        # DATA HEAVE LOC PLOT
        plt.figure(figsize=(9.5, 5.3))
        sb.heatmap(map_heave_loc, cmap="jet", cbar_kws={'label': r'$ z / |H_{wave}| $'})
        plt.yticks(np.arange(len(y_axis_range)) + 0.5, y_axis_range)
        plt.xticks(np.arange(len(x_axis_range)) + 0.5, x_axis_range)
        plt.xlim(0, len(x_axis_range))
        plt.ylim(0, len(y_axis_range))
        plt.title("Maximum steady state heave displacement")
        plt.xlabel(xaxis)
        plt.ylabel(yaxis)
        plt.savefig("Figures/Test_{}/Heatmaps/Data_1_Loc_Heave_Heatmap_{}-{}".format(f"{Last_Test_Number:05d}",
                                                                                     f"{First_Test_Number:05d}",
                                                                                     f"{Last_Test_Number:05d}", loopname))
    
        # DATA ROLL LOC PLOT
        plt.figure(figsize=(9.5, 5.3))
        sb.heatmap(map_roll_loc, cmap="jet", cbar_kws={'label': r'$ R_{x} / \theta_{p} $'})
        plt.yticks(np.arange(len(y_axis_range)) + 0.5, y_axis_range)
        plt.xticks(np.arange(len(x_axis_range)) + 0.5, x_axis_range)
        plt.xlim(0, len(x_axis_range))
        plt.ylim(0, len(y_axis_range))
        plt.title("Maximum steady state roll rotation")
        plt.xlabel(xaxis)
        plt.ylabel(yaxis)
        plt.savefig("Figures/Test_{}/Heatmaps/Data_2_Loc_Roll_Heatmap_{}-{}".format(f"{Last_Test_Number:05d}",
                                                                                    f"{First_Test_Number:05d}",
                                                                                    f"{Last_Test_Number:05d}", loopname))
    
        # DATA SWAY ACC PLOT
        plt.figure(figsize=(9.5, 5.3))
        sb.heatmap(map_sway_acc, cmap="jet", cbar_kws={'label': r'$ \ddot{y} / g $'})
        plt.yticks(np.arange(len(y_axis_range)) + 0.5, y_axis_range)
        plt.xticks(np.arange(len(x_axis_range)) + 0.5, x_axis_range)
        plt.xlim(0, len(x_axis_range))
        plt.ylim(0, len(y_axis_range))
        plt.title("Maximum steady state sway acceleration")
        plt.xlabel(xaxis)
        plt.ylabel(yaxis)
        plt.savefig("Figures/Test_{}/Heatmaps/Data_3_Acc_Sway_Heatmap_{}-{}".format(f"{Last_Test_Number:05d}",
                                                                                    f"{First_Test_Number:05d}",
                                                                                    f"{Last_Test_Number:05d}", loopname))
    
        # DATA HEAVE ACC PLOT
        plt.figure(figsize=(9.5, 5.3))
        sb.heatmap(map_heave_acc, cmap="jet", cbar_kws={'label': r'$ \ddot{z} / g $'})
        plt.yticks(np.arange(len(y_axis_range)) + 0.5, y_axis_range)
        plt.xticks(np.arange(len(x_axis_range)) + 0.5, x_axis_range)
        plt.xlim(0, len(x_axis_range))
        plt.ylim(0, len(y_axis_range))
        plt.title("Maximum steady state heave acceleration")
        plt.xlabel(xaxis)
        plt.ylabel(yaxis)
        plt.savefig("Figures/Test_{}/Heatmaps/Data_4_Acc_Heave_Heatmap_{}-{}".format(f"{Last_Test_Number:05d}",
                                                                                     f"{First_Test_Number:05d}",
                                                                                     f"{Last_Test_Number:05d}", loopname))
    
        # DATA ROLL ACC PLOT
        plt.figure(figsize=(9.5, 5.3))
        sb.heatmap(map_roll_acc, cmap="jet", cbar_kws={'label': r'$ \ddot{R_{x}} / ( \theta_{p} \cdot g / H_{wave} ) $'})
        plt.yticks(np.arange(len(y_axis_range)) + 0.5, y_axis_range)
        plt.xticks(np.arange(len(x_axis_range)) + 0.5, x_axis_range)
        plt.xlim(0, len(x_axis_range))
        plt.ylim(0, len(y_axis_range))
        plt.title("Maximum steady state roll acceleration")
        plt.xlabel(xaxis)
        plt.ylabel(yaxis)
        plt.savefig("Figures/Test_{}/Heatmaps/Data_5_Acc_Roll_Heatmap_{}-{}".format(f"{Last_Test_Number:05d}",
                                                                                    f"{First_Test_Number:05d}",
                                                                                    f"{Last_Test_Number:05d}", loopname))
        
        # DATA TOT ACC PLOT
        plt.figure(figsize=(9.5, 5.3))
        sb.heatmap(map_tot_acc, cmap="jet", cbar_kws={'label': r'$ \ddot{z} / g $'})
        plt.yticks(np.arange(len(y_axis_range)) + 0.5, y_axis_range)
        plt.xticks(np.arange(len(x_axis_range)) + 0.5, x_axis_range)
        plt.xlim(0, len(x_axis_range))
        plt.ylim(0, len(y_axis_range))
        plt.title("Maximum steady state total acceleration")
        plt.xlabel(xaxis)
        plt.ylabel(yaxis)
        plt.savefig("Figures/Test_{}/Heatmaps/Data_4_Acc_Tot_Heatmap_{}-{}".format(f"{Last_Test_Number:05d}",
                                                                                     f"{First_Test_Number:05d}",
                                                                                     f"{Last_Test_Number:05d}", loopname))
        
        
        if LoadData == True:
            pass
        else:
            # DATA FORCE PLOT
            plt.figure(figsize=(9.5, 5.3))
            sb.heatmap(map_force, cmap="jet", cbar_kws={'label': r'$ F_{p} / F_{g} $'})
            plt.yticks(np.arange(len(y_axis_range)) + 0.5, y_axis_range)
            plt.xticks(np.arange(len(x_axis_range)) + 0.5, x_axis_range)
            plt.xlim(0, len(x_axis_range))
            plt.ylim(0, len(y_axis_range))
            plt.title("Maximum steady state pendulum force")
            plt.xlabel(xaxis)
            plt.ylabel(yaxis)
            plt.savefig(
                "Figures/Test_{}/Heatmaps/Data_6_Force_Heatmap_{}-{}".format(f"{Last_Test_Number:05d}", f"{First_Test_Number:05d}",
                                                                             f"{Last_Test_Number:05d}", loopname))
        
            # DATA MIN FORCE PLOT
            plt.figure(figsize=(9.5, 5.3))
            sb.heatmap(map_force_min, cmap="jet", cbar_kws={'label': r'$ F_{p} / F_{g} $'})
            plt.yticks(np.arange(len(y_axis_range)) + 0.5, y_axis_range)
            plt.xticks(np.arange(len(x_axis_range)) + 0.5, x_axis_range)
            plt.xlim(0, len(x_axis_range))
            plt.ylim(0, len(y_axis_range))
            plt.title("Minimum steady state pendulum force")
            plt.xlabel(xaxis)
            plt.ylabel(yaxis)
            plt.savefig(
                "Figures/Test_{}/Heatmaps/Data_7_Force2_Heatmap_{}-{}".format(f"{Last_Test_Number:05d}", f"{First_Test_Number:05d}",
                                                                              f"{Last_Test_Number:05d}", loopname))
    
        plt.close('all')
    
        # ENHANCED SWAY LOC PLOT
        plt.figure(figsize=(9.5, 5.3))
        sb.heatmap(map_sway_loc_enhanced, cmap="jet", cbar_kws={'label': r'$ y / H_{wave} $'})
        plt.yticks(np.arange(len(y_axis_ticks)) / (len(y_axis_ticks) - 1) * (len(map_sway_loc_enhanced) - 1) + 0.5,
                   np.round(y_axis_ticks, y_decimals), rotation=0)
        plt.xticks(np.arange(len(x_axis_ticks)) / (len(x_axis_ticks) - 1) * (len(map_sway_loc_enhanced[0]) - 1) + 0.5,
                   np.round(x_axis_ticks, x_decimals), rotation=0)
        plt.xlim(0, len(x_axis_range) * Plot_enhancer - (Plot_enhancer - 1))
        plt.ylim(0, len(y_axis_range) * Plot_enhancer - (Plot_enhancer - 1))
        plt.title("Maximum steady state sway displacement")
        plt.xlabel(xaxis)
        plt.ylabel(yaxis)
        plt.savefig(
            "Figures/Test_{}/Heatmaps/0Loc_Sway_Heatmap_{}-{}".format(f"{Last_Test_Number:05d}", f"{First_Test_Number:05d}",
                                                                      f"{Last_Test_Number:05d}", loopname))
    
        # ENHANCED HEAVE LOC PLOT
        plt.figure(figsize=(9.5, 5.3))
        sb.heatmap(map_heave_loc_enhanced, cmap="jet", cbar_kws={'label': r'$ z / H_{wave} $'})
        plt.yticks(np.arange(len(y_axis_ticks)) / (len(y_axis_ticks) - 1) * (len(map_sway_loc_enhanced) - 1) + 0.5,
                   np.round(y_axis_ticks, y_decimals), rotation=0)
        plt.xticks(np.arange(len(x_axis_ticks)) / (len(x_axis_ticks) - 1) * (len(map_sway_loc_enhanced[0]) - 1) + 0.5,
                   np.round(x_axis_ticks, x_decimals), rotation=0)
        plt.xlim(0, len(x_axis_range) * Plot_enhancer - (Plot_enhancer - 1))
        plt.ylim(0, len(y_axis_range) * Plot_enhancer - (Plot_enhancer - 1))
        plt.title("Maximum steady state heave displacement")
        plt.xlabel(xaxis)
        plt.ylabel(yaxis)
        plt.savefig(
            "Figures/Test_{}/Heatmaps/1Loc_Heave_Heatmap_{}-{}".format(f"{Last_Test_Number:05d}", f"{First_Test_Number:05d}",
                                                                       f"{Last_Test_Number:05d}", loopname))
    
        # ENHANCED ROLL LOC PLOT
        plt.figure(figsize=(9.5, 5.3))
        sb.heatmap(map_roll_loc_enhanced, cmap="jet", cbar_kws={'label': r'$ R_{x} / \theta_{p} $'})
        plt.yticks(np.arange(len(y_axis_ticks)) / (len(y_axis_ticks) - 1) * (len(map_sway_loc_enhanced) - 1) + 0.5,
                   np.round(y_axis_ticks, y_decimals), rotation=0)
        plt.xticks(np.arange(len(x_axis_ticks)) / (len(x_axis_ticks) - 1) * (len(map_sway_loc_enhanced[0]) - 1) + 0.5,
                   np.round(x_axis_ticks, x_decimals), rotation=0)
        plt.xlim(0, len(x_axis_range) * Plot_enhancer - (Plot_enhancer - 1))
        plt.ylim(0, len(y_axis_range) * Plot_enhancer - (Plot_enhancer - 1))
        plt.title("Maximum steady state roll displacement")
        plt.xlabel(xaxis)
        plt.ylabel(yaxis)
        plt.savefig(
            "Figures/Test_{}/Heatmaps/2Loc_Roll_Heatmap_{}-{}".format(f"{Last_Test_Number:05d}", f"{First_Test_Number:05d}",
                                                                      f"{Last_Test_Number:05d}", loopname))
    
        # ENHANCED SWAY ACC PLOT
        plt.figure(figsize=(9.5, 5.3))
        sb.heatmap(map_sway_acc_enhanced, cmap="jet", cbar_kws={'label': r'$ \ddot{y} / g $'})
        plt.yticks(np.arange(len(y_axis_ticks)) / (len(y_axis_ticks) - 1) * (len(map_sway_loc_enhanced) - 1) + 0.5,
                   np.round(y_axis_ticks, y_decimals), rotation=0)
        plt.xticks(np.arange(len(x_axis_ticks)) / (len(x_axis_ticks) - 1) * (len(map_sway_loc_enhanced[0]) - 1) + 0.5,
                   np.round(x_axis_ticks, x_decimals), rotation=0)
        plt.xlim(0, len(x_axis_range) * Plot_enhancer - (Plot_enhancer - 1))
        plt.ylim(0, len(y_axis_range) * Plot_enhancer - (Plot_enhancer - 1))
        plt.title("Maximum steady state sway acceleration")
        plt.xlabel(xaxis)
        plt.ylabel(yaxis)
        plt.savefig(
            "Figures/Test_{}/Heatmaps/3Acc_Sway_Heatmap_{}-{}".format(f"{Last_Test_Number:05d}", f"{First_Test_Number:05d}",
                                                                      f"{Last_Test_Number:05d}", loopname))
    
        # ENHANCED HEAVE ACC PLOT
        plt.figure(figsize=(9.5, 5.3))
        sb.heatmap(map_heave_acc_enhanced, cmap="jet", cbar_kws={'label': r'$ \ddot{z} / g $'})
        plt.yticks(np.arange(len(y_axis_ticks)) / (len(y_axis_ticks) - 1) * (len(map_sway_loc_enhanced) - 1) + 0.5,
                   np.round(y_axis_ticks, y_decimals), rotation=0)
        plt.xticks(np.arange(len(x_axis_ticks)) / (len(x_axis_ticks) - 1) * (len(map_sway_loc_enhanced[0]) - 1) + 0.5,
                   np.round(x_axis_ticks, x_decimals), rotation=0)
        plt.xlim(0, len(x_axis_range) * Plot_enhancer - (Plot_enhancer - 1))
        plt.ylim(0, len(y_axis_range) * Plot_enhancer - (Plot_enhancer - 1))
        plt.title("Maximum steady state heave acceleration")
        plt.xlabel(xaxis)
        plt.ylabel(yaxis)
        plt.savefig(
            "Figures/Test_{}/Heatmaps/4Acc_Heave_Heatmap_{}-{}".format(f"{Last_Test_Number:05d}", f"{First_Test_Number:05d}",
                                                                       f"{Last_Test_Number:05d}", loopname))
    
        # ENHANCED ROLL ACC PLOT
        plt.figure(figsize=(9.5, 5.3))
        sb.heatmap(map_roll_acc_enhanced, cmap="jet",
                   cbar_kws={'label': r'$ \ddot{R_{x}} / ( \theta_{p} \cdot g / H_{wave} )$'})
        plt.yticks(np.arange(len(y_axis_ticks)) / (len(y_axis_ticks) - 1) * (len(map_sway_loc_enhanced) - 1) + 0.5,
                   np.round(y_axis_ticks, y_decimals), rotation=0)
        plt.xticks(np.arange(len(x_axis_ticks)) / (len(x_axis_ticks) - 1) * (len(map_sway_loc_enhanced[0]) - 1) + 0.5,
                   np.round(x_axis_ticks, x_decimals), rotation=0)
        plt.xlim(0, len(x_axis_range) * Plot_enhancer - (Plot_enhancer - 1))
        plt.ylim(0, len(y_axis_range) * Plot_enhancer - (Plot_enhancer - 1))
        plt.title("Maximum steady state roll acceleration")
        plt.xlabel(xaxis)
        plt.ylabel(yaxis)
        plt.savefig(
            "Figures/Test_{}/Heatmaps/5Acc_Roll_Heatmap_{}-{}".format(f"{Last_Test_Number:05d}", f"{First_Test_Number:05d}",
                                                                      f"{Last_Test_Number:05d}", loopname))
        
        # ENHANCED TOT ACC PLOT
        plt.figure(figsize=(9.5, 5.3))
        sb.heatmap(map_tot_acc_enhanced, cmap="jet", cbar_kws={'label': r'$ \ddot{z} / g $'})
        plt.yticks(np.arange(len(y_axis_ticks)) / (len(y_axis_ticks) - 1) * (len(map_sway_loc_enhanced) - 1) + 0.5,
                   np.round(y_axis_ticks, y_decimals), rotation=0)
        plt.xticks(np.arange(len(x_axis_ticks)) / (len(x_axis_ticks) - 1) * (len(map_sway_loc_enhanced[0]) - 1) + 0.5,
                   np.round(x_axis_ticks, x_decimals), rotation=0)
        plt.xlim(0, len(x_axis_range) * Plot_enhancer - (Plot_enhancer - 1))
        plt.ylim(0, len(y_axis_range) * Plot_enhancer - (Plot_enhancer - 1))
        plt.title("Maximum steady state total acceleration")
        plt.xlabel(xaxis)
        plt.ylabel(yaxis)
        plt.savefig(
            "Figures/Test_{}/Heatmaps/6Acc_Total_Heatmap_{}-{}".format(f"{Last_Test_Number:05d}", f"{First_Test_Number:05d}",
                                                                       f"{Last_Test_Number:05d}", loopname))
        
    
        if LoadData == True:
            pass
        else:
            # ENHANCED FORCE PLOT
            plt.figure(figsize=(9.5, 5.3))
            sb.heatmap(map_force_enhanced, cmap="jet", cbar_kws={'label': r'$ F_{p} / F_{g} $'})
            plt.yticks(np.arange(len(y_axis_ticks)) / (len(y_axis_ticks) - 1) * (len(map_sway_loc_enhanced) - 1) + 0.5,
                       np.round(y_axis_ticks, y_decimals), rotation=0)
            plt.xticks(np.arange(len(x_axis_ticks)) / (len(x_axis_ticks) - 1) * (len(map_sway_loc_enhanced[0]) - 1) + 0.5,
                       np.round(x_axis_ticks, x_decimals), rotation=0)
            plt.xlim(0, len(x_axis_range) * Plot_enhancer - (Plot_enhancer - 1))
            plt.ylim(0, len(y_axis_range) * Plot_enhancer - (Plot_enhancer - 1))
            plt.title("Maximum steady state pendulum force")
            plt.xlabel(xaxis)
            plt.ylabel(yaxis)
            plt.savefig(
                "Figures/Test_{}/Heatmaps/6Force_Heatmap_{}-{}".format(f"{Last_Test_Number:05d}", f"{First_Test_Number:05d}",
                                                                       f"{Last_Test_Number:05d}", loopname))
        
            # ENHANCED MIN FORCE PLOT
            plt.figure(figsize=(9.5, 5.3))
            sb.heatmap(map_force_min_enhanced, cmap="jet", cbar_kws={'label': r'$ F_{p} / F_{g} $'})
            plt.yticks(np.arange(len(y_axis_ticks)) / (len(y_axis_ticks) - 1) * (len(map_sway_loc_enhanced) - 1) + 0.5,
                       np.round(y_axis_ticks, y_decimals), rotation=0)
            plt.xticks(np.arange(len(x_axis_ticks)) / (len(x_axis_ticks) - 1) * (len(map_sway_loc_enhanced[0]) - 1) + 0.5,
                       np.round(x_axis_ticks, x_decimals), rotation=0)
            plt.xlim(0, len(x_axis_range) * Plot_enhancer - (Plot_enhancer - 1))
            plt.ylim(0, len(y_axis_range) * Plot_enhancer - (Plot_enhancer - 1))
            plt.title("Minimum steady state pendulum force")
            plt.xlabel(xaxis)
            plt.ylabel(yaxis)
            plt.savefig(
                "Figures/Test_{}/Heatmaps/7Force2_Heatmap_{}-{}".format(f"{Last_Test_Number:05d}", f"{First_Test_Number:05d}",
                                                                        f"{Last_Test_Number:05d}", loopname))

        #ROLL LOC LIMIT
        plt.figure(figsize=(9.5, 5.3))
        sb.heatmap(limit_loc_roll, cmap="Greens")
        plt.yticks(np.arange(len(y_axis_ticks)) / (len(y_axis_ticks) - 1) * (len(map_sway_loc_enhanced) - 1) + 0.5,
                   np.round(y_axis_ticks, y_decimals), rotation=0)
        plt.xticks(
            np.arange(len(x_axis_ticks)) / (len(x_axis_ticks) - 1) * (len(map_sway_loc_enhanced[0]) - 1) + 0.5,
            np.round(x_axis_ticks, x_decimals), rotation=0)
        plt.xlim(0, len(x_axis_range) * Plot_enhancer - (Plot_enhancer - 1))
        plt.ylim(0, len(y_axis_range) * Plot_enhancer - (Plot_enhancer - 1))
        plt.title("Roll displacement limit: "+str(roll_loc_value)+" rad")
        plt.xlabel(xaxis)
        plt.ylabel(yaxis)
        plt.savefig(
            "Figures/Test_{}/Heatmaps/2Loc_Roll_Heatmap_Limit_{}-{}".format(f"{Last_Test_Number:05d}",
                                                                      f"{First_Test_Number:05d}",
                                                                      f"{Last_Test_Number:05d}", loopname))

        #SWAY LIMIT PLOT
        plt.figure(figsize=(9.5, 5.3))
        sb.heatmap(limit_acc_sway, cmap="Greens")
        plt.yticks(np.arange(len(y_axis_ticks)) / (len(y_axis_ticks) - 1) * (len(map_sway_loc_enhanced) - 1) + 0.5,
                   np.round(y_axis_ticks, y_decimals), rotation=0)
        plt.xticks(np.arange(len(x_axis_ticks)) / (len(x_axis_ticks) - 1) * (len(map_sway_loc_enhanced[0]) - 1) + 0.5,
                   np.round(x_axis_ticks, x_decimals), rotation=0)
        plt.xlim(0, len(x_axis_range) * Plot_enhancer - (Plot_enhancer - 1))
        plt.ylim(0, len(y_axis_range) * Plot_enhancer - (Plot_enhancer - 1))
        plt.title("Sway acceleration limit: "+str(sway_value)+" m/s^2")
        plt.xlabel(xaxis)
        plt.ylabel(yaxis)
        plt.savefig(
            "Figures/Test_{}/Heatmaps/3Acc_Sway_Heatmap_Limit_{}-{}".format(f"{Last_Test_Number:05d}", f"{First_Test_Number:05d}",
                                                                          f"{Last_Test_Number:05d}", loopname))
    
    
        #HEAVE LIMIT PLOT
        plt.figure(figsize=(9.5, 5.3))
        sb.heatmap(limit_acc_heave, cmap="Greens")
        plt.yticks(np.arange(len(y_axis_ticks)) / (len(y_axis_ticks) - 1) * (len(map_sway_loc_enhanced) - 1) + 0.5,
                   np.round(y_axis_ticks, y_decimals), rotation=0)
        plt.xticks(np.arange(len(x_axis_ticks)) / (len(x_axis_ticks) - 1) * (len(map_sway_loc_enhanced[0]) - 1) + 0.5,
                   np.round(x_axis_ticks, x_decimals), rotation=0)
        plt.xlim(0, len(x_axis_range) * Plot_enhancer - (Plot_enhancer - 1))
        plt.ylim(0, len(y_axis_range) * Plot_enhancer - (Plot_enhancer - 1))
        plt.title("Heave acceleration limit: "+str(heave_value)+" m/s^2")
        plt.xlabel(xaxis)
        plt.ylabel(yaxis)
        plt.savefig(
            "Figures/Test_{}/Heatmaps/4Acc_Heave_Heatmap_Limit_{}-{}".format(f"{Last_Test_Number:05d}", f"{First_Test_Number:05d}",
                                                                       f"{Last_Test_Number:05d}", loopname))
    
        #ROLL LIMIT PLOT
        plt.figure(figsize=(9.5, 5.3))
        sb.heatmap(limit_acc_roll, cmap="Greens")
        plt.yticks(np.arange(len(y_axis_ticks)) / (len(y_axis_ticks) - 1) * (len(map_sway_loc_enhanced) - 1) + 0.5,
                   np.round(y_axis_ticks, y_decimals), rotation=0)
        plt.xticks(np.arange(len(x_axis_ticks)) / (len(x_axis_ticks) - 1) * (len(map_sway_loc_enhanced[0]) - 1) + 0.5,
                   np.round(x_axis_ticks, x_decimals), rotation=0)
        plt.xlim(0, len(x_axis_range) * Plot_enhancer - (Plot_enhancer - 1))
        plt.ylim(0, len(y_axis_range) * Plot_enhancer - (Plot_enhancer - 1))
        plt.title("Roll acceleration limit: "+str(roll_value)+" rad/s^2")
        plt.xlabel(xaxis)
        plt.ylabel(yaxis)
        plt.savefig(
            "Figures/Test_{}/Heatmaps/5Acc_Roll_Heatmap_Limit_{}-{}".format(f"{Last_Test_Number:05d}", f"{First_Test_Number:05d}",
                                                                          f"{Last_Test_Number:05d}", loopname))
        
        #TOTAL LIMIT PLOT
        plt.figure(figsize=(9.5, 5.3))
        sb.heatmap(limit_acc_tot, cmap="Greens")
        plt.yticks(np.arange(len(y_axis_ticks)) / (len(y_axis_ticks) - 1) * (len(map_sway_loc_enhanced) - 1) + 0.5,
                   np.round(y_axis_ticks, y_decimals), rotation=0)
        plt.xticks(np.arange(len(x_axis_ticks)) / (len(x_axis_ticks) - 1) * (len(map_sway_loc_enhanced[0]) - 1) + 0.5,
                   np.round(x_axis_ticks, x_decimals), rotation=0)
        plt.xlim(0, len(x_axis_range) * Plot_enhancer - (Plot_enhancer - 1))
        plt.ylim(0, len(y_axis_range) * Plot_enhancer - (Plot_enhancer - 1))
        plt.title("Total acceleration limit: "+str(tot_value)+" m/s^2")
        plt.xlabel(xaxis)
        plt.ylabel(yaxis)
        plt.savefig(
            "Figures/Test_{}/Heatmaps/6Acc_Total_Heatmap_Limit_{}-{}".format(f"{Last_Test_Number:05d}", f"{First_Test_Number:05d}",
                                                                       f"{Last_Test_Number:05d}", loopname))


    #txt file to show the changes made in the various tests
    sensdata = open("Figures/Test_{}/Sens_Test_{}-{}.txt".format(f"{Last_Test_Number:05d}", f"{First_Test_Number:05d}",
                                                                 f"{Last_Test_Number:05d}"), 'w')

    sensdata.write("First test number:              ")
    sensdata.write(f"{First_Test_Number:05d}")
    sensdata.write("\n")

    sensdata.write("Last test number:               ")
    sensdata.write(str(f"{Last_Test_Number:05d}"))
    sensdata.write("\n \n")

    sensdata.write("Sensitivity analysis on:        ")
    sensdata.write(str(loopname))
    sensdata.write("\n \n")

    computation_list_extra = np.zeros((len(computation_list),3))
    for i in range (len(computation_list)):
        computation_list_extra[i][0] = computation_list[i][0]
        computation_list_extra[i][1] = computation_list[i][1]
        computation_list_extra[i][2] = First_Test_Number + i

    sensdata.write("Values:        ")
    sensdata.write("\n")
    sensdata.write(str(computation_list_extra))
    sensdata.write("\n")
    sensdata.close()
    
    np.savetxt("Figures/Test_{}/Sens_Test_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname), computation_list_extra, delimiter=',')

    # rename first and last folder to appear more visible in results folder
    os.rename("Figures/Test_{}".format(f"{First_Test_Number:05d}"),
              "Figures/Test_{} - start".format(f"{First_Test_Number:05d}"))
    os.rename("Figures/Test_{}".format(f"{Last_Test_Number:05d}"),
              "Figures/Test_{} - finish".format(f"{Last_Test_Number:05d}"))

    return ()



if __name__ == "__main__":
    now = datetime.now()
    current_time = now.strftime("%H:%M:%S")
    print(current_time)

    # Product("WaveHeight_Length", 2690,[0.1,1.2,0.1])
    Product("WaveHeight_Length_ResultingDes", 8850,[0.28,2.07,0.25],True, True, False)

    now = datetime.now()
    current_time = now.strftime("%H:%M:%S")
    print(current_time)







#Product(NEEM, FirstNumber,Rangetickstuff):


# def Product(NEEM, FirstNumber,Rangetickstuff, GenerateData = True ,MakePlot = False,LoadData = False):