import numpy as np

def Enhance(Small_Matrix, Plot_enhancer):

    """"
    Function to interpolate the heat map values so smooth lines will form
    """

    Large_Matrix = np.zeros((int(len(Small_Matrix) + (len(Small_Matrix) - 1) * (Plot_enhancer - 1)),
                                      int(len(Small_Matrix[0]) + (len(Small_Matrix[0]) - 1) * (Plot_enhancer - 1))))

    for i in range(len(Large_Matrix)):
        for j in range(len(Large_Matrix[0])):
            i_real = i / Plot_enhancer
            j_real = j / Plot_enhancer

            i_round_down = int(i_real)
            j_round_down = int(j_real)

            if i_round_down == (len(Small_Matrix) - 1):
                i_round_down = i_round_down - 1

            if j_round_down == (len(Small_Matrix[0]) - 1):
                j_round_down = j_round_down - 1

            i_zero_one_space = i_real - i_round_down
            j_zero_one_space = j_real - j_round_down

            # Topleft
            if i_round_down == 0 and j_round_down == 0:
                [[y11, y12, y13], [y21, y22, y23], [y31, y32, y33]] = Small_Matrix[i_round_down:i_round_down + 3,
                                                                      j_round_down:j_round_down + 3]

                ConstantA = -y21 + (1 / 2) * y11 + (1 / 2) * y31
                ConstantB = y21 - (1 / 2) * y11 - (1 / 2) * y31
                ConstantC = y21 - y11
                ConstantD = -y12 + (1 / 2) * y11 + (1 / 2) * y13
                ConstantE = y12 - (1 / 2) * y11 - (1 / 2) * y13
                ConstantF = y12 - y11
                ConstantG = -3 * y12 * (1 / 2) + 3 * y11 * (1 / 2) + 2 * y22 - 2 * y21 - (1 / 2) * y32 + (1 / 2) * y31
                ConstantH = -2 * y12 + 3 * y11 * (1 / 2) + 2 * y22 - 3 * y21 * (1 / 2) - (1 / 2) * y23 + (1 / 2) * y13
                ConstantI = -(1 / 2) * y11 + (1 / 2) * y12 - y22 + y21 + (1 / 2) * y32 - (1 / 2) * y31
                ConstantJ = y12 - y11 - y22 + y21
                ConstantK = -(1 / 2) * y11 + y12 - y22 + (1 / 2) * y21 + (1 / 2) * y23 - (1 / 2) * y13
                ConstantL = y11

            #TopRight
            elif i_round_down == 0 and j_round_down == len(Small_Matrix[0]) - 2:
                [[y10, y11, y12], [y20, y21, y22], [y30, y31, y32]] = Small_Matrix[i_round_down:i_round_down + 3,
                                                                      j_round_down - 1:j_round_down + 2]

                ConstantA = -y21 + (1 / 2) * y11 + (1 / 2) * y31
                ConstantB = y21 - (1 / 2) * y11 - (1 / 2) * y31
                ConstantC = y21 - y11
                ConstantD = -(1 / 2) * y12 + y11 - (1 / 2) * y10
                ConstantE = y12 - 2 * y11 + y10
                ConstantF = (1 / 2) * y12 - (1 / 2) * y10
                ConstantG = (1 / 2) * y11 - y21 + 3 * y22 * (1 / 2) - y12 - (1 / 2) * y32 + (1 / 2) * y31 - (
                        1 / 2) * y20 + (1 / 2) * y10
                ConstantH = -2 * y21 + 2 * y11 - 3 * y12 * (1 / 2) + 3 * y22 * (1 / 2) + (1 / 2) * y20 - (1 / 2) * y10
                ConstantI = -(1 / 2) * y11 + y21 - y22 + (1 / 2) * y12 + (1 / 2) * y32 - (1 / 2) * y31
                ConstantJ = -(1 / 2) * y22 + (1 / 2) * y20 + (1 / 2) * y12 - (1 / 2) * y10
                ConstantK = (1 / 2) * y12 - y11 + y21 - (1 / 2) * y22 - (1 / 2) * y20 + (1 / 2) * y10
                ConstantL = y11

            #BottomLeft
            elif i_round_down == len(Small_Matrix) - 2 and j_round_down == 0:
                [[y01, y02, y03], [y11, y12, y13], [y21, y22, y23]] = Small_Matrix[i_round_down - 1:i_round_down + 2,
                                                                      j_round_down:j_round_down + 3]

                ConstantA = -(1 / 2) * y21 + y11 - (1 / 2) * y01
                ConstantB = y21 - 2 * y11 + y01
                ConstantC = (1 / 2) * y21 - (1 / 2) * y01
                ConstantD = -y12 + (1 / 2) * y11 + (1 / 2) * y13
                ConstantE = y12 - (1 / 2) * y11 - (1 / 2) * y13
                ConstantF = y12 - y11
                ConstantG = -2 * y12 + 2 * y11 - 3 * y21 * (1 / 2) + 3 * y22 * (1 / 2) + (1 / 2) * y02 - (1 / 2) * y01
                ConstantH = 3 * y22 * (1 / 2) - (1 / 2) * y02 - y21 + (1 / 2) * y01 + (1 / 2) * y11 - y12 - (
                            1 / 2) * y23 + (1 / 2) * y13
                ConstantI = (1 / 2) * y21 - y11 + y12 - (1 / 2) * y22 - (1 / 2) * y02 + (1 / 2) * y01
                ConstantJ = -(1 / 2) * y22 + (1 / 2) * y02 + (1 / 2) * y21 - (1 / 2) * y01
                ConstantK = -(1 / 2) * y11 + y12 - y22 + (1 / 2) * y21 + (1 / 2) * y23 - (1 / 2) * y13
                ConstantL = y11

            #BottomRight
            elif i_round_down == len(Small_Matrix) - 2 and j_round_down == len(Small_Matrix[0]) - 2:
                [[y00, y01, y02], [y10, y11, y12], [y20, y21, y22]] = Small_Matrix[i_round_down - 1:i_round_down + 2,
                                                                      j_round_down - 1:j_round_down + 2]

                ConstantA = -(1 / 2) * y21 + y11 - (1 / 2) * y01
                ConstantB = y21 - 2 * y11 + y01
                ConstantC = (1 / 2) * y21 - (1 / 2) * y01
                ConstantD = -(1 / 2) * y12 + y11 - (1 / 2) * y10
                ConstantE = y12 - 2 * y11 + y10
                ConstantF = (1 / 2) * y12 - (1 / 2) * y10
                ConstantG = -(1 / 2) * y21 + y11 + y22 + (1 / 2) * y02 - (1 / 2) * y01 - 3 * y12 * (1 / 2) - (
                            1 / 2) * y20 + (1 / 2) * y10
                ConstantH = -(1 / 2) * y12 + y11 + y22 + (1 / 2) * y20 - (1 / 2) * y10 - 3 * y21 * (1 / 2) - (
                            1 / 2) * y02 + (1 / 2) * y01
                ConstantI = (1 / 2) * y21 - y11 - (1 / 2) * y22 - (1 / 2) * y02 + (1 / 2) * y01 + y12
                ConstantJ = -(1 / 2) * y21 - (1 / 2) * y12 + y11 + (1 / 2) * y20 - (1 / 2) * y10 + (1 / 2) * y02 - (
                            1 / 2) * y01
                ConstantK = (1 / 2) * y12 - y11 - (1 / 2) * y22 - (1 / 2) * y20 + (1 / 2) * y10 + y21
                ConstantL = y11

            # Top
            elif i < Plot_enhancer and j > Plot_enhancer - 1 and j < len(
                Large_Matrix[0]) - Plot_enhancer - 1:
                [[y10, y11, y12, y13], [y20, y21, y22, y23], [y30, y31, y32, y33]] = Small_Matrix[
                                                                                     i_round_down:i_round_down + 3,
                                                                                     j_round_down - 1:j_round_down + 3]

                ConstantA = -y21 + (1 / 2) * y11 + (1 / 2) * y31
                ConstantB = y21 - (1 / 2) * y11 - (1 / 2) * y31
                ConstantC = y21 - y11
                ConstantD = (1 / 2) * y13 + 3 * y11 * (1 / 2) - 3 * y12 * (1 / 2) - (1 / 2) * y10
                ConstantE = -(1 / 2) * y13 - 5 * y11 * (1 / 2) + 2 * y12 + y10
                ConstantF = (1 / 2) * y12 - (1 / 2) * y10
                ConstantG = (1 / 2) * y11 - y21 + 3 * y22 * (1 / 2) - y12 - (1 / 2) * y32 + (1 / 2) * y31 - (
                        1 / 2) * y20 + (1 / 2) * y10
                ConstantH = -5 * y21 * (1 / 2) + 5 * y11 * (1 / 2) + 5 * y22 * (1 / 2) - 5 * y12 * (1 / 2) - (
                        1 / 2) * y23 + (1 / 2) * y13 + (1 / 2) * y20 - (1 / 2) * y10
                ConstantI = -(1 / 2) * y11 + y21 - y22 + (1 / 2) * y12 + (1 / 2) * y32 - (1 / 2) * y31
                ConstantJ = -(1 / 2) * y22 + (1 / 2) * y20 + (1 / 2) * y12 - (1 / 2) * y10
                ConstantK = 3 * y21 * (1 / 2) - 3 * y11 * (1 / 2) - 3 * y22 * (1 / 2) + 3 * y12 * (1 / 2) + (
                        1 / 2) * y23 - (1 / 2) * y13 - (1 / 2) * y20 + (1 / 2) * y10
                ConstantL = y11


            # Bottom
            elif i > len(Large_Matrix) - Plot_enhancer - 2 and j > Plot_enhancer - 1 and j < len(
                Large_Matrix[0]) - Plot_enhancer - 1:
                # sway
                [[y00, y01, y02, y03], [y10, y11, y12, y13], [y20, y21, y22, y23]] = Small_Matrix[
                                                                                     i_round_down - 1:i_round_down + 2,
                                                                                     j_round_down - 1:j_round_down + 3]

                ConstantA = -(1 / 2) * y21 + y11 - (1 / 2) * y01
                ConstantB = y21 - 2 * y11 + y01
                ConstantC = (1 / 2) * y21 - (1 / 2) * y01
                ConstantD = (1 / 2) * y13 + 3 * y11 * (1 / 2) - 3 * y12 * (1 / 2) - (1 / 2) * y10
                ConstantE = -(1 / 2) * y13 - 5 * y11 * (1 / 2) + 2 * y12 + y10
                ConstantF = (1 / 2) * y12 - (1 / 2) * y10
                ConstantG = -(1 / 2) * y21 + y11 + y22 + (1 / 2) * y02 - (1 / 2) * y01 - 3 * y12 * (1 / 2) - (
                        1 / 2) * y20 + (1 / 2) * y10
                ConstantH = -(1 / 2) * y23 - 2 * y21 + 3 * y11 * (1 / 2) + (1 / 2) * y13 + 2 * y22 + (
                        1 / 2) * y20 - 3 * y12 * (1 / 2) - (1 / 2) * y10 - (1 / 2) * y02 + (1 / 2) * y01
                ConstantI = (1 / 2) * y21 - y11 - (1 / 2) * y22 - (1 / 2) * y02 + (1 / 2) * y01 + y12
                ConstantJ = -(1 / 2) * y21 - (1 / 2) * y12 + y11 + (1 / 2) * y20 - (1 / 2) * y10 + (1 / 2) * y02 - (
                        1 / 2) * y01
                ConstantK = (1 / 2) * y23 + 3 * y21 * (1 / 2) - 3 * y11 * (1 / 2) - (1 / 2) * y13 - 3 * y22 * (
                            1 / 2) - (
                                    1 / 2) * y20 + 3 * y12 * (1 / 2) + (1 / 2) * y10
                ConstantL = y11

            # Left
            elif i > Plot_enhancer - 1 and i < len(Large_Matrix) - Plot_enhancer - 1 and j < Plot_enhancer:
                [[y01, y02, y03], [y11, y12, y13], [y21, y22, y23], [y31, y32, y33]] = Small_Matrix[
                                                                                       i_round_down - 1:i_round_down + 3,
                                                                                       j_round_down:j_round_down + 3]

                ConstantA = (1 / 2) * y31 + 3 * y11 * (1 / 2) - 3 * y21 * (1 / 2) - (1 / 2) * y01
                ConstantB = -(1 / 2) * y31 - 5 * y11 * (1 / 2) + 2 * y21 + y01
                ConstantC = (1 / 2) * y21 - (1 / 2) * y01
                ConstantD = -y12 + (1 / 2) * y11 + (1 / 2) * y13
                ConstantE = y12 - (1 / 2) * y11 - (1 / 2) * y13
                ConstantF = y12 - y11
                ConstantG = -5 * y12 * (1 / 2) + 5 * y11 * (1 / 2) + 5 * y22 * (1 / 2) - 5 * y21 * (1 / 2) - (
                        1 / 2) * y32 + (1 / 2) * y31 + (1 / 2) * y02 - (1 / 2) * y01
                ConstantH = 3 * y22 * (1 / 2) - (1 / 2) * y02 - y21 + (1 / 2) * y01 + (1 / 2) * y11 - y12 - (
                        1 / 2) * y23 + (1 / 2) * y13
                ConstantI = 3 * y12 * (1 / 2) - 3 * y11 * (1 / 2) - 3 * y22 * (1 / 2) + 3 * y21 * (1 / 2) + (
                        1 / 2) * y32 - (1 / 2) * y31 - (1 / 2) * y02 + (1 / 2) * y01
                ConstantJ = -(1 / 2) * y22 + (1 / 2) * y02 + (1 / 2) * y21 - (1 / 2) * y01
                ConstantK = -(1 / 2) * y11 + y12 - y22 + (1 / 2) * y21 + (1 / 2) * y23 - (1 / 2) * y13
                ConstantL = y11


            # Right
            elif i > Plot_enhancer - 1 and i < len(Large_Matrix) - Plot_enhancer and j > len(
                    Large_Matrix[0]) - Plot_enhancer - 2:
                [[y00, y01, y02], [y10, y11, y12], [y20, y21, y22], [y30, y31, y32]] = Small_Matrix[
                                                                                       i_round_down - 1:i_round_down + 3,
                                                                                       j_round_down - 1:j_round_down + 2]

                ConstantA = (1 / 2) * y31 + 3 * y11 * (1 / 2) - 3 * y21 * (1 / 2) - (1 / 2) * y01
                ConstantB = -(1 / 2) * y31 - 5 * y11 * (1 / 2) + 2 * y21 + y01
                ConstantC = (1 / 2) * y21 - (1 / 2) * y01
                ConstantD = -(1 / 2) * y12 + y11 - (1 / 2) * y10
                ConstantE = y12 - 2 * y11 + y10
                ConstantF = (1 / 2) * y12 - (1 / 2) * y10
                ConstantG = -(1 / 2) * y32 - 2 * y12 + 3 * y11 * (1 / 2) + (1 / 2) * y31 + 2 * y22 + (
                            1 / 2) * y02 - 3 * y21 * (1 / 2) - (1 / 2) * y01 - (1 / 2) * y20 + (1 / 2) * y10
                ConstantH = -(1 / 2) * y12 + y11 + y22 + (1 / 2) * y20 - (1 / 2) * y10 - 3 * y21 * (1 / 2) - (
                            1 / 2) * y02 + (1 / 2) * y01
                ConstantI = (1 / 2) * y32 + 3 * y12 * (1 / 2) - 3 * y11 * (1 / 2) - (1 / 2) * y31 - 3 * y22 * (1 / 2) - (
                            1 / 2) * y02 + 3 * y21 * (1 / 2) + (1 / 2) * y01
                ConstantJ = -(1 / 2) * y21 - (1 / 2) * y12 + y11 + (1 / 2) * y20 - (1 / 2) * y10 + (1 / 2) * y02 - (
                            1 / 2) * y01
                ConstantK = (1 / 2) * y12 - y11 - (1 / 2) * y22 - (1 / 2) * y20 + (1 / 2) * y10 + y21
                ConstantL = y11


            # Midfield
            elif i_round_down != 0 and i_round_down != len(Small_Matrix) - 2 and j_round_down != 0 and j_round_down != len(
                    Small_Matrix[0]) - 2:
                [[y00, y01, y02, y03], [y10, y11, y12, y13], [y20, y21, y22, y23], [y30, y31, y32, y33]] = Small_Matrix[
                                                                                                           i_round_down - 1:i_round_down + 3,
                                                                                                           j_round_down - 1:j_round_down + 3]

                ConstantA = (1 / 2) * y31 + 3 * y11 * (1 / 2) - 3 * y21 * (1 / 2) - (1 / 2) * y01
                ConstantB = -(1 / 2) * y31 - 5 * y11 * (1 / 2) + 2 * y21 + y01
                ConstantC = (1 / 2) * y21 - (1 / 2) * y01
                ConstantD = (1 / 2) * y13 + 3 * y11 * (1 / 2) - 3 * y12 * (1 / 2) - (1 / 2) * y10
                ConstantE = -(1 / 2) * y13 - 5 * y11 * (1 / 2) + 2 * y12 + y10
                ConstantF = (1 / 2) * y12 - (1 / 2) * y10
                ConstantG = -(1 / 2) * y32 - 2 * y12 + 3 * y11 * (1 / 2) + (1 / 2) * y31 + 2 * y22 + (
                            1 / 2) * y02 - 3 * y21 * (1 / 2) - (1 / 2) * y01 - (1 / 2) * y20 + (1 / 2) * y10
                ConstantH = -(1 / 2) * y23 - 2 * y21 + 3 * y11 * (1 / 2) + (1 / 2) * y13 + 2 * y22 + (
                            1 / 2) * y20 - 3 * y12 * (1 / 2) - (1 / 2) * y10 - (1 / 2) * y02 + (1 / 2) * y01
                ConstantI = (1 / 2) * y32 + 3 * y12 * (1 / 2) - 3 * y11 * (1 / 2) - (1 / 2) * y31 - 3 * y22 * (1 / 2) - (
                            1 / 2) * y02 + 3 * y21 * (1 / 2) + (1 / 2) * y01
                ConstantJ = -(1 / 2) * y21 - (1 / 2) * y12 + y11 + (1 / 2) * y20 - (1 / 2) * y10 + (1 / 2) * y02 - (
                            1 / 2) * y01
                ConstantK = (1 / 2) * y23 + 3 * y21 * (1 / 2) - 3 * y11 * (1 / 2) - (1 / 2) * y13 - 3 * y22 * (1 / 2) - (
                            1 / 2) * y20 + 3 * y12 * (1 / 2) + (1 / 2) * y10
                ConstantL = y11

            Large_Matrix[i, j] = ConstantA * i_zero_one_space ** 3 \
                                 + ConstantB * i_zero_one_space ** 2 \
                                 + ConstantC * i_zero_one_space \
                                 + ConstantD * j_zero_one_space ** 3 \
                                 + ConstantE * j_zero_one_space ** 2 \
                                 + ConstantF * j_zero_one_space \
                                 + ConstantG * i_zero_one_space ** 2 * j_zero_one_space \
                                 + ConstantH * i_zero_one_space * j_zero_one_space ** 2 \
                                 + ConstantI * i_zero_one_space ** 3 * j_zero_one_space \
                                 + ConstantJ * i_zero_one_space ** 2 * j_zero_one_space ** 2 \
                                 + ConstantK * i_zero_one_space * j_zero_one_space ** 3 \
                                 + ConstantL

    return (Large_Matrix)

def BlackLine(Large_Matrix, Plot_enhancer):
    """"
    Finds maximum and minimum values for every x value, makes black lines for maximum and minimum
    """

    # empty array to store y value with maimum z value for every x
    CriticalLine_Max = np.zeros(int(len(Large_Matrix[0])/Plot_enhancer*10))
    CriticalLine_Min = np.zeros(int(len(Large_Matrix[0])/Plot_enhancer*10))

    # find the highest z value and store corrsponding y value for every x
    for i in range(len(CriticalLine_Max)):
        Temp_Max = -10**20
        Temp_Min = 10**20
        for j in range (len(Large_Matrix)):
            if Large_Matrix[j,int(i*Plot_enhancer/10)] > Temp_Max:
                Temp_Max = Large_Matrix[j,int(i*Plot_enhancer/10)]
                Location_Max = j
            if Large_Matrix[j,int(i*Plot_enhancer/10)] < Temp_Min:
                Temp_Min = Large_Matrix[j,int(i*Plot_enhancer/10)]
                Location_Min = j

        if Location_Max == 0 or Location_Max == len(Large_Matrix) -1:
            Location_Max = np.nan

        if Location_Min == 0 or Location_Min == len(Large_Matrix) -1:
            Location_Min = np.nan

        CriticalLine_Max[i] = Location_Max
        CriticalLine_Min[i] = Location_Min

    # gridpoint number
    x_axis = np.linspace(0,len(CriticalLine_Max)-1,len(CriticalLine_Max))

    # check if curvefit is possible
    MaxFit = False
    MinFit = False

    for i in range (len(CriticalLine_Max)):
        if np.isnan(CriticalLine_Max[i]) == False:
            MaxFit = True
        if np.isnan(CriticalLine_Min[i]) == False:
            MinFit = True

    #Curvefit if possible
    if MaxFit == True:
        idx = np.isfinite(CriticalLine_Max)
        Max_coeff = np.polyfit(x_axis[idx], CriticalLine_Max[idx], 3)

        for i in range(len(CriticalLine_Max)):
            CriticalLine_Max[i] = Max_coeff[0] * x_axis[i]**3 + Max_coeff[1] * x_axis[i]**2 + Max_coeff[2] * x_axis[i] + Max_coeff[3]

    if MinFit == True:
        idx = np.isfinite(CriticalLine_Min)
        Min_coeff = np.polyfit(x_axis[idx], CriticalLine_Min[idx], 3)

        for i in range(len(CriticalLine_Min)):
            CriticalLine_Min[i] = Min_coeff[0] * x_axis[i]**3 + Min_coeff[1] * x_axis[i]**2 + Min_coeff[2] * x_axis[i] + Min_coeff[3]

    return (CriticalLine_Min, CriticalLine_Max)