  # import of libraries
import numpy as np
# from sympy import tanh, sqrt, symbols, nsolve
import Core


def Main(loopname, loopvalue, showplotoverride, HeatMapTestNumber, HeatMapRound):

    ########################################## TO DO ###############################
    #Total energy plot
    #Average acceleration and location integration in the inertia of the FFturbine (grid cells for also in vertical direction)
    #Average sway, heave, roll displacement and acceleration output for the heatmap function. Such that these values of several test can be integrated in on figure for the sensitivity analysis
    #Inbouwen dat bij de heatmap figures alleen de golfhoogte-golflengte relaties worden gebruikt die realistisch zijn....
    #MAking RAO's with a fixed x-axis.
    #Improving the total plot heatmap figurese to a easier understandable figure





    ################################################## ENVIRONMENTAL CONDITIONS ########################################

    # Physics
    rho = 1025  #kg/m3
    g = 9.8 #m/s2

    # Circumstances
    depth = 23.3 #m               # Average depth
    Tidal_level = 0 #m
    flow_velocity = 0 # m/s
    Wind_Distributed_Load_Deck = 2120 #N/m           (2120)
    Wind_Distributed_Load_Super_Structure = 3000 #N/m   (3000)
    Traffic_load = 128000 #kg
    Num_wave_periods = 8 #Number of wave periods in simulation #Default is 8

    ################################################ COMPUTATION OPTIONS ########################################
    
    # Simulation time
    Total_time = 30   #seconds This value is overwritten in case showplotoverride==3 or showplotoverride==4
#    Total_time = 2

    # Timestep
    time_step = 0.10    #seconds This value is overwritten in case showplotoverride==3 or showplotoverride==4
                                    
    # first smooth_time seconds, forces will be smoothened to allow for faster computation.
    # smooth_time = Total_time*0.7 #s
    # smooth_factor = 0.4
    smooth_factor = 0.5
    
    Show_plot = True
#    Show_plot = False

    # Show_Tidal_Displacement_In_Plot = True
    Show_Tidal_Displacement_In_Plot = False

    # Three_Dimensional_Calculation = True
    Three_Dimensional_Calculation = False                   #So that would be 2D for middle segment only

    Smooth_Start = True
    # Smooth_Start = False                              #Option to avoid jumpy behaviour by using gradually rising force

    #Approaching_Wave_Field = True                    # Makes waves arrive later. To assess initial impact of waves
    Approaching_Wave_Field = False

    Make_Animation = True
    # Make_Animation = False                                # only works for 2D

    # Add_Wind = True
    Add_Wind = False
    if Add_Wind == True:
        Wind_Deck_Force = True
        Wind_Super_Structure_Force = True
    else:
        Wind_Deck_Force = False
        Wind_Super_Structure_Force = False

    Add_Flow = True
    # Add_Flow = False
    if Add_Flow == True:
        Current_Force = True
        Turbine_Force = True
        Pendulum_Drag_Force = True
    else:
        flow_velocity = 0
        Current_Force = True ##
        Turbine_Force = True
        Pendulum_Drag_Force = True

    Add_Waves = True
    # Add_Waves = False
    if Add_Waves == True:
        Wave_Force = True
    else:
        Wave_Force = False

    # Traffic_Force = True   #The traffic force does only make an addition of the mass and moment of inertia of the segmenet.
    Traffic_Force = False  #The traffic force does only make an addition of the mass and moment of inertia of the segmenet.

    # Constant_force = True                #test force to check the numerical scheme
    Constant_force = False                 #test force

    # Integration_Of_Ansys_Aqwa_mass = True
    Integration_Of_Ansys_Aqwa_mass = False                              #Based on literature

    # Integration_Of_Ansys_Aqwa_damp = True
    Integration_Of_Ansys_Aqwa_damp = False                              #Based on literature

    ExperimentalAddition = True
    # ExperimentalAddition = False                                        #Use information based on experiments


    #Damping measures
    Sway_Plate_Force = False
#    Sway_Plate_Force = True

    Sway_Plate_Force_Design3 = False
#    Sway_Plate_Force_Design3 = True



    Heave_Plate_Force = False
#    Heave_Plate_Force = True

    second_level_heave = False
    # second_level_heave = True




#    Slosh_Force = True
    Slosh_Force = False

    Slosh_Force_test = False
    if Slosh_Force == True:
        # Slosh_Force_test = True
        Slosh_Force_test = False



    Turbine_test = False

    ################################################ STRUCTURE SETTINGS ################################################


    # Number of bridge segments
    segments = 3 #shall be 2 or more, 3 for 2D calculation
    Length_segment = 100  #m
    free_space_between_segments = 1  #m

    #Normal mass
    M_segment = 3000000  # kg
    Jx_segment = 460700000  # kg m2
    Jy_segment = 2608000000  # kg m2
    Jz_segment = 2692000000  # kg m2

    # Vertical position of various elements with respect to COG
    z_location_bottom_floater = -3.3    #m
    z_location_deck = 10.5  #m
    z_location_Super_Structure = 7.3 #m
    z_location_turbines = -7.5 #m For the new Fishflow turbines    
    width_deck = 11 #m

    # Pendulum information
    Angle_Pendulum_Mid_Tide = 40 / 180.  * np.pi  # degrees       # << 90 degrees
    Length_Pendulum = 30.7 * np.ones((segments-1) * 2) #m
    Pendulum_hinge_top_y_loc = 4.5  #m           respect to COG of segment (6.5 "real" value)
    Pendulum_hinge_top_z_loc = -4.74   #m          respect to COG of segment (-7.2 is estimate from drawing)
    Diameter_pendulum = 1.320* np.ones((segments-1) * 2)  #m

    # Floater information
    Number_of_small_floaters = 2 #plz dont touch that..
    Width_small_floater = 3.5    #m
    Length_small_floater = 34 #m

    Number_of_large_floaters = 3
    Width_large_floater = 5     #m
    Length_large_floater = 34   #m

    # Turbine information (between a single set of floaters)
    #Casing dimensions of the FishFlow turbines are
    N_turbines = (Number_of_large_floaters + Number_of_small_floaters - 1)*2
    Turbine_mass = 320000/2.     #This mass is included in the moment of inertia and the mass matrix
    Turbine_Volume = Turbine_mass/rho #Submerged volume. Here the assumption is made that the turbine floats.
    Turbine_depth = 1 #m the distance of the ToS of the turbine and the surface elevation
    FFTurbine_H = 10 #m
    FFTurbine_W = 9.5 #m
    FFTurbine_L = 26.5 #m
    FFTur_evalf_loc = 3.333 #m The distance from the top of the t
    Tur_grid_size = 0.5 #m
    Diameter_turbine_impeller = 8 #m Per fishflow turbine
    Induction_factor = 0.18756 #With help of an email of FishFlow Innovations
    Velocity_max_flow = 4.5 #m/s
    Force_max_flow = 0.5*rho*Velocity_max_flow**2*0.25*np.pi*Diameter_turbine_impeller**2*4*Induction_factor*(1-Induction_factor)  #N per turbine

    #horizontal added mass of one FishFlow turbine
    C_added_tur_hori = 2.23 #As specified in the  DNV-H103 on page 139 a/b=0.1 hence the Ca=2.23
    M_added_tur_hori = rho * C_added_tur_hori * np.pi*((FFTurbine_H-Diameter_turbine_impeller)/2+Diameter_turbine_impeller) * 2*0.5* 0.25*np.pi*((FFTurbine_H-Diameter_turbine_impeller)/2)**2

    #vertical added mass of one FishFlow turbine
    C_added_tur_vert = 1.3 #DNV-RP-H103 p139 a/b=2.6 --> Ca=1.3
    M_added_tur_vert = rho * (FFTurbine_W * (0.5 * np.pi * (FFTurbine_L/2)**2 * C_added_tur_vert + Turbine_depth * FFTurbine_L) + 
                              FFTurbine_H * FFTurbine_W * FFTurbine_L - 0.25 * np.pi * Diameter_turbine_impeller**2 * FFTurbine_L)

    #rotational added mass of one FishFlow turbine
    M_added_tur_rot = (z_location_turbines**2 * M_added_tur_hori + 
                       1/12 * (0.25 * np.pi * Diameter_turbine_impeller**2 * FFTurbine_L) * rho * (3 * (Diameter_turbine_impeller/2)**2 + FFTurbine_L**2))

    
    #Sway plate
    Sway_width = 98. #m
    Sway_height = 8.
    z_location_sway = -16.5 #m For the new Fishflow turbines    
    C_drag_sway = 1.9
    M_added_sway_plate = 0.25 * np.pi * Sway_height**2 * Sway_width * rho
    M_added_sway_plateD3 = Number_of_large_floaters * rho * Width_large_floater * (9 * 3 * 9 + 0.25 * np.pi * 9**2)
    sway_plate_num = int(1) #must be an integer

    
    #Heave plate
    n_plates = 3.
    Heave_dist_x = 10.
    Heave_dist_y = 35.
    z_location_heave = -19.8
    C_drag_sway = 1.9
    heave_plate_bottom_dist = 0
    M_added_heave_plate = n_plates * rho * (0.25 * np.pi * Heave_dist_x**2 * Heave_dist_y)
    M_added_heave_plate_roll = n_plates * rho * np.pi / 8. * (Heave_dist_y/2)**4 * Heave_dist_x
    
    height_second_level = 9 #m
    M_added_heave_plate_2 = n_plates * rho * (FFTurbine_L * height_second_level * Width_large_floater)
    M_added_heave_plate_roll_2 = n_plates * rho * np.pi /8. * (FFTurbine_L/2)**4 * Width_large_floater
    


    
    
    #Slosh damper
    Slosh_length = 9.5 #m
    Slosh_water_level = 2 #m
    Slosh_mass = 2*175000




    # Damping
    Damping_Pendulum = 0  * np.ones((segments-1) * 2) #Ns/m     #119400 true value
    Damping_Spudpole = [0,0]  #Ns/m
    Damping_connection_segments_y = 0    # Ns/m
    Damping_connection_segments_z = 0    # Ns/m

    # Stiffness
    Stiffness_Pendulum = 10**8 * np.ones((segments-1) * 2) #This is already corrected for a weak soil by a factor 10. This value is also determined by the Antea Group
#    Stiffness_Pendulum = 10**7 * np.ones((segments-1) * 2) #Making the stiffness larger means making the time step smaller #N/m
    Stiffness_Spudpole = 0 * np.ones(2) #[5.4*10**7,1.9*10**7] #N/m
    Stiffness_connection_segments_y = 0  #10 ** 6
    Stiffness_connection_segments_z = 0  #10 ** 6
    Stiffness_lean_factor = 0.2 #Nubmer between 0 and 1 that sets how much the hydrodynamic stiffness in heave direction from the adjacent element is taken into account

    # Coefficients for drag and added mass
    C_drag_pointed_rectangle = 1.15 #[-]   # 1.15 is probs to high
    C_drag_bottom_floater = 0.75  #[-]  #use half value as there is not turbulance on top side of floater   0.75 truth
    C_Added_Mass_Pointed_Tip_Reduction = 0.55 #[-] # 0.55 true value
    C_Added_Mass_Not_Infinite_Factor = 1 #[- `  xxx or 1.0?
    C_Marine_Growth_Extra = 1.1 #[-]   # 1.1 is expected to be more correct #Has to do with the added mass of the floater
    C_Damping_Pointed_Tip_Reduction = 0.8  #[-]
    C_drag_turbine = 1.3 #based on a KC number of 5
    C_radiation_turbine_sway_reduction = 0.4
    C_inertia = 1.0 #Inertia coefficient Hydro and Froude-Krylov force

    # Ansys Aqwa interaction file name and information
    Ansys_Aqwa_file_name = "ANALYSIS_TURBINE.LIS"
    Ansys_small_floater = np.array ( [ 2 , 3.5 , 34 ])
    Ansys_large_floater = np.array ( [ 3 , 5 , 34 ])
    Ansys_Mass = 2.32*10**6
    


    
    
    # loopfixers, to override parameters from the Looper.py
    if loopname == "WaveHeight_Length":
        Wave_height = loopvalue[0]
        Wave_length = Length_large_floater * loopvalue[1]
        flow_velocity = 0.  # m/s
        Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
        Wave_period = Wave_length / Wave_speed
        print(Wave_period, Wave_length)
        gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
        if showplotoverride==3:
            if loopvalue[0]*flow_velocity > 0:
                Total_time = 1.5 * Num_wave_periods * Wave_period
            else:
                Total_time = Num_wave_periods * Wave_period
            time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
            #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
        if showplotoverride==4:
            if loopvalue[0]*flow_velocity > 0:
                Total_time = 1.5 * Num_wave_periods * Wave_period
            else:
                Total_time = Num_wave_periods * Wave_period
            time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
    if loopname == "WaveHeight_Length_ResultingDes":
        Sway_Plate_Force = True

        Sway_width = 50.  # m
        Sway_height = 8.
        z_location_sway = -16.5  # m For the new Fishflow turbines
        C_drag_sway = 1.9
        M_added_sway_plate = 0.25 * np.pi * Sway_height ** 2 * Sway_width * rho
        M_added_sway_plateD3 = Number_of_large_floaters * rho * Width_large_floater * (
                    9 * 3 * 9 + 0.25 * np.pi * 9 ** 2)
        sway_plate_num = int(3)  # must be an integer

        Pendulum_hinge_top_y_loc = 13.5  # m           respect to COG of segment (6.5 "real" value)

        Wave_height = loopvalue[0]
        Wave_length = Length_large_floater * loopvalue[1]
        flow_velocity = 0.  # m/s
        Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
        Wave_period = Wave_length / Wave_speed
        print(Wave_period, Wave_length)
        gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
        if showplotoverride==3:
            if loopvalue[0]*flow_velocity > 0:
                Total_time = 1.5 * Num_wave_periods * Wave_period
            else:
                Total_time = Num_wave_periods * Wave_period
            time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
            #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
        if showplotoverride==4:
            if loopvalue[0]*flow_velocity > 0:
                Total_time = 1.5 * Num_wave_periods * Wave_period
            else:
                Total_time = Num_wave_periods * Wave_period
            time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
    if loopname == "WaveHeight_Length_small_inertia":
        C_inertia = 0.9  # Inertia coefficient Hydro and Froude-Krylov force
        Wave_height = loopvalue[0]
        Wave_length = Length_large_floater * loopvalue[1]
        flow_velocity = 0.  # m/s
        Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
        Wave_period = Wave_length / Wave_speed
        gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
        if showplotoverride==3:
            if loopvalue[0]*flow_velocity > 0:
                Total_time = 1.5 * Num_wave_periods * Wave_period
            else:
                Total_time = Num_wave_periods * Wave_period
            time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
            #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
        if showplotoverride==4:
            if loopvalue[0]*flow_velocity > 0:
                Total_time = 1.5 * Num_wave_periods * Wave_period
            else:
                Total_time = Num_wave_periods * Wave_period
            time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
    if loopname == "WaveHeight_Length_floater_length":
        Number_of_small_floaters = 2  # plz dont touch that..
        Width_small_floater = 3.5  # m
        Length_small_floater = 1.1*34  # m
        Number_of_large_floaters = 3
        Width_large_floater = 5  # m
        Length_large_floater = 1.1*34  # m

        Wave_height = loopvalue[0]
        Wave_length = Length_large_floater * loopvalue[1]
        flow_velocity = 0.  # m/s
        Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
        Wave_period = Wave_length / Wave_speed
        gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
        if showplotoverride==3:
            if loopvalue[0]*flow_velocity > 0:
                Total_time = 1.5 * Num_wave_periods * Wave_period
            else:
                Total_time = Num_wave_periods * Wave_period
            time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
            #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
        if showplotoverride==4:
            if loopvalue[0]*flow_velocity > 0:
                Total_time = 1.5 * Num_wave_periods * Wave_period
            else:
                Total_time = Num_wave_periods * Wave_period
            time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
    if loopname == "WaveHeight_Length_heave68":
        #Heave plate
        Heave_Plate_Force = True

        n_plates = 1.
        Heave_dist_x = 30.
        Heave_dist_y = 68.
        z_location_heave = -19.8
        C_drag_sway = 1.9
        heave_plate_bottom_dist = 5
        M_added_heave_plate = n_plates * rho * (heave_plate_bottom_dist*Heave_dist_x*Heave_dist_y +   0.5*0.25 * np.pi * Heave_dist_x**2 * 16.)
        
        
        
        
        Wave_height = loopvalue[0]
        Wave_length = Length_large_floater * loopvalue[1]
        flow_velocity = 0.  # m/s
        Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
        Wave_period = Wave_length / Wave_speed
        gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
        if showplotoverride==3:
            if loopvalue[0]*flow_velocity > 0:
                Total_time = 1.5 * Num_wave_periods * Wave_period
            else:
                Total_time = Num_wave_periods * Wave_period
            time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
            #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
        if showplotoverride==4:
            if loopvalue[0]*flow_velocity > 0:
                Total_time = 1.5 * Num_wave_periods * Wave_period
            else:
                Total_time = Num_wave_periods * Wave_period
            time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
    if loopname == "WaveHeight_Length_heave_upper":
        Heave_Plate_Force = True
        n_plates = 1.
        Heave_dist_x = 26.5
        Heave_dist_y = 15.
        z_location_heave = -12.5
        C_drag_sway = 1.9
        M_added_heave_plate = n_plates * rho * ( 0.5 * 0.25 * np.pi * Heave_dist_x ** 2 * Heave_dist_y + Heave_dist_y * 9 * Heave_dist_x)

        Wave_height = loopvalue[0]
        Wave_length = Length_large_floater * loopvalue[1]
        flow_velocity = 0.  # m/s
        Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
        Wave_period = Wave_length / Wave_speed
        gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
        if showplotoverride==3:
            if loopvalue[0]*flow_velocity > 0:
                Total_time = 1.5 * Num_wave_periods * Wave_period
            else:
                Total_time = Num_wave_periods * Wave_period
            time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
            #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
        if showplotoverride==4:
            if loopvalue[0]*flow_velocity > 0:
                Total_time = 1.5 * Num_wave_periods * Wave_period
            else:
                Total_time = Num_wave_periods * Wave_period
            time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
    # if loopname == "WaveHeight_Length_full_shorter_heave":
    #     Heave_Plate_Force = True
    #     n_plates = 1.
    #     Heave_dist_x = 30.
    #     Heave_dist_y = 68.
    #     z_location_heave = -19.8
    #     C_drag_sway = 1.9
    #     heave_plate_bottom_dist = 5
    #     C_within_turbines = 0.25  # Due to the turbines, all volume above the heave plates cannot be taken into account for the added mass. Only 25% can be taken into account
    #     M_added_heave_plate = n_plates * rho * (C_within_turbines * 0.5 * 0.25 * np.pi * Heave_dist_x ** 2 * Heave_dist_y + heave_plate_bottom_dist * Heave_dist_x * Heave_dist_y)
    #     M_added_heave_plate_roll = n_plates * rho * np.pi / 8. * (Heave_dist_y / 2) ** 4 * Heave_dist_x
    #     Wave_height = loopvalue[0]
    #     Wave_length = Length_large_floater * loopvalue[1]
    #     flow_velocity = 0.  # m/s
    #     Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
    #     Wave_period = Wave_length / Wave_speed
    #     gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
    #     if showplotoverride==3:
    #         if loopvalue[0]*flow_velocity > 0:
    #             Total_time = 1.5 * Num_wave_periods * Wave_period
    #         else:
    #             Total_time = Num_wave_periods * Wave_period
    #         time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
    #         #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
    #     if showplotoverride==4:
    #         if loopvalue[0]*flow_velocity > 0:
    #             Total_time = 1.5 * Num_wave_periods * Wave_period
    #         else:
    #             Total_time = Num_wave_periods * Wave_period
    #         time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
    # if loopname == "WaveHeight_Length_single_sway_70m":
    #     Sway_Plate_Force = True
    #     Sway_width = 70.  # m
    #     Sway_height = 8.
    #     z_location_sway = -16.5  # m For the new Fishflow turbines
    #     C_drag_sway = 1.9
    #     M_added_sway_plate = 0.25 * np.pi * Sway_height ** 2 * Sway_width * rho
    #     M_added_sway_plateD3 = Number_of_large_floaters * rho * Width_large_floater * (9 * 3 * 9 + 0.25 * np.pi * 9 ** 2)
    #     sway_plate_num = int(1)  # must be an integer
    #
    #     Wave_height = loopvalue[0]
    #     Wave_length = Length_large_floater * loopvalue[1]
    #     flow_velocity = 0.  # m/s
    #     Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
    #     Wave_period = Wave_length / Wave_speed
    #     gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
    #     if showplotoverride==3:
    #         if loopvalue[0]*flow_velocity > 0:
    #             Total_time = 1.5 * Num_wave_periods * Wave_period
    #         else:
    #             Total_time = Num_wave_periods * Wave_period
    #         time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
    #         #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
    #     if showplotoverride==4:
    #         if loopvalue[0]*flow_velocity > 0:
    #             Total_time = 1.5 * Num_wave_periods * Wave_period
    #         else:
    #             Total_time = Num_wave_periods * Wave_period
    #         time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
    # if loopname == "WaveHeight_Length_double_sway_70m":
    #     Sway_Plate_Force = True
    #     Sway_width = 70.  # m
    #     Sway_height = 8.
    #     z_location_sway = -16.5  # m For the new Fishflow turbines
    #     C_drag_sway = 1.9
    #     M_added_sway_plate = 0.25 * np.pi * Sway_height ** 2 * Sway_width * rho
    #     M_added_sway_plateD3 = Number_of_large_floaters * rho * Width_large_floater * (9 * 3 * 9 + 0.25 * np.pi * 9 ** 2)
    #     sway_plate_num = int(2)  # must be an integer
    #
    #     Wave_height = loopvalue[0]
    #     Wave_length = Length_large_floater * loopvalue[1]
    #     flow_velocity = 0.  # m/s
    #     Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
    #     Wave_period = Wave_length / Wave_speed
    #     gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
    #     if showplotoverride==3:
    #         if loopvalue[0]*flow_velocity > 0:
    #             Total_time = 1.5 * Num_wave_periods * Wave_period
    #         else:
    #             Total_time = Num_wave_periods * Wave_period
    #         time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
    #         #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec



    Alternative_prints = False
    if showplotoverride == 1:
        Show_plot = False
        Make_Animation = False
        Alternative_prints = True
        Approaching_Wave_Field = False

    if showplotoverride == 2:
        Show_plot = False
        Make_Animation = False
        Alternative_prints = True

    if showplotoverride == 3:
        Show_plot = False
        Make_Animation = False
        Alternative_prints = True
        Approaching_Wave_Field = False

    if showplotoverride == 4:
        Show_plot = False
        Make_Animation = False
        Alternative_prints = False
        Approaching_Wave_Field = False

    if Slosh_Force_test == True:
        Smooth_Start = False

    if Heave_Plate_Force == True:
        M_segment = 3194100  # kg
        Jx_segment = 550000000  # kg m2
        Jy_segment = 2754000000  # kg m2
        Jz_segment = 2786000000  # kg m2
        if second_level_heave == True:
            # M_segment = 3273000  # kg #This mass is for both decks
            # Jx_segment = 567000000  # kg m2 #This mass is for both decks
            # Jy_segment = 2796000000  # kg m2 #This mass is for both decks
            # Jz_segment = 2821000000  # kg m2 #This mass is for both decks
            M_segment = 3102000  # kg #This mass is valid for solely the upper deck
            Jx_segment = 482000000  # kg m2 #This mass is valid for solely the upper deck
            Jy_segment = 2662000000  # kg m2 #This mass is valid for solely the upper deck
            Jz_segment = 2737000000  # kg m2 #This mass is valid for solely the upper deck

    A_small_floater = Width_small_floater * Length_small_floater + 2 * 1 / 2. * Width_small_floater ** 2  # m2
    A_large_floater = Width_large_floater * Length_large_floater + 2 * 1 / 2. * Width_large_floater ** 2 * 0.5  # m2

    if Slosh_Force == True:
        draught = (M_segment - 8 * Turbine_Volume * rho)/ ((A_small_floater * Number_of_small_floaters + A_large_floater * Number_of_large_floaters) * rho)
        # draught = (M_segment - 8 * Turbine_Volume * rho + Slosh_mass)/ ((A_small_floater * Number_of_small_floaters + A_large_floater * Number_of_large_floaters) * rho)
    else:
        if Turbine_test == True:
            draught = (M_segment)/ ((A_small_floater * Number_of_small_floaters + A_large_floater * Number_of_large_floaters) * rho)
        else:
            draught = (M_segment - 8 * Turbine_Volume * rho)/ ((A_small_floater * Number_of_small_floaters + A_large_floater * Number_of_large_floaters) * rho)
    COG_to_surface = z_location_bottom_floater + draught

    # Cluster similar data into arrays
    J_segment = [Jx_segment,Jy_segment,Jz_segment]
    characteristics_small_floater = [Number_of_small_floaters, Width_small_floater, Length_small_floater]
    characteristics_large_floater = [Number_of_large_floaters, Width_large_floater, Length_large_floater]
    Damping_connection_segment = [Damping_connection_segments_y, Damping_connection_segments_z]
    Stiffness_connection_segment = [Stiffness_connection_segments_y, Stiffness_connection_segments_z]
    Pendulum_hinge_top_location = [Pendulum_hinge_top_y_loc, Pendulum_hinge_top_z_loc]
    Max_Turbine = [Force_max_flow * ((Number_of_large_floaters + Number_of_small_floaters -1) * 2), Velocity_max_flow]
    Angle_Pendulum = Angle_Pendulum_Mid_Tide * np.ones(2*segments - 2)
    Wave_hlp = [Wave_height, Wave_length, Wave_period]
    Ansys_char = [Ansys_small_floater, Ansys_large_floater, Ansys_Mass * np.ones(3)]
    Turbine_dimensions_HWL = [FFTurbine_H, FFTurbine_W, FFTurbine_L, Turbine_depth, Tur_grid_size, Turbine_Volume, N_turbines, FFTur_evalf_loc]
    Turbine_char = [Diameter_turbine_impeller, Induction_factor, C_added_tur_hori, C_added_tur_vert, C_drag_turbine]
    smooth_time = Total_time*smooth_factor
    Sway_plate_char = [Sway_width, Sway_height, z_location_sway, C_drag_sway, M_added_sway_plate, sway_plate_num]
    Heave_plate_char = [Heave_dist_x,Heave_dist_y,z_location_heave, heave_plate_bottom_dist, C_drag_sway,
                        M_added_heave_plate, M_added_heave_plate_roll, M_added_heave_plate_2, M_added_heave_plate_roll_2, second_level_heave, height_second_level, n_plates]
    Slosh_char = [Slosh_length, Slosh_water_level, Slosh_mass]
    

    Test_Number, Max_location, Max_acceleration, Max_F_Pendulum, Min_F_pendulum= Core.Core_function(Total_time, time_step, segments, Length_segment, free_space_between_segments,
                       characteristics_small_floater, characteristics_large_floater, M_segment, J_segment,
                       z_location_bottom_floater, z_location_deck, width_deck, z_location_Super_Structure, z_location_turbines, Turbine_char,
                       Length_Pendulum, Angle_Pendulum, Angle_Pendulum_Mid_Tide, Pendulum_hinge_top_location, Diameter_pendulum,
                       Stiffness_Pendulum, Stiffness_Spudpole, Stiffness_connection_segment, Damping_Pendulum,
                       Damping_Spudpole, Damping_connection_segment, Wind_Distributed_Load_Deck,
                       Wind_Distributed_Load_Super_Structure, Traffic_load, Max_Turbine, C_drag_pointed_rectangle, C_drag_bottom_floater,
                       C_Added_Mass_Pointed_Tip_Reduction, C_Added_Mass_Not_Infinite_Factor, C_Marine_Growth_Extra, C_Damping_Pointed_Tip_Reduction, Tidal_level, flow_velocity,
                       Wave_hlp, depth, rho, g, gridsize, smooth_time, Three_Dimensional_Calculation, Wind_Deck_Force, Wind_Super_Structure_Force,
                       Wave_Force, Pendulum_Drag_Force, Current_Force, Turbine_Force, Traffic_Force, Constant_force, Smooth_Start, Approaching_Wave_Field, Show_plot,
                       Show_Tidal_Displacement_In_Plot, Make_Animation, Alternative_prints, HeatMapTestNumber, HeatMapRound, Integration_Of_Ansys_Aqwa_mass, Integration_Of_Ansys_Aqwa_damp,
                       Ansys_Aqwa_file_name, Ansys_char, ExperimentalAddition,Stiffness_lean_factor,showplotoverride, M_added_tur_hori, M_added_tur_vert,M_added_tur_rot,Turbine_dimensions_HWL,draught,
                       C_radiation_turbine_sway_reduction, C_inertia, Sway_Plate_Force, COG_to_surface, Sway_plate_char, Heave_Plate_Force, Heave_plate_char, 
                       Slosh_char, Slosh_Force, Slosh_Force_test, loopname, Sway_Plate_Force_Design3, M_added_sway_plateD3)


    return(Max_location, Max_acceleration, Max_F_Pendulum, Min_F_pendulum, Wave_height, g, M_segment, Angle_Pendulum_Mid_Tide, Wave_period, Wave_length)



if __name__ == "__main__":
    # Max_location, Max_acceleration, Max_F_Pendulum, Min_F_pendulum, Wave_height, g, M_segment, Angle_Pendulum_Mid_Tide, Wave_period, Wave_length = Main(loopname, [WaveHeight/Draught,WaveLength/FloaterLength], showplotoverride, HeatMapTestNumber, HeatMapRound)
    Max_location, Max_acceleration, Max_F_Pendulum, Min_F_pendulum, Wave_height, g, M_segment, Angle_Pendulum_Mid_Tide, Wave_period, Wave_length = Main("WaveHeight_Length", [1.5,0.73], 0, 0, 14)




       # if loopname == "WaveHeight_Period":
       #  Wave_height = loopvalue[0] * draught
       #  Wave_period = loopvalue[1]
       #  flow_velocity = 0  # m/s
       #
       #
       #  Wave_length = Length_large_floater * loopvalue[1]
       #
       #  Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2 * np.pi * depth / Wave_length)) + flow_velocity
       #  Wave_period = Wave_length / Wave_speed
       #  gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
       #  if showplotoverride == 3:
       #    Total_time = Num_wave_periods * Wave_period
       #    time_step = 1 / (abs((loopvalue[0]) - 0.25) * 25 + 15)
       #    # time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
       #  if showplotoverride == 4:
       #    Total_time = Num_wave_periods * Wave_period
       #    time_step = 1 / ((abs(loopvalue[0]) - 0.25) * 25 + 15)





#if loopname == "WaveHeight_Length_slosh":
#        Wave_height = loopvalue[0] * draught
#        Wave_length = Length_large_floater * loopvalue[1]
#        flow_velocity = 0  # m/s
#        Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
#        Wave_period = Wave_length / Wave_speed
#        gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
#        if showplotoverride==3:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/(abs((loopvalue[0]) - 0.25)*25+15)
#            #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
#        if showplotoverride==4:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/((abs(loopvalue[0]) - 0.25)*25+15)
#        Slosh_mass = 6 * 175000
#    if loopname == "WaveHeight_Length_slosh20":
#        Wave_height = loopvalue[0] * draught
#        Wave_length = Length_large_floater * loopvalue[1]
#        flow_velocity = 0  # m/s
#        Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
#        Wave_period = Wave_length / Wave_speed
#        gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
#        if showplotoverride==3:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/(abs((loopvalue[0]) - 0.25)*25+15)
#            #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
#        if showplotoverride==4:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/((abs(loopvalue[0]) - 0.25)*25+15)
#        Slosh_mass = 4 * 175000
#    if loopname == "WaveHeight_Length_heave01":
#        Heave_Plate_Force = True
#        Wave_height = loopvalue[0] * draught
#        Wave_length = Length_large_floater * loopvalue[1]
#        flow_velocity = 0  # m/s
#        Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
#        Wave_period = Wave_length / Wave_speed
#        gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
#        if showplotoverride==3:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/(abs((loopvalue[0]) - 0.25)*25+15)
#            #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
#        if showplotoverride==4:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/((abs(loopvalue[0]) - 0.25)*25+15)
#        Heave_dist_x = 98
#        Heave_dist_y = 20.
#        z_location_heave = -19.8
#        heave_plate_bottom_dist = 5
#        C_drag_sway = 1.9
#        C_added_trapped = 1
#        M_added_heave_plate = rho * Heave_dist_x * Heave_dist_y * heave_plate_bottom_dist * C_added_trapped
#        M_added_heave_plate_roll = rho * np.pi / 8. * (Heave_dist_y/2)**4 * Heave_dist_x * (C_added_trapped + 3)/4.
#    if loopname == "WaveHeight_Length_heave1":
#        Wave_height = loopvalue[0] * draught
#        Wave_length = Length_large_floater * loopvalue[1]
#        flow_velocity = 0  # m/s
#        Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
#        Wave_period = Wave_length / Wave_speed
#        gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
#        if showplotoverride==3:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/(abs((loopvalue[0]) - 0.25)*25+15)
#            #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
#        if showplotoverride==4:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/((abs(loopvalue[0]) - 0.25)*25+15)
#        Heave_dist_x = 70
#        Heave_dist_y = 30.
#        z_location_heave = -19.8
#        heave_plate_bottom_dist = 5
#        C_drag_sway = 1.9
#        C_added_trapped = 1
#        M_added_heave_plate = rho * Heave_dist_x * Heave_dist_y * heave_plate_bottom_dist * C_added_trapped
#        M_added_heave_plate_roll = rho * np.pi / 8. * (Heave_dist_y/2)**4 * Heave_dist_x * (C_added_trapped + 3)/4.
#    if loopname == "WaveHeight_Length_heave2":
#        Wave_height = loopvalue[0] * draught
#        Wave_length = Length_large_floater * loopvalue[1]
#        flow_velocity = 0  # m/s
#        Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
#        Wave_period = Wave_length / Wave_speed
#        gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
#        if showplotoverride==3:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/(abs((loopvalue[0]) - 0.25)*25+15)
#            #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
#        if showplotoverride==4:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/((abs(loopvalue[0]) - 0.25)*25+15)
#        Heave_dist_x = 50
#        Heave_dist_y = 30.
#        z_location_heave = -19.8
#        heave_plate_bottom_dist = 5
#        C_drag_sway = 1.9
#        C_added_trapped = 1
#        M_added_heave_plate = rho * Heave_dist_x * Heave_dist_y * heave_plate_bottom_dist * C_added_trapped
#        M_added_heave_plate_roll = rho * np.pi / 8. * (Heave_dist_y/2)**4 * Heave_dist_x * (C_added_trapped + 3)/4.
#    if loopname == "WaveHeight_Length_heave3":
#        Wave_height = loopvalue[0] * draught
#        Wave_length = Length_large_floater * loopvalue[1]
#        flow_velocity = 0  # m/s
#        Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
#        Wave_period = Wave_length / Wave_speed
#        gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
#        if showplotoverride==3:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/(abs((loopvalue[0]) - 0.25)*25+15)
#            #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
#        if showplotoverride==4:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/((abs(loopvalue[0]) - 0.25)*25+15)
#        Heave_dist_x = 30
#        Heave_dist_y = 30.
#        z_location_heave = -19.8
#        heave_plate_bottom_dist = 5
#        C_drag_sway = 1.9
#        C_added_trapped = 1
#        M_added_heave_plate = rho * Heave_dist_x * Heave_dist_y * heave_plate_bottom_dist * C_added_trapped
#        M_added_heave_plate_roll = rho * np.pi / 8. * (Heave_dist_y/2)**4 * Heave_dist_x * (C_added_trapped + 3)/4.
#    if loopname == "WaveHeight_Length_sway1":
#        Sway_Plate_Force = True
#        Wave_height = loopvalue[0] * draught
#        Wave_length = Length_large_floater * loopvalue[1]
#        flow_velocity = 0  # m/s
#        Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
#        Wave_period = Wave_length / Wave_speed
#        gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
#        if showplotoverride==3:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/(abs((loopvalue[0]) - 0.25)*25+15)
#            #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
#        if showplotoverride==4:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/((abs(loopvalue[0]) - 0.25)*25+15)
#        #Sway plate
#        Sway_width = 50 #m
#        Sway_height = 8.
#        z_location_sway = -16.5 #m For the new Fishflow turbines    
#        C_drag_sway = 1.9
#        M_added_sway_plate = 0.25 * np.pi * Sway_height**2 * Sway_width * rho
#    if loopname == "Negative_WaveHeight_Length":
#        Wave_height = -loopvalue[0] * draught
#        Wave_length = Length_large_floater * loopvalue[1]
#        flow_velocity = 0  # m/s
#        Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
#        Wave_period = Wave_length / Wave_speed
#        gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
#        if showplotoverride==3:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/(abs((loopvalue[0]) - 0.25)*25+15)
#            #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
#        if showplotoverride==4:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/((abs(loopvalue[0]) - 0.25)*25+15)
#    if loopname == "WaveHeight_Length_PosCur2":
#        Wave_height = loopvalue[0] * draught
#        Wave_length = Length_large_floater * loopvalue[1]
#        flow_velocity = 2  # m/s
#        Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2 * np.pi * depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
#        Wave_period = Wave_length / Wave_speed
#        gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
#        if showplotoverride == 3:
#          Total_time = Num_wave_periods * Wave_period
#          time_step = 1 / (abs((loopvalue[0]) - 0.25) * 25 + 15)
#          # time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
#        if showplotoverride == 4:
#          Total_time = Num_wave_periods * Wave_period
#          time_step = 1 / ((abs(loopvalue[0]) - 0.25) * 25 + 15)
#    if loopname == "WaveHeight_Length_NegCur2":
#        Wave_height = loopvalue[0] * draught
#        Wave_length = Length_large_floater * loopvalue[1]
#        flow_velocity = -2  # m/s
#        Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2 * np.pi * depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
#        Wave_period = Wave_length / Wave_speed
#        gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
#        if showplotoverride == 3:
#          Total_time = Num_wave_periods * Wave_period
#          time_step = 1 / (abs((loopvalue[0]) - 0.25) * 25 + 15)
#          # time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
#        if showplotoverride == 4:
#          Total_time = Num_wave_periods * Wave_period
#          time_step = 1 / ((abs(loopvalue[0]) - 0.25) * 25 + 15)
#    if loopname == "Negative_WaveHeight_Length_PosCur2":
#        Wave_height = -loopvalue[0] * draught
#        Wave_length = Length_large_floater * loopvalue[1]
#        flow_velocity = 2  # m/s
#        Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2 * np.pi * depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
#        Wave_period = Wave_length / Wave_speed
#        gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
#        if showplotoverride == 3:
#          Total_time = Num_wave_periods * Wave_period
#          time_step = 1 / (abs((loopvalue[0]) - 0.25) * 25 + 15)
#          # time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
#        if showplotoverride == 4:
#          Total_time = Num_wave_periods * Wave_period
#          time_step = 1 / ((abs(loopvalue[0]) - 0.25) * 25 + 15)
#    if loopname == "Negative_WaveHeight_Length_NegCur2":
#        Wave_height = -loopvalue[0] * draught
#        Wave_length = Length_large_floater * loopvalue[1]
#        flow_velocity = -2  # m/s
#        Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2 * np.pi * depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
#        Wave_period = Wave_length / Wave_speed
#        gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
#        if showplotoverride == 3:
#            Total_time = Num_wave_periods * Wave_period
#            time_step = 1 / (abs((loopvalue[0]) - 0.25) * 25 + 15)
#            # time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
#        if showplotoverride == 4:
#            Total_time = Num_wave_periods * Wave_period
#            time_step = 1 / ((abs(loopvalue[0]) - 0.25) * 25 + 15)
       
#       if loopname == "WaveHeight_Length_only_upper_heave_plate":
#        Heave_Plate_Force = True
#        second_level_heave = True
#        Wave_height = loopvalue[0]
#        Wave_length = Length_large_floater * loopvalue[1]
#        flow_velocity = 0  # m/s
#        Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
#        Wave_period = Wave_length / Wave_speed
#        gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
#        if showplotoverride==3:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/(abs((loopvalue[0]) - 0.25)*25+15)
#            #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
#        if showplotoverride==4:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/((abs(loopvalue[0]) - 0.25)*25+15)
#    if loopname == "WaveHeight_Length_sway_design4":
#        Sway_Plate_Force = True
#        Sway_Plate_Force_Design3 = False
#        Sway_width = 50. #m
#        Sway_height = 8.
#        z_location_sway = -16.5 #m For the new Fishflow turbines    
#        C_drag_sway = 1.9
#        M_added_sway_plate = 0.25 * np.pi * Sway_height**2 * Sway_width * rho
#        M_added_sway_plateD3 = Number_of_large_floaters * rho * Width_large_floater * (9 * 3 * 9 + 0.25 * np.pi * 9**2)
#        sway_plate_num = int(2) #must be an integer
#        Wave_height = loopvalue[0]
#        Wave_length = Length_large_floater * loopvalue[1]
#        flow_velocity = 0  # m/s
#        Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
#        Wave_period = Wave_length / Wave_speed
#        gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
#        if showplotoverride==3:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/(abs((loopvalue[0]) - 0.25)*25+15)
#            #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
#        if showplotoverride==4:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/((abs(loopvalue[0]) - 0.25)*25+15)
#    if loopname == "WaveHeight_Length_sway_design4.1":
#        Sway_Plate_Force = True
#        Sway_Plate_Force_Design3 = False
#        Sway_width = 50. #m
#        Sway_height = 8.
#        z_location_sway = -16.5 #m For the new Fishflow turbines
#        C_drag_sway = 1.9
#        M_added_sway_plate = 0.25 * np.pi * Sway_height**2 * Sway_width * rho
#        M_added_sway_plateD3 = Number_of_large_floaters * rho * Width_large_floater * (9 * 3 * 9 + 0.25 * np.pi * 9**2)
#        sway_plate_num = int(3) #must be an integer
#        Wave_height = loopvalue[0]
#        Wave_length = Length_large_floater * loopvalue[1]
#        flow_velocity = 0  # m/s
#        Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
#        Wave_period = Wave_length / Wave_speed
#        gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
#        if showplotoverride==3:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/(abs((loopvalue[0]) - 0.25)*25+15)
#            #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
#        if showplotoverride==4:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/((abs(loopvalue[0]) - 0.25)*25+15)
#    if loopname == "WaveHeight_Length_sway_design5":
#        Sway_Plate_Force = True
#        Sway_Plate_Force_Design3 = False
#        Sway_width = 98. #m
#        Sway_height = 8.
#        z_location_sway = -16.5 #m For the new Fishflow turbines
#        C_drag_sway = 1.9
#        M_added_sway_plate = 0.25 * np.pi * Sway_height**2 * Sway_width * rho
#        M_added_sway_plateD3 = Number_of_large_floaters * rho * Width_large_floater * (9 * 3 * 9 + 0.25 * np.pi * 9**2)
#        sway_plate_num = int(2) #must be an integer
#        Wave_height = loopvalue[0]
#        Wave_length = Length_large_floater * loopvalue[1]
#        flow_velocity = 0  # m/s
#        Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
#        Wave_period = Wave_length / Wave_speed
#        gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
#        if showplotoverride==3:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/(abs((loopvalue[0]) - 0.25)*25+15)
#            #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
#        if showplotoverride==4:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/((abs(loopvalue[0]) - 0.25)*25+15)
#    if loopname == "WaveHeight_Length_without_Turbine":
#        Turbine_test = True
#        M_segment = 1600000  # kg
#        Jx_segment = 165000000  # kg m2
#        Jy_segment = 1477000000  # kg m2
#        Jz_segment = 1450000000  # kg m2
#        Wave_height = loopvalue[0]
#        Wave_length = Length_large_floater * loopvalue[1]
#        flow_velocity = 0  # m/s
#        Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
#        Wave_period = Wave_length / Wave_speed
#        gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
#        if showplotoverride==3:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/(abs((loopvalue[0]) - 0.25)*25+15)
#            #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
#        if showplotoverride==4:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/((abs(loopvalue[0]) - 0.25)*25+15)
#    if loopname == "WaveHeight_Length_high_sway_plate":
#        Sway_Plate_Force = True
#        z_location_sway = -7.3
#        Wave_height = loopvalue[0]
#        Wave_length = Length_large_floater * loopvalue[1]
#        flow_velocity = 0  # m/s
#        Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
#        Wave_period = Wave_length / Wave_speed
#        gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
#        if showplotoverride==3:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/(abs((loopvalue[0]) - 0.25)*25+15)
#            #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
#        if showplotoverride==4:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/((abs(loopvalue[0]) - 0.25)*25+15)
#    if loopname == "WaveHeight_Length_single_heave_level":
#        Heave_Plate_Force = True
#        Wave_height = loopvalue[0]
#        Wave_length = Length_large_floater * loopvalue[1]
#        flow_velocity = 0  # m/s
#        Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
#        Wave_period = Wave_length / Wave_speed
#        gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
#        if showplotoverride==3:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/(abs((loopvalue[0]) - 0.25)*25+15)
#            #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
#        if showplotoverride==4:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/((abs(loopvalue[0]) - 0.25)*25+15)
    
    
    
#    if loopname == "WaveHeight_Length":
#        Wave_height = loopvalue[0] * draught
#        Wave_length = Length_large_floater * loopvalue[1]
#        flow_velocity = 0  # m/s
#        Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
#        Wave_period = Wave_length / Wave_speed
#        gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
#        if showplotoverride==3:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/(abs((loopvalue[0]) - 0.25)*25+15)
#            #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
#        if showplotoverride==4:
#            Total_time = Num_wave_periods*Wave_period
#            time_step = 1/((abs(loopvalue[0]) - 0.25)*25+15)


    # if loopname == "WaveHeight_Length_single_sway_70m":
    #     Sway_Plate_Force = True
    #     Sway_width = 70.  # m
    #     Sway_height = 8.
    #     z_location_sway = -16.5  # m For the new Fishflow turbines
    #     C_drag_sway = 1.9
    #     M_added_sway_plate = 0.25 * np.pi * Sway_height ** 2 * Sway_width * rho
    #     M_added_sway_plateD3 = Number_of_large_floaters * rho * Width_large_floater * (9 * 3 * 9 + 0.25 * np.pi * 9 ** 2)
    #     sway_plate_num = int(1)  # must be an integer
    #
    #     Wave_height = loopvalue[0]
    #     Wave_length = Length_large_floater * loopvalue[1]
    #     flow_velocity = 0.  # m/s
    #     Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
    #     Wave_period = Wave_length / Wave_speed
    #     gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
    #     if showplotoverride==3:
    #         if loopvalue[0]*flow_velocity > 0:
    #             Total_time = 1.5 * Num_wave_periods * Wave_period
    #         else:
    #             Total_time = Num_wave_periods * Wave_period
    #         time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
    #         #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
    #     if showplotoverride==4:
    #         if loopvalue[0]*flow_velocity > 0:
    #             Total_time = 1.5 * Num_wave_periods * Wave_period
    #         else:
    #             Total_time = Num_wave_periods * Wave_period
    #         time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
    # if loopname == "WaveHeight_Length_double_sway_70m":
    #     Sway_Plate_Force = True
    #     Sway_width = 70.  # m
    #     Sway_height = 8.
    #     z_location_sway = -16.5  # m For the new Fishflow turbines
    #     C_drag_sway = 1.9
    #     M_added_sway_plate = 0.25 * np.pi * Sway_height ** 2 * Sway_width * rho
    #     M_added_sway_plateD3 = Number_of_large_floaters * rho * Width_large_floater * (9 * 3 * 9 + 0.25 * np.pi * 9 ** 2)
    #     sway_plate_num = int(2)  # must be an integer
    #
    #     Wave_height = loopvalue[0]
    #     Wave_length = Length_large_floater * loopvalue[1]
    #     flow_velocity = 0.  # m/s
    #     Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
    #     Wave_period = Wave_length / Wave_speed
    #     gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
    #     if showplotoverride==3:
    #         if loopvalue[0]*flow_velocity > 0:
    #             Total_time = 1.5 * Num_wave_periods * Wave_period
    #         else:
    #             Total_time = Num_wave_periods * Wave_period
    #         time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
    #         #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
    # if loopname == "WaveHeight_Length_slosh":
    #     Slosh_Force = True
    #     Wave_height = loopvalue[0]
    #     Wave_length = Length_large_floater * loopvalue[1]
    #     flow_velocity = 0.  # m/s
    #     Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
    #     Wave_period = Wave_length / Wave_speed
    #     gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
    #     if showplotoverride==3:
    #         if loopvalue[0]*flow_velocity > 0:
    #             Total_time = 1.5 * Num_wave_periods * Wave_period
    #         else:
    #             Total_time = Num_wave_periods * Wave_period
    #         time_step = 0.02
    #         # time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
    #         #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
    #     if showplotoverride==4:
    #         if loopvalue[0]*flow_velocity > 0:
    #             Total_time = 1.5 * Num_wave_periods * Wave_period
    #         else:
    #             Total_time = Num_wave_periods * Wave_period
    #         time_step = 0.02
    #         # time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
    # if loopname == "WaveHeight_Length_heave":
    #     Heave_Plate_Force = True
    #
    #     rho = 1025
    #     n_plates = 1.
    #     Heave_dist_x = 30.
    #     Heave_dist_y = 98.
    #     z_location_heave = -19.8
    #     C_drag_sway = 1.9
    #     heave_plate_bottom_dist = 5
    #     C_within_turbines = 0.25  # Due to the turbines, all volume above the heave plates cannot be taken into account for the added mass. Only 25% can be taken into account
    #     M_added_heave_plate = n_plates * rho * (C_within_turbines * 0.5 * 0.25 * np.pi * Heave_dist_x ** 2 * Heave_dist_y + heave_plate_bottom_dist * Heave_dist_x * Heave_dist_y)
    #     M_added_heave_plate_roll = n_plates * rho * np.pi / 8. * (Heave_dist_y / 2) ** 4 * Heave_dist_x
    #
    #     Wave_height = loopvalue[0]
    #     Wave_length = Length_large_floater * loopvalue[1]
    #     flow_velocity = 0.  # m/s
    #     Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
    #     Wave_period = Wave_length / Wave_speed
    #     gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
    #     if showplotoverride==3:
    #         if loopvalue[0]*flow_velocity > 0:
    #             Total_time = 1.5 * Num_wave_periods * Wave_period
    #         else:
    #             Total_time = Num_wave_periods * Wave_period
    #         time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
    #         #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
    #     if showplotoverride==4:
    #         if loopvalue[0]*flow_velocity > 0:
    #             Total_time = 1.5 * Num_wave_periods * Wave_period
    #         else:
    #             Total_time = Num_wave_periods * Wave_period
    #         time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
    # if loopname == "WaveNegHeight_Length_incl_chosen_sway":
    #     Sway_Plate_Force = True
    #     Sway_width = 50.  # m
    #     Sway_height = 8.
    #     z_location_sway = -16.5  # m For the new Fishflow turbines
    #     C_drag_sway = 1.9
    #     M_added_sway_plate = 0.25 * np.pi * Sway_height ** 2 * Sway_width * rho
    #     M_added_sway_plateD3 = Number_of_large_floaters * rho * Width_large_floater * (9 * 3 * 9 + 0.25 * np.pi * 9 ** 2)
    #     sway_plate_num = int(3)  # must be an integer
    #     Wave_height = -loopvalue[0]
    #     Wave_length = Length_large_floater * loopvalue[1]
    #     flow_velocity = 0.  # m/s
    #     Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
    #     Wave_period = Wave_length / Wave_speed
    #     gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
    #     if showplotoverride==3:
    #         if loopvalue[0]*flow_velocity > 0:
    #             Total_time = 1.5 * Num_wave_periods * Wave_period
    #         else:
    #             Total_time = Num_wave_periods * Wave_period
    #         time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
    #         #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
    #     if showplotoverride==4:
    #         if loopvalue[0]*flow_velocity > 0:
    #             Total_time = 1.5 * Num_wave_periods * Wave_period
    #         else:
    #             Total_time = Num_wave_periods * Wave_period
    #         time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
    # if loopname == "WaveHeight_Length_posHposC":
    #     Wave_height = loopvalue[0]
    #     Wave_length = Length_large_floater * loopvalue[1]
    #     flow_velocity = 2  # m/s
    #     Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
    #     Wave_period = Wave_length / Wave_speed
    #     gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
    #     if showplotoverride==3:
    #         if loopvalue[0]*flow_velocity > 0:
    #             Total_time = 1.5 * Num_wave_periods * Wave_period
    #         else:
    #             Total_time = Num_wave_periods * Wave_period
    #         time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
    #         #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
    #     if showplotoverride==4:
    #         if loopvalue[0]*flow_velocity > 0:
    #             Total_time = 1.5 * Num_wave_periods * Wave_period
    #         else:
    #             Total_time = Num_wave_periods * Wave_period
    #         time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
    # if loopname == "WaveHeight_Length_negHposC":
    #     Wave_height = -loopvalue[0]
    #     Wave_length = Length_large_floater * loopvalue[1]
    #     flow_velocity = 2  # m/s
    #     Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
    #     Wave_period = Wave_length / Wave_speed
    #     gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
    #     if showplotoverride==3:
    #         if loopvalue[0]*flow_velocity > 0:
    #             Total_time = 1.5 * Num_wave_periods * Wave_period
    #         else:
    #             Total_time = Num_wave_periods * Wave_period
    #         time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
    #         #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
    #     if showplotoverride==4:
    #         if loopvalue[0]*flow_velocity > 0:
    #             Total_time = 1.5 * Num_wave_periods * Wave_period
    #         else:
    #             Total_time = Num_wave_periods * Wave_period
    #         time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
    # if loopname == "WaveHeight_Length_posHnegC":
    #     Wave_height = loopvalue[0]
    #     Wave_length = Length_large_floater * loopvalue[1]
    #     flow_velocity = -2  # m/s
    #     Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
    #     Wave_period = Wave_length / Wave_speed
    #     gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
    #     if showplotoverride==3:
    #         if loopvalue[0]*flow_velocity > 0:
    #             Total_time = 1.5 * Num_wave_periods * Wave_period
    #         else:
    #             Total_time = Num_wave_periods * Wave_period
    #         time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
    #         #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
    #     if showplotoverride==4:
    #         if loopvalue[0]*flow_velocity > 0:
    #             Total_time = 1.5 * Num_wave_periods * Wave_period
    #         else:
    #             Total_time = Num_wave_periods * Wave_period
    #         time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
    # if loopname == "WaveHeight_Length_negHnegC":
    #     Wave_height = -loopvalue[0]
    #     Wave_length = Length_large_floater * loopvalue[1]
    #     flow_velocity = -2  # m/s
    #     Wave_speed = np.sqrt(g * Wave_length / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_length)) + flow_velocity * (Wave_height/abs(Wave_height))
    #     Wave_period = Wave_length / Wave_speed
    #     gridsize = np.array([Wave_length / 30, abs(Wave_height) / (20 + 10 * abs(Wave_height))])  # m
    #     if showplotoverride==3:
    #         if loopvalue[0]*flow_velocity > 0:
    #             Total_time = 1.5 * Num_wave_periods * Wave_period
    #         else:
    #             Total_time = Num_wave_periods * Wave_period
    #         time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)
    #         #time_step = 1/((loopvalue[0] - 0.25)*25+15) gives variation between 1/15=0.067sec and 1/(25+15)=0.025sec
    #     if showplotoverride==4:
    #         if loopvalue[0]*flow_velocity > 0:
    #             Total_time = 1.5 * Num_wave_periods * Wave_period
    #         else:
    #             Total_time = Num_wave_periods * Wave_period
    #         time_step = 1/(abs(loopvalue[0] - 0.28)/loopvalue[0]*20+15)