import matplotlib.pyplot as plt
import numpy as np
import os

# To determine test number
def fcount(path = "Figures/", map={}):
    count = 0
    for f in os.listdir(path):
        child = os.path.join(path, f)
        if os.path.isdir(child):
            child_count = fcount(child, map)
            count += child_count + 1  # unless include self
    if path.find("\Heatmaps") != -1:
        count = count -1
    map[path] = count
    return (count)

# print input data, and the output data as matrices and natural periods in txt file.
def DataFile(Test_Number, M_matrix, C_matrix, K_matrix, Total_time, time_step, Length_segment,
             free_space_between_segments, characteristics_small_floater, characteristics_large_floater, M_segment,
             J_segment, z_location_bottom_floater, z_location_deck, z_location_Super_Structure, z_location_turbines, width_deck, Turbine_char,
             Length_Pendulum, Angle_Pendulum_Mid_Tide, Angle_Pendulum_Initial_Tidal, Pendulum_hinge_top_location, Diameter_pendulum,
             Stiffness_Pendulum, Stiffness_Spudpole, Stiffness_connection_segment, Damping_Pendulum, Damping_Spudpole,
             Damping_connection_segment, Wind_Distributed_Load_Deck, Wind_Distributed_Load_Super_Structure, Traffic_load, Max_Turbine,
             C_drag_pointed_rectangle,  C_drag_bottom_floater, C_Added_Mass_Pointed_Tip_Reduction, C_Added_Mass_Not_Infinite_Factor, C_Marine_Growth_Extra, C_Damping_Pointed_Tip_Reduction,
             Tidal_level, flow_velocity, Wave_hlp, depth, rho, g, Natural_Period, gridsize, smooth_time, Max_location,
             Max_acceleration, Max_F_Pendulum, Min_F_Pendulum, Wave_Force, Pendulum_Drag_Force, Current_Force, Turbine_Force, Traffic_Force, Constant_force, Three_Dimensional_Calculation,
             Wind_Deck_Force, Wind_Super_Structure_Force, Smooth_Start, Approaching_Wave_Field, Integration_Of_Ansys_Aqwa_mass,
             Integration_Of_Ansys_Aqwa_damp, Ansys_Aqwa_file_name, Ansys_char, Acceleration_Override, ExperimentalAddition,start_search,Stiffness_lean_factor,
             Turbine_dimensions_HWL,M_added_tur_hori, M_added_tur_vert,C_radiation_turbine_sway_reduction,x_list, Sway_Plate_Force, Slosh_Force_test,draught, loopname,
             Heave_Plate_Force, Heave_plate_char, Sway_plate_char, Slosh_char, Slosh_Force):

    Diameter_turbine_impeller, Induction_factor, C_added_tur_hori, C_added_tur_vert, C_drag_turbine = Turbine_char
    Heave_dist_x,Heave_dist_y,z_location_heave, heave_plate_bottom_dist, C_drag_sway,M_added_heave_plate, M_added_heave_plate_roll, M_added_heave_plate_2, M_added_heave_plate_roll_2, second_level_heave, height_second_level, n_plates = Heave_plate_char
    
    if not os.path.exists("Figures/Test_{}".format(f"{Test_Number:05d}")):
        os.mkdir("Figures/Test_{}".format(f"{Test_Number:05d}"))

    Max_y, Max_z, Max_Rx = Max_location
    Max_yddot, Max_zddot, Max_Rxddot, Max_ddot = Max_acceleration


    testdata = open("Figures/Test_{}/Data_{}.txt".format(f"{Test_Number:05d}", f"{Test_Number:05d}"), 'w')

    testdata.write("Test number:                          ")
    testdata.write(str(f"{Test_Number:05d}"))
    testdata.write("\n \n")
    
    testdata.write("Test name:                            ")
    testdata.write(str(loopname))
    testdata.write("\n \n \n")

    if Acceleration_Override == True:
        testdata.write(" > > > Test object became airborne and was manually corrected during the test < < < ")
        testdata.write("\n \n \n")

    testdata.write("- - - - - - - - - - - - - - - - - - - - - - - - - - SIMULATION CHARACTERISTICS - - - - - - - - - - - - - - - - - - - - - - - - - -")
    testdata.write("\n \n")

    testdata.write("Simulation time:                      ")
    testdata.write(str(round(Total_time,1)))
    testdata.write(" [s]")
    testdata.write("\n")
    
    testdata.write("Total time used to search for maxima: ")
    testdata.write(str(round((1-start_search/(Total_time/time_step))*Total_time)))
    testdata.write(" [s]")
    testdata.write("\n")
    
    if Smooth_Start == True:
        testdata.write("Force smooth time                     ")
        testdata.write(str(round(smooth_time,1)))
        testdata.write(" [s]")
        testdata.write("\n")
    else:
        testdata.write("\n")
    
    testdata.write("Timestep:                             ")
    testdata.write(str(round(time_step,3)))
    testdata.write(" [s]")
    testdata.write("\n \n")
    


    if Integration_Of_Ansys_Aqwa_mass == True:
        testdata.write("Added mass:                           Estimated with Ansys Aqwa")
    else:
        testdata.write("Added mass:                           Estimated with DNV literature")
    testdata.write("\n")

    if Integration_Of_Ansys_Aqwa_damp == True:
        testdata.write("Added damping:                        Estimated with Ansys Aqwa")
    else:
        testdata.write("Added damping:                        Estimated with Vugts experiments")
    testdata.write("\n")

    if ExperimentalAddition == True:
        testdata.write("Own experiments are used to determine the coefficients")
    else:
        testdata.write("Own experiments are not used")
    testdata.write("\n \n")

    testdata.write("Forces in simulation:                 ")
    if Wind_Deck_Force == True:
        testdata.write("Wind (deck); ")
    if Wind_Super_Structure_Force == True:
        testdata.write("Wind (super structure); ")
    if Wave_Force == True:
        testdata.write("Waves; ")
    if Current_Force == True:
        testdata.write("Pontoon drag; ")
    if Pendulum_Drag_Force == True:
        testdata.write("Pendulum drag; ")
    if Turbine_Force == True:
        testdata.write("Turbine drag; ")
    if Traffic_Force == True:
        testdata.write("Traffic; ")
    if Constant_force == True:
        testdata.write("Constant-testforce; ")
    if Wind_Deck_Force == False and Wind_Super_Structure_Force == False and Wave_Force == False and Current_Force == False and Current_Force == False and Traffic_Force == False and Constant_force == False and Pendulum_Drag_Force == False and Turbine_Force == False:
        testdata.write("None")
    testdata.write("\n \n")


    

    testdata.write("Approaching wave field                ")
    if Approaching_Wave_Field == True:
        testdata.write("Yes")
    else:
        testdata.write("No")
    testdata.write("\n")


    testdata.write("Wave gridsize [y,z]:                  ")
    testdata.write(str(gridsize))
    testdata.write(" [m]")
    testdata.write("\n")

    testdata.write("Average depth below TB at MSL:        ")
    testdata.write(str(depth))
    testdata.write(" [m]")
    testdata.write("\n")

    testdata.write("Tidal level:                          ")
    if Tidal_level > 0:
        testdata.write("+")
    testdata.write(str(Tidal_level))
    testdata.write(" [m]")
    testdata.write("\n")
    
    testdata.write("Density water:                        ")
    testdata.write(str(rho))
    testdata.write(" [kg/m3]")
    testdata.write("\n")

    testdata.write("Gravitational acceleration:           ")
    testdata.write(str(g))
    testdata.write(" [s]")
    testdata.write("\n \n")
   

    testdata.write("Distributed wind load deck:            ")
    if Wind_Super_Structure_Force == True:
        testdata.write(str(Wind_Distributed_Load_Deck))
    else:
        testdata.write(str(0))
    testdata.write(" [N/m]")
    testdata.write("\n")

    testdata.write("Distributed wind load super structure: ")
    if Wind_Super_Structure_Force == True:
        testdata.write(str(Wind_Distributed_Load_Super_Structure))
    else:
        testdata.write(str(0))
    testdata.write(" [N/m]")
    testdata.write("\n \n")
    testdata.write("\n \n")



    testdata.write("- - - - - - - - - - - - - - - - - - - - - - - - - - - DAMPING CHARACTERISTICS - - - - - - - - - - - - - - - - - - - - - - - - - - -")
    testdata.write("\n \n")

    if Sway_Plate_Force == True:
        testdata.write("Sway_Plate_Force:                      True; ")
        testdata.write("\n")
        testdata.write("Sway plate char: "+str(Sway_plate_char))
        testdata.write("\n")
    else:
        testdata.write("Sway_Plate_Force:                      False; ")
        testdata.write("\n")

    if Heave_Plate_Force == True:
        testdata.write("Heave_Plate_Force:                     True; ")
        testdata.write("\n")
        testdata.write("Heave plate char: "+str(Heave_plate_char))
        testdata.write("\n")
        if second_level_heave == True:
            testdata.write("Heave plate second level:              True; ")
            testdata.write("\n")
        else:
            testdata.write("Heave plate second level:              False; ")
            testdata.write("\n")
    else:
        testdata.write("Heave_Plate_Force                      False; ")
        testdata.write("\n")
    
    if Slosh_Force == True:
        testdata.write("Slosh_Force:                      True")
        testdata.write("\n")
        testdata.write("Slosh char: "+str(Slosh_char))
        testdata.write("\n")
    else:
        testdata.write("Slosh_Force:                      False")
        testdata.write("\n")

    if Slosh_Force_test == True:
        testdata.write("Slosh_Force_test:                      True")
        testdata.write("\n")
        testdata.write("Slosh char: "+str(Slosh_char))
        testdata.write("\n")
    else:
        testdata.write("Slosh_Force_test:                      False")
        testdata.write("\n")


    testdata.write("- - - - - - - - - - - - - - - - - - - - - - - - - - - HYDRODYNAMIC CHARACTERISTICS - - - - - - - - - - - - - - - - - - - - - - - - - - -")
    testdata.write("\n \n")
    testdata.write("Flow velocity:                        ")
    testdata.write(str(flow_velocity))
    testdata.write(" [m/s]")
    testdata.write("\n")

    testdata.write("Wave height:                          ")
    testdata.write(str(round(Wave_hlp[0],3)))
    testdata.write(" [m]")
    testdata.write("\n")

    testdata.write("Wave length:                          ")
    testdata.write(str(round(Wave_hlp[1],3)))
    testdata.write(" [m]")
    testdata.write("\n")

    testdata.write("Wave period:                          ")
    testdata.write(str(round(Wave_hlp[2],3)))
    testdata.write(" [s]")
    testdata.write("\n")

    testdata.write("Relative wave celerity:               ")
    testdata.write(str(round(Wave_hlp[1]/Wave_hlp[2])))
    testdata.write(" [m/s]")
    testdata.write("\n")

    testdata.write("Absolute wave celerity:               ")
    testdata.write(str(round(Wave_hlp[1]/Wave_hlp[2]+flow_velocity)))
    testdata.write(" [m/s]")

    testdata.write("\n \n")
    testdata.write("\n \n")

    testdata.write("- - - - - - - - - - - - - - - - - - - - - - - - - - - SYSTEM CHARACTERISTICS - - - - - - - - - - - - - - - - - - - - - - - - - - -")
    testdata.write("\n \n")

    testdata.write("Length of segment:                                              ")
    testdata.write(str(Length_segment))
    testdata.write(" [m]")
    testdata.write("\n")

    testdata.write("Free space between segments:                                    ")
    testdata.write(str(free_space_between_segments))
    testdata.write(" [m]")
    testdata.write("\n \n")

    if Traffic_Force == True:
        M_segment = M_segment - Traffic_load
        J_segment[0] = J_segment[0] - M_segment * (z_location_deck + 2)**2

    testdata.write("Mass of segment:                                                ")
    testdata.write(str(M_segment))
    testdata.write(" [kg]")
    testdata.write("\n")

    testdata.write("Rotational momentum of segment [x,y,z]:                         ")
    testdata.write(str(J_segment))
    testdata.write(" [kgm2]")
    testdata.write("\n \n")

    testdata.write("Mass of traffic:                                                ")
    testdata.write(str(Traffic_load))
    testdata.write(" [kg]")
    testdata.write("\n \n")

    testdata.write("Draught:                                                        ")
    testdata.write(str(round(draught,2)))
    testdata.write(" [m]")
    testdata.write("\n")
    
    testdata.write("Average z-coordinate of traffic:                                ")
    testdata.write(str(z_location_deck + 2))
    testdata.write(" [m]")
    testdata.write("\n")

    testdata.write("Location of bottom floaters compared to COG (z-axis):           ")
    testdata.write(str(z_location_bottom_floater))
    testdata.write(" [m]")
    testdata.write("\n")

    testdata.write("Location of deck compared to COG (z-axis):                      ")
    testdata.write(str(z_location_deck))
    testdata.write(" [m]")
    testdata.write("\n")

    testdata.write("Location of super structure compared to COG (z-axis):           ")
    testdata.write(str(z_location_Super_Structure))
    testdata.write(" [m]")
    testdata.write("\n")

    testdata.write("Location of turbine compared to COG (z-axis):                   ")
    testdata.write(str(z_location_turbines))
    testdata.write(" [m]")
    testdata.write("\n")
    
    testdata.write("Width of the deck:                                              ")
    testdata.write(str(width_deck))
    testdata.write(" [m]")
    testdata.write("\n \n")
    

    testdata.write("Characteristics of small floater [Amount, width, length]:       ")
    testdata.write(str(characteristics_small_floater))
    testdata.write(" [-, m, m]")
    testdata.write("\n")

    testdata.write("Characteristics of large floater [Amount, width, length]:       ")
    testdata.write(str(characteristics_large_floater))
    testdata.write(" [-, m, m]")
    testdata.write("\n \n")

    testdata.write("Stiffness of pendulum:                                          ")
    testdata.write(str(Stiffness_Pendulum))
    testdata.write(" [N/m]")
    testdata.write("\n")

    testdata.write("Stiffness of spudpole:                                          ")
    testdata.write(str(Stiffness_Spudpole))
    testdata.write(" [N/m]")
    testdata.write("\n")

    testdata.write("Stiffness of connections between segments:                      ")
    testdata.write(str(Stiffness_connection_segment))
    testdata.write(" [N/m]")
    testdata.write("\n \n")

    testdata.write("Damping of pendulum:                                            ")
    testdata.write(str(Damping_Pendulum))
    testdata.write(" [N/m]")
    testdata.write("\n")

    testdata.write("Damping of spudpole:                                            ")
    testdata.write(str(Damping_Spudpole))
    testdata.write(" [N/m]")
    testdata.write("\n")

    testdata.write("Damping of connections between segments:                        ")
    testdata.write(str(Damping_connection_segment))
    testdata.write(" [N/m]")
    testdata.write("\n \n")

    testdata.write("Angle of pendulums at mid-tide:                                 ")
    testdata.write(str(round(Angle_Pendulum_Mid_Tide * 180 / np.pi)))
    testdata.write(" [deg]")
    testdata.write("\n")

    testdata.write("Angle of pendulum at tidal level:                               ")
    Angle_Pendulum_Initial_Tidal_deg = np.zeros(len(Angle_Pendulum_Initial_Tidal))
    for i in range (len(Angle_Pendulum_Initial_Tidal)):
        Angle_Pendulum_Initial_Tidal_deg[i] = round(Angle_Pendulum_Initial_Tidal[i] * 180 / np.pi,2)
    testdata.write(str(Angle_Pendulum_Initial_Tidal_deg))
    testdata.write(" [deg]")
    testdata.write("\n")

    testdata.write("Length of pendulums:                                            ")
    testdata.write(str(Length_Pendulum))
    testdata.write(" [m]")
    testdata.write("\n")

    testdata.write("Location hinge pendulum compared to COG:                        ")
    testdata.write(str(Pendulum_hinge_top_location))
    testdata.write(" [m]")
    testdata.write("\n")

    testdata.write("Diameter of the pendulums:                                      ")
    testdata.write(str(Diameter_pendulum))
    testdata.write(" [m]")
    testdata.write("\n \n")

    
    testdata.write("Diameter of each turbine impeller:                              ")
    testdata.write(str(Turbine_char[0]))
    testdata.write(" [m]")
    testdata.write("\n")
    
    testdata.write("Total width of one FishFlow turbine casing:              ")
    testdata.write(str(Turbine_dimensions_HWL[1]))
    testdata.write(" [m]")
    testdata.write("\n")

    testdata.write("Total height of one FishFlow turbine casing:              ")
    testdata.write(str(Turbine_dimensions_HWL[0]))
    testdata.write(" [m]")
    testdata.write("\n")

    testdata.write("Total length of one FishFlow turbine casing:              ")
    testdata.write(str(Turbine_dimensions_HWL[2]))
    testdata.write(" [m]")
    testdata.write("\n")

    testdata.write("Submerged depth of Turbine:                               ")
    testdata.write(str(Turbine_dimensions_HWL[3]))
    testdata.write(" [m]")
    testdata.write("\n")

    testdata.write("Combined turbine force at flow velocity of ")
    testdata.write(str(Max_Turbine[1]))
    testdata.write(" m/s:             ")
    testdata.write(str(round(Max_Turbine[0])))
    testdata.write(" [N]")
    testdata.write("\n")

    
    
    testdata.write("- - - - - - - - - - - - - - - - - - - - - - - - COEFFICIENTS - - - - - - - - - - - - - - - - - - - - - - - - ")
    testdata.write("\n \n")
    
    
    testdata.write("Drag coefficient floaters horizontal:                           ")
    testdata.write(str(C_drag_pointed_rectangle))
    testdata.write(" [-]")
    testdata.write("\n")

    testdata.write("Drag coefficient floaters vertical:                             ")
    testdata.write(str(C_drag_bottom_floater))
    testdata.write(" [-]")
    testdata.write("\n")

    testdata.write("Added mass pointed tip coefficient:                             ")
    testdata.write(str(C_Added_Mass_Pointed_Tip_Reduction))
    testdata.write(" [-]")
    testdata.write("\n")

    testdata.write("Non-infinite length coefficient:                                ")
    testdata.write(str(C_Added_Mass_Not_Infinite_Factor))
    testdata.write(" [-]")
    testdata.write("\n")

    testdata.write("Extra added mass coefficient due to marine growth:              ")
    testdata.write(str(C_Marine_Growth_Extra))
    testdata.write(" [-]")
    testdata.write("\n")

    testdata.write("Reduction in radiation damping due to pointed tips:             ")
    testdata.write(str(C_Damping_Pointed_Tip_Reduction))
    testdata.write(" [-]")
    testdata.write("\n")
    
    testdata.write("Turbine induction factor:                                       ")
    testdata.write(str(Induction_factor))
    testdata.write(" [-]")
    testdata.write("\n")
    
    testdata.write("Turbine added mass coefficient for the horizontal movement:     ")
    testdata.write(str(C_added_tur_hori))
    testdata.write(" [-]")
    testdata.write("\n")    
   
    testdata.write("Turbine added mass coefficient for the vertical movement:       ")
    testdata.write(str(C_added_tur_vert))
    testdata.write(" [-]")
    testdata.write("\n")     
   

    testdata.write("Lean factor for the adjacent hydraulic stiffness:               ")
    testdata.write(str(Stiffness_lean_factor))
    testdata.write(" [-]")
    testdata.write("\n")
    
    
    Stiffness_lean_factor

    testdata.write("\n \n")
    testdata.write("\n \n")

    testdata.write("- - - - - - - - - - - - - - - - - LARGEST DISPLACEMENTS, ACCELERATIONS AND PENDULUM FORCES FOUND - - - - - - - - - - - - - - - - - ")
    testdata.write("\n \n")

    testdata.write("Average displacement in y-direction (Sway):                     ")
    testdata.write(str(np.round(np.mean(x_list[:, 0]),3)))
    testdata.write("  [m]")
    testdata.write("\n")

    testdata.write("Average displacement in z-direction (Heave):                    ")
    testdata.write(str(np.round(np.mean(x_list[:, 1]),3)))
    testdata.write("  [m]")
    testdata.write("\n")

    testdata.write("Average rotation around the x-axis (Roll):                      ")
    testdata.write(str(np.round(np.mean(x_list[:, 2]),3)))
    testdata.write("  [rad]")
    testdata.write("\n \n")

    testdata.write("Maximum displacement in y-direction (Sway):                     ")
    testdata.write(str(Max_y))
    testdata.write("  [m]")
    testdata.write("\n")

    testdata.write("Maximum displacement in z-direction (Heave):                    ")
    testdata.write(str(Max_z))
    testdata.write("  [m]")
    testdata.write("\n")

    testdata.write("Maximum rotation around the x-axis (Roll):                      ")
    testdata.write(str(Max_Rx))
    testdata.write(" [rad]")
    testdata.write("\n \n")


    testdata.write("Maximum acceleration in y-direction (Sway):                     ")
    testdata.write(str(Max_yddot))
    testdata.write("  [m/s^2]")
    testdata.write("\n")

    testdata.write("Maximum acceleration in z-direction (Heave):                    ")
    testdata.write(str(Max_zddot))
    testdata.write("  [m/s^2]")
    testdata.write("\n")

    testdata.write("Maximum acceleration rotational around the x-axis (Roll):       ")
    testdata.write(str(Max_Rxddot))
    testdata.write(" [rad/s^2]")
    testdata.write("\n")

    testdata.write("Maximum acceleration total/combined:                            ")
    testdata.write(str(Max_ddot))
    testdata.write("  [m/s^2]")
    testdata.write("\n")

    testdata.write("\n")

    for i in range (len(Max_F_Pendulum)):
        if Three_Dimensional_Calculation == False:
            if i != 1 and i != 2:
                continue
            else:
                testdata.write("Maximum force found in pendulum ")
                testdata.write(str(i))
                testdata.write(":                              ")
                testdata.write(str(np.format_float_scientific(Max_F_Pendulum[i],unique=False, precision=2)))
                testdata.write("  [N]")
                testdata.write("\n")
        else:
            testdata.write("Maximum force found in pendulum ")
            testdata.write(str(i+1))
            testdata.write(":                              ")
            testdata.write(str(np.format_float_scientific(Max_F_Pendulum[i],unique=False, precision=2)))
            testdata.write("  [N]")
            testdata.write("\n")


    for i in range (len(Min_F_Pendulum)):
        if Three_Dimensional_Calculation == False:
            if i != 1 and i != 2:
                continue
            else:
                testdata.write("Minimum force found in pendulum ")
                testdata.write(str(i))
                testdata.write(":                              ")
                testdata.write(str(np.format_float_scientific(Min_F_Pendulum[i],unique=False, precision=2)))
                testdata.write(" [N]")
                testdata.write("\n")
        else:
            testdata.write("Minimum force found in pendulum ")
            testdata.write(str(i+1))
            testdata.write(":                              ")
            testdata.write(str(np.format_float_scientific(Min_F_Pendulum[i],unique=False, precision=2)))
            testdata.write(" [N]")
            testdata.write("\n")


    testdata.write("\n \n")
    testdata.write("\n \n")


    testdata.write("- - - - - - - - - - - - - - - - - - - - - - - - MATRICES AND NATURAL FREQUENCIES - - - - - - - - - - - - - - - - - - - - - - - - ")
    testdata.write("\n \n")


    M_matrix_print = np.zeros((3, 3))
    C_matrix_print = np.zeros((3, 3))
    K_matrix_print = np.zeros((3, 3))

    for i in range (3):
        for j in range (3):
            M_matrix_print[i, j] = M_matrix[i, j]
            C_matrix_print[i, j] = C_matrix[i, j]
            K_matrix_print[i, j] = K_matrix[i, j]



    testdata.write("Initial M-matrix: \n")
    testdata.write("[")
    for i in range (len(M_matrix_print)):
        testdata.write("[")
        for j in range (len(M_matrix_print)):
            testdata.write(str(np.format_float_scientific(M_matrix_print[i,j],unique=False, precision=2)))
            if j != len(M_matrix_print) - 1:
                testdata.write(" , ")
        testdata.write("]")
        if i != len(M_matrix_print) - 1:
            testdata.write(", \n")
    testdata.write("] \n \n")

    testdata.write("Initial C-matrix: \n")
    testdata.write("[")
    for i in range (len(C_matrix_print)):
        testdata.write("[")
        for j in range (len(C_matrix_print)):
            testdata.write(str(np.format_float_scientific(C_matrix_print[i,j],unique=False, precision=2)))
            if j != len(C_matrix_print) - 1:
                testdata.write(" , ")
        testdata.write("]")
        if i != len(C_matrix_print) - 1:
            testdata.write(", \n")
    testdata.write("] \n \n")

    testdata.write("Initial K-matrix: \n")
    testdata.write("[")
    for i in range (len(K_matrix_print)):
        testdata.write("[")
        for j in range (len(K_matrix_print)):
            testdata.write(str(np.format_float_scientific(K_matrix_print[i,j],unique=False, precision=2)))
            if j != len(K_matrix_print) - 1:
                testdata.write(" , ")
        testdata.write("]")
        if i != len(K_matrix_print) - 1:
            testdata.write(", \n")
    testdata.write("] \n \n")



    testdata.write("Natural periods: \n")
    testdata.write("Sway:                  ")
    testdata.write(str(round(Natural_Period[0],2)))
    testdata.write("   [s]")
    testdata.write("\n")
    
    testdata.write("Heave:                 ")
    testdata.write(str(round(Natural_Period[1],2)))
    testdata.write("  [s]")
    testdata.write("\n")
        
    testdata.write("Roll:                  ")
    testdata.write(str(round(Natural_Period[2],2)))
    testdata.write("   [s]")
    testdata.write("\n")


    if Integration_Of_Ansys_Aqwa_mass == True or Integration_Of_Ansys_Aqwa_damp == True:

        testdata.write("\n")
        testdata.write("\n \n")
        testdata.write("\n \n")
        testdata.write("\n \n")

        testdata.write(
            "- - - - - - - - - - - - - - - - - - - - - - - - Ansys characteristics - - - - - - - - - - - - - - - - - - - - - - - - ")

        testdata.write("\n \n")
        testdata.write("\n \n")

        testdata.write("File name:                      ")
        testdata.write(Ansys_Aqwa_file_name)
        testdata.write("\n \n")

        testdata.write("Small floater:                  ")
        testdata.write(str(Ansys_char[0]))
        testdata.write("\n")
        testdata.write("Large floater:                  ")
        testdata.write(str(Ansys_char[1]))
        testdata.write("\n")
        testdata.write("Mass segment:                   ")
        testdata.write(str(Ansys_char[2][0]))
        testdata.write("\n \n")


    testdata.close()

    return()




#Plot them all, separated by segment
def Graphs(Test_Number, segments, steps, Total_time, Time, x_list, xdot_list, xddot_list,xddot_list_tot,F_list,
           Show_Tidal_Displacement_In_Plot, Tidal_level, Length_segment, Angle_Pendulum_Initial_Tidal,
           F_pendulum, Three_Dimensional_Calculation, Wave_Force,showplotoverride, slosh_kin_list,Slosh_Force, Slosh_Force_test):


#    if Slosh_Force_test == True:
#        for i in range (len(x_list)):
#            x_list[i,0]=0
#            x_list[i,1]=0
#            x_list[i,2]=0
    
    
    # plot displacement
    # avg_roll = np.mean(x_list[:, 2])   #Average roll calculation
    # avg_roll_array = np.ones(len(Time))*avg_roll
    fig = plt.figure(figsize=(15,8))
    ax1 = fig.add_subplot(111)
    ax2 = ax1.twinx()
    
    if Slosh_Force_test == True:
        print('none')
        plt.title("Displacement of slosh damper point mass")
    else:
        plt.title("Displacement of segment")
        ax1.plot(Time, x_list[:, 0], 'g', label='Sway')
        ax1.plot(Time, x_list[:, 1], 'r', label='Heave')
    if Slosh_Force==True:
        ax1.plot(Time, slosh_kin_list[:, 0], 'b', label='Damper_sway dev=1')
        ax1.plot(Time, slosh_kin_list[:, 3], color='lightsteelblue', label='Damper_heave dev=1')
    ax1.set_ylabel("Translation [m]")
    if Slosh_Force_test == True:
        print('none')
    else:
        ax2.plot(Time, x_list[:, 2], 'c--', label='Roll')
    # ax2.plot(Time, avg_roll_array, 'b--', label='Average roll is ' + str(np.round(avg_roll,3))
    ax2.set_ylabel("Rotation [rad]")
    if Wave_Force == True:
        max1 = max(max(x_list[int(steps * 0.6): steps, 0]),
                   max(x_list[int(steps * 0.6): steps, 1]),
                   -min(x_list[int(steps * 0.6): steps, 0]),
                   -min(x_list[int(steps * 0.6): steps, 1]), 0.000001)
        max2 = max(max(x_list[int(steps * 0.6): steps, 2]),
                   -min(x_list[int(steps * 0.6): steps, 2]), 0.000001)
    else:
        max1 = max(max(x_list[:, 0]),
                   max(x_list[:, 1]),
                   -min(x_list[:, 0]),
                   -min(x_list[:, 1]), 0.000001)
        max2 = max(max(x_list[:, 2]),
                   -min(x_list[:, 2]), 0.000001)
    if showplotoverride==0:
        max1 = 1.3 * 2/3
        max2 = 0.04 * 2/3
    ax1.legend(loc=3)
    ax2.legend(loc=4)
    ax1.set_ylim(-max1 * 6 / 4 , max1 * 6 / 4 )
    ax2.set_ylim(-max2 * 6 / 4 , max2 * 6 / 4 )
    plt.xlim(0,Total_time)
    ax1.set_xlabel("Time [s]")
    plt.savefig("Figures/Test_{}/Test_{}_1_Displacement".format(f"{Test_Number:05d}",f"{Test_Number:05d}"),bbox_inches='tight')


    # plot velocity
    fig = plt.figure(figsize=(13,7))
    ax1 = fig.add_subplot(111)
    ax2 = ax1.twinx()
    plt.title("Velocity of segment")
    ax1.plot(Time, xdot_list[:, 0], 'g', label='Sway')
    ax1.plot(Time, xdot_list[:, 1], 'r', label='Heave')
    if Slosh_Force==True:
    #    ax1.plot(Time, slosh_kin_list[:, 1]/2., 'b', label='Slosh_sway_y')
        ax1.plot(Time, slosh_kin_list[:, 2]/2., 'b', label='Damper dev=2')
    ax1.set_ylabel("Velocity [m/s]")
    ax2.plot(Time, xdot_list[:, 2], 'c--', label='Roll')
    ax2.set_ylabel("Rotational velocity [rad/s]")
    if Wave_Force == True:
        max1 = max(max(xdot_list[int(steps * 0.6): steps, 0]),
                   max(xdot_list[int(steps * 0.6): steps, 1]),
                   -min(xdot_list[int(steps * 0.6): steps, 0]),
                   -min(xdot_list[int(steps * 0.6): steps, 1]), 0.000001)
        max2 = max(max(xdot_list[int(steps * 0.6): steps, 2]),
                   -min(xdot_list[int(steps * 0.6): steps, 2]), 0.000001)
    else:
        max1 = max(max(xdot_list[:, 0]),
                   max(xdot_list[:, 1]),
                   -min(xdot_list[:, 0]),
                   -min(xdot_list[:, 1]), 0.000001)
        max2 = max(max(xdot_list[:, 2]),
                   -min(xdot_list[:, 2]), 0.000001)
    if showplotoverride == 0:
        max1=1.3 * 2/3
        max2=0.065 * 2/3
    ax1.legend(loc=3)
    ax2.legend(loc=4)
    ax1.set_ylim(-max1 * 6 / 4 , max1 * 6 / 4 )
    ax2.set_ylim(-max2 * 6 / 4 , max2 * 6 / 4 )
    plt.xlim(0,Total_time)
    ax1.set_xlabel("Time [s]")
    plt.savefig("Figures/Test_{}/Test_{}_2_Velocity".format(f"{Test_Number:05d}", f"{Test_Number:05d}"),bbox_inches='tight')


    # plot acceleration
    fig = plt.figure(figsize=(13,7))
    ax1 = fig.add_subplot(111)
    ax2 = ax1.twinx()
    plt.title("Acceleration of segment")
    ax1.plot(Time[0:-1], xddot_list[:, 0], 'g', label='Sway')
    ax1.plot(Time[0:-1], xddot_list[:, 1], 'r', label='Heave')
    ax1.plot(Time[0:-1], xddot_list_tot, 'darkblue', label='Total')
    if Slosh_Force==True:
        ax1.plot(Time, slosh_kin_list[:, 4], 'b', label='Damper dev=1')
    ax1.set_ylabel("Acceleration [m/s$^2$]")
    ax2.plot(Time[0:-1], xddot_list[:, 2], 'c--', label='Roll')
    ax2.set_ylabel("Rotational acceleration [rad/s$^2$]")
    if Wave_Force == True:
        max1 = max(max(xddot_list[int(steps * 0.6): steps, 0]),
                   max(xddot_list[int(steps * 0.6): steps, 1]),
                   -min(xddot_list[int(steps * 0.6): steps, 0]),
                   -min(xddot_list[int(steps * 0.6): steps, 1]), 0.000001)
        max2 = max(max(xddot_list[int(steps * 0.6): steps, 2]),
                   -min(xddot_list[int(steps * 0.6): steps, 2]), 0.000001)
    else:
        max1 = max(max(xddot_list[:, 0]),
                   max(xddot_list[:, 1]),
                   -min(xddot_list[:, 0]),
                   -min(xddot_list[:, 1]), 0.000001)
        max2 = max(max(xddot_list[:, 2]),
                   -min(xddot_list[:, 2]), 0.000001)
    if showplotoverride == 0:
        max1=1.8 * 2/3
        max2=0.045 * 2/3
    ax1.legend(loc=3)
    ax2.legend(loc=4)
    ax1.set_ylim(-max1 * 6 / 4 , max1 * 6 / 4 )
    ax2.set_ylim(-max2 * 6 / 4 , max2 * 6 / 4 )
    plt.xlim(0,Total_time)
    ax1.set_xlabel("Time [s]")
    plt.savefig("Figures/Test_{}/Test_{}_3_Acceleration".format(f"{Test_Number:05d}", f"{Test_Number:05d}"),bbox_inches='tight')
    
    Time=Time[:-1]
    
    # plot force
    fig = plt.figure(figsize=(13,7))
    ax1 = fig.add_subplot(111)
    ax2 = ax1.twinx()
    if Three_Dimensional_Calculation == True:
        plt.title("Force on segment")
    else:
        plt.title("Forces on segment")
    ax1.plot(Time, F_list[:, 0], 'g', label='F_h')
    ax1.plot(Time, F_list[:, 1], 'r', label='F_v')
    ax1.set_ylabel("Force [N]")
    ax2.plot(Time, F_list[:, 2], 'c--', label='M_y')
    ax2.set_ylabel("Moment [Nm]")
    if Wave_Force == True:
        max1 = max(max(F_list[int(steps * 0.6): steps, 0]),
                   max(F_list[int(steps * 0.6): steps, 1]),
                   -min(F_list[int(steps * 0.6): steps, 0]),
                   -min(F_list[int(steps * 0.6): steps, 1]), 0.000001)
                  
        max2 = max(max(F_list[int(steps * 0.6): steps, 2]),
                   -min(F_list[int(steps * 0.6): steps, 2]), 0.000001)
    else:
        max1 = max(max(F_list[:, 0]),
                   max(F_list[:, 1]),
                   -min(F_list[:, 0]),
                   -min(F_list[:, 1]),0.000001)
                
        max2 = max(max(F_list[:, 2]),
                   -min(F_list[:, 2]),0.000001)
    if showplotoverride == 0:
        max1 = 11000000 * 2/3
        max2 = 120000000 * 2/3
    ax1.legend(loc=3)
    ax2.legend(loc=4)
    ax1.set_ylim(-max1 * 6 / 4 , max1 * 6 / 4 )
    ax2.set_ylim(-max2 * 6 / 4 , max2 * 6 / 4 )
    plt.xlim(0,Total_time)
    ax1.set_xlabel("Time [s]")
    plt.savefig("Figures/Test_{}/Test_{}_4_Force_matrix".format(f"{Test_Number:05d}",f"{Test_Number:05d}"),bbox_inches='tight')
    
    
    F_pendulum = F_pendulum[:-1]
    Time = Time[:-1]
    # plot pendulum forces
    fig = plt.figure(figsize=(13,7))
    plt.title("Pendulum forces")
    for i in [1]:
        plt.plot(Time, F_pendulum[:,1], label = "Single pendulum")
        # plt.plot(Time, F_pendulum[:,i], label = "Single pendulum")
    maxi = max(np.max(F_pendulum),-np.min(F_pendulum))
    plt.ylim(-1.25 * maxi, 1.25 * maxi)
    plt.legend()
    plt.ylabel("Force [N]")
    plt.xlim(0,Total_time)
    if showplotoverride == 0:
        plt.ylim(-2700000,2700000)
    plt.xlabel("Time [s]")
    plt.savefig("Figures/Test_{}/Test_{}_5_Pendulum_Forces".format(f"{Test_Number:05d}",f"{Test_Number:05d}"),bbox_inches='tight')

    return()


