import Heatmap_Enhancer
import numpy as np
import matplotlib.pyplot as plt
import os
import shutil

#ROA finder

First_Test_Number = 6700
Last_Test_Number = 6747

##### CHECK THE WAVE DATA. IS IT POSITIVE OR NEGATIVE
flow_velocity = 0  #flow velocity


Wave_Height_Direction = 1 #Positive directed waves
#Wave_Height_Direction = -1 #Negative directed waves
Length_large_floater = 34
loopname = "WaveHeight_Length"
g=9.8
depth=23.3

map_sway_loc = np.loadtxt("Figures/Test_{} - finish/Map_Sway_Loc_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),delimiter=',')
map_heave_loc = np.loadtxt("Figures/Test_{} - finish/Map_Heave_Loc_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),delimiter=',')
map_roll_loc = np.loadtxt("Figures/Test_{} - finish/Map_Roll_Loc_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),delimiter=',')
map_sway_acc = np.loadtxt("Figures/Test_{} - finish/Map_Sway_Acc_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),delimiter=',')
# map_heave_acc = np.loadtxt("Figures/Test_{} - finish/Map_Heave_Acc_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),delimiter=',')
# map_roll_acc = np.loadtxt("Figures/Test_{} - finish/Map_Roll_Acc_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),delimiter=',')
map_tot_acc = np.loadtxt("Figures/Test_{} - finish/Map_Sway_Acc_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),delimiter=',')
Wave_height = np.loadtxt("Figures/Test_{} - finish/Map_Wave_Height_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),delimiter=',')
Wave_period = np.loadtxt("Figures/Test_{} - finish/Map_Wave_Period_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),delimiter=',')
Wave_length = np.loadtxt("Figures/Test_{} - finish/Map_Wave_Length_Data_{}-{}.csv".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname),delimiter=',')
Wave_number = 2*np.pi/Wave_length


len_l = len(map_sway_loc) #len(map_sway_loc) defines the dimension of the wave length variations. The x-axis for the RAO's (12)
len_h = len(map_sway_loc[0]) #len(map_sway_loc[0]) defines the dimension of the wave height variations. The y-axis for the RAO's (7)

#%%
len_l = len(map_sway_loc) #len(map_sway_loc) defines the dimension of the wave length variations.
len_h = len(map_sway_loc[0]) #len(map_sway_loc[0]) defines the dimension of the wave height variations. The y-axis for the RAO's

Axis_Wave_L_pre_enhanced = np.zeros((len_l,len_h))
for i in range(len_l):
    for j in range(len_h):
        Axis_Wave_L_pre_enhanced[i,j] = Wave_length[j+i*len_h]#Wave_length[(j+1)+len_h*i]

Plot_enhancer = int(14 * 36 / len_l)        
Axis_Wave_L_enhanced = np.array(Heatmap_Enhancer.Enhance(Axis_Wave_L_pre_enhanced, Plot_enhancer))

Wave_L_enhanced = np.zeros(len(Axis_Wave_L_enhanced))
for i in range(len(Axis_Wave_L_enhanced)):
    Wave_L_enhanced[i] = Axis_Wave_L_enhanced[i,0]

Wave_L_enhanced
Wave_speed = np.sqrt(g * Wave_L_enhanced / 2 / np.pi * np.tanh(2*np.pi *depth / Wave_L_enhanced)) + flow_velocity * Wave_height[0]*abs(Wave_height[0]) * Wave_Height_Direction
Wave_period = Wave_L_enhanced / Wave_speed
Wave_freq = 2*np.pi/Wave_period
#%%


RAO_sway_loc = np.zeros((len_l,len_h))
RAO_heave_loc = np.zeros((len_l,len_h))
RAO_roll_loc = np.zeros((len_l,len_h))
RAO_sway_acc = np.zeros((len_l,len_h))
RAO_tot_acc = np.zeros((len_l,len_h))

#%%

for i in range (len_l):
    for j in range (len_h):
        RAO_sway_loc[i][j] = map_sway_loc[i][j] * (1. / (abs(Wave_height[j])*0.5))
        RAO_heave_loc[i][j] = map_heave_loc[i][j] * (1. / (abs(Wave_height[j])*0.5))
        RAO_roll_loc[i][j] = map_roll_loc[i][j] * (1. / (abs(Wave_height[j])*0.5*Wave_number[i*len_h]))
        RAO_sway_acc[i][j] = map_sway_acc[i][j] * (1. / (abs(Wave_height[j])*0.5))
        RAO_tot_acc[i][j] = map_tot_acc[i][j] #* (1. / (abs(Wave_height[j])*0.5))
        # print(RAO_roll_loc[i][j],map_roll_loc[i][j],abs(Wave_height[j]),Wave_number[(i*4)+j])


#%%

Plot_enhancer = int(14 * 36 / len_l)
RAO_sway_loc_enhanced = np.array(Heatmap_Enhancer.Enhance(RAO_sway_loc, Plot_enhancer))
RAO_heave_loc_enhanced = np.array(Heatmap_Enhancer.Enhance(RAO_heave_loc, Plot_enhancer))
RAO_roll_loc_enhanced = np.array(Heatmap_Enhancer.Enhance(RAO_roll_loc, Plot_enhancer))
RAO_sway_acc_enhanced = np.array(Heatmap_Enhancer.Enhance(RAO_sway_acc, Plot_enhancer))


# os.mkdir("Figures/Test_{} - finish/ROA".format(f"{Last_Test_Number:05d}"))
dir = "Figures/Test_{} - finish/RAO".format(f"{Last_Test_Number:05d}")
if os.path.exists(dir):
    shutil.rmtree(dir)
os.makedirs(dir)
plt.rcParams.update({'font.size': 14})



 #%%

Htest = 0
H_axis_range_enhanced = np.linspace(min(Wave_height), max(Wave_height), len(RAO_sway_loc_enhanced[0]))
for i in range(len(H_axis_range_enhanced)):
    if H_axis_range_enhanced[i]>=Htest:
        testnum = i
        break
print(H_axis_range_enhanced[testnum])

RAO_sway_average=np.zeros(len(RAO_sway_loc_enhanced))
RAO_heave_average=np.zeros(len(RAO_sway_loc_enhanced))
RAO_roll_average=np.zeros(len(RAO_sway_loc_enhanced))
RAO_sway_acc_average=np.zeros(len(RAO_sway_loc_enhanced))
for i in range(len(RAO_sway_loc_enhanced)):
    RAO_sway_average[i]=np.mean(RAO_sway_loc_enhanced[i])
    RAO_heave_average[i]=np.mean(RAO_heave_loc_enhanced[i])
    RAO_roll_average[i]=np.mean(RAO_roll_loc_enhanced[i])
    RAO_sway_acc_average[i]=np.mean(RAO_sway_acc_enhanced[i])
    
#freq_axis = np.linspace(max(Wave_freq),min(Wave_freq),len(RAO_sway_loc_enhanced))
linewidth=1
#%%

plt.figure(figsize=(9.5, 5.3))
for i in range(len(H_axis_range_enhanced)):
    if i==0:
        plt.plot(Wave_freq, RAO_sway_loc_enhanced[:,i],'k.', markersize=0.05,label='For all H')
    else:
        plt.plot(Wave_freq, RAO_sway_loc_enhanced[:,i],'k.', markersize=0.05)
plt.plot(Wave_freq, RAO_sway_loc_enhanced[:,0],color='c',label='For H_min = '+str(round(min(Wave_height),2))+' m',linewidth=linewidth)
plt.plot(Wave_freq, RAO_sway_loc_enhanced[:,len(H_axis_range_enhanced)-1],color='lime',label='For H_max = '+str(round(max(Wave_height),2))+' m',linewidth=linewidth)
if Htest > 0:
    plt.plot(Wave_freq, RAO_sway_loc_enhanced[:,testnum], color='r', label='For H = '+str(Htest)+' m',linewidth=linewidth)
plt.plot(Wave_freq, RAO_sway_average, color='darkorange', label='Average RAO',linewidth=linewidth)
plt.xlabel("Wave frequency in rad/s")
#plt.xlim(0.5,2.2) for current plots, use this range....
plt.ylabel("RAO (-)")
plt.title("Response Amplitude Operator for sway")
plt.legend()
plt.savefig("Figures/Test_{} - finish/RAO/RAO_Sway_{}-{}".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname), dpi=250)




#%%

plt.figure(figsize=(9.5, 5.3))
for i in range(len(H_axis_range_enhanced)):
    if i==0:
        plt.plot(Wave_freq, RAO_sway_loc_enhanced[:,i],'k.', markersize=0.05,label='For all H')
    else:
        plt.plot(Wave_freq, RAO_sway_loc_enhanced[:,i],'k.', markersize=0.05)
plt.plot(Wave_freq, RAO_sway_loc_enhanced[:,0],color='c',label='For H_min = '+str(round(min(Wave_height),2))+' m',linewidth=linewidth)
plt.plot(Wave_freq, RAO_sway_loc_enhanced[:,len(H_axis_range_enhanced)-1],color='lime',label='For H_max = '+str(round(max(Wave_height),2))+' m',linewidth=linewidth)
if Htest > 0:
    plt.plot(Wave_freq, RAO_sway_loc_enhanced[:,testnum], color='r', label='For H = '+str(Htest)+' m',linewidth=linewidth)
plt.plot(Wave_freq, RAO_sway_average, color='darkorange', label='Average RAO',linewidth=linewidth)
plt.xlabel("Wave frequency in rad/s")
plt.ylabel("RAO (-)")
plt.title("Response Amplitude Operator for sway")
plt.legend()
plt.savefig("Figures/Test_{} - finish/RAO/RAO_Sway_{}-{}".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname), dpi=250)

#%%


plt.figure(figsize=(9.5, 5.3))
for i in range(len(H_axis_range_enhanced)):
    if i==0:
        plt.plot(Wave_freq, RAO_heave_loc_enhanced[:,i],'k.', markersize=0.05,label='For all H') #To make one label
    else:
        plt.plot(Wave_freq, RAO_heave_loc_enhanced[:,i],'k.', markersize=0.05)
plt.plot(Wave_freq, RAO_heave_loc_enhanced[:,0],color='c',label='For H_min = '+str(round(min(Wave_height),2))+' m',linewidth=linewidth)
plt.plot(Wave_freq, RAO_heave_loc_enhanced[:,len(H_axis_range_enhanced)-1],color='lime',label='For H_max = '+str(round(max(Wave_height),2))+' m',linewidth=linewidth)
if Htest > 0:
    plt.plot(Wave_freq, RAO_heave_loc_enhanced[:,testnum], color='r', label='For H = '+str(Htest)+' m',linewidth=linewidth)
plt.plot(Wave_freq, RAO_heave_average, color='darkorange', label='Average RAO',linewidth=linewidth)
plt.xlabel("Wave frequency in rad/s")
plt.ylabel("RAO (-)")
plt.title("Response Amplitude Operator for heave")
plt.legend()
plt.savefig("Figures/Test_{} - finish/RAO/RAO_Heave_{}-{}".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname), dpi=250)

#%%

plt.figure(figsize=(9.5, 5.3))
for i in range(len(H_axis_range_enhanced)):
    if i==0:
        plt.plot(Wave_freq, RAO_roll_loc_enhanced[:,i],'k.', markersize=0.05,label='For all H')
    else:
        plt.plot(Wave_freq, RAO_roll_loc_enhanced[:,i],'k.', markersize=0.05)
plt.plot(Wave_freq, RAO_roll_loc_enhanced[:,0],color='c',label='For H_min = '+str(round(min(Wave_height),2))+' m',linewidth=linewidth)
plt.plot(Wave_freq, RAO_roll_loc_enhanced[:,len(H_axis_range_enhanced)-1],color='lime',label='For H_max = '+str(round(max(Wave_height),2))+' m',linewidth=linewidth)
if Htest > 0:
    plt.plot(Wave_freq, RAO_roll_loc_enhanced[:,testnum], color='r', label='For H = '+str(Htest)+' m',linewidth=linewidth)
plt.plot(Wave_freq, RAO_roll_average, color='darkorange', label='Average RAO',linewidth=linewidth)
plt.xlabel("Wave frequency in rad/s")
plt.ylabel("RAO (-)")
plt.title("Response Amplitude Operator for roll")
plt.legend()
plt.savefig("Figures/Test_{} - finish/RAO/RAO_Roll_{}-{}".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname), dpi=250)


#%%

plt.figure(figsize=(9.5, 5.3))
for i in range(len(H_axis_range_enhanced)):
    if i==0:
        plt.plot(Wave_freq, RAO_sway_acc_enhanced[:,i],'k.', markersize=0.05,label='For all H')
    else:
        plt.plot(Wave_freq, RAO_sway_acc_enhanced[:,i],'k.', markersize=0.05)
plt.plot(Wave_freq, RAO_sway_acc_enhanced[:,0],color='c',label='For H_min = '+str(round(min(Wave_height),2))+' m',linewidth=linewidth)
plt.plot(Wave_freq, RAO_sway_acc_enhanced[:,len(H_axis_range_enhanced)-1],color='lime',label='For H_max = '+str(round(max(Wave_height),2))+' m',linewidth=linewidth)
if Htest > 0:
    plt.plot(Wave_freq, RAO_sway_acc_enhanced[:,testnum], color='r', label='For H = '+str(Htest)+' m',linewidth=linewidth)
plt.plot(Wave_freq, RAO_sway_acc_average, color='darkorange', label='Average RAO',linewidth=linewidth)
plt.xlabel("Wave frequency in rad/s")
plt.ylabel(" (m/s)")
plt.title("Dimensionless acceleration for sway")
plt.legend()
plt.savefig("Figures/Test_{} - finish/RAO/Acc_sway_{}-{}".format(f"{Last_Test_Number:05d}",f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}", loopname), dpi=250)
